/*
 * ̕\eXg
 */
#include <farl.h>

#define	NULL			0
#define	TRIANGLE_NUMBER	12		// |S

// _̍W
float	cube_vert[TRIANGLE_NUMBER*3][3]={
	{ -0.3,  0.3,  0.3 }, { -0.3, -0.3,  0.3 }, {  0.3,  0.3,  0.3 },
	{  0.3,  0.3,  0.3 }, { -0.3, -0.3,  0.3 }, {  0.3, -0.3,  0.3 },
	{  0.3,  0.3,  0.3 }, {  0.3, -0.3,  0.3 }, {  0.3,  0.3, -0.3 },
	{  0.3,  0.3, -0.3 }, {  0.3, -0.3,  0.3 }, {  0.3, -0.3, -0.3 },
	{  0.3,  0.3, -0.3 }, {  0.3, -0.3, -0.3 }, { -0.3,  0.3, -0.3 },
	{ -0.3,  0.3, -0.3 }, {  0.3, -0.3, -0.3 }, { -0.3, -0.3, -0.3 },
	{ -0.3,  0.3, -0.3 }, { -0.3, -0.3, -0.3 }, { -0.3,  0.3,  0.3 },
	{ -0.3,  0.3,  0.3 }, { -0.3, -0.3, -0.3 }, { -0.3, -0.3,  0.3 },
	{ -0.3,  0.3, -0.3 }, { -0.3,  0.3,  0.3 }, {  0.3,  0.3, -0.3 },
	{  0.3,  0.3, -0.3 }, { -0.3,  0.3,  0.3 }, {  0.3,  0.3,  0.3 },
	{ -0.3, -0.3,  0.3 }, { -0.3, -0.3, -0.3 }, {  0.3, -0.3,  0.3 },
	{  0.3, -0.3,  0.3 }, { -0.3, -0.3, -0.3 }, {  0.3, -0.3, -0.3 },
	};

// @
float	cube_fnor[TRIANGLE_NUMBER][3]={
	{  0.0,  0.0,  1.0 }, {  0.0,  0.0,  1.0 },
	{  1.0,  0.0,  0.0 }, {  1.0,  0.0,  0.0 },
	{  0.0,  0.0, -1.0 }, {  0.0,  0.0, -1.0 },
	{ -1.0,  0.0,  0.0 }, { -1.0,  0.0,  0.0 },
	{  0.0,  1.0,  0.0 }, {  0.0,  1.0,  0.0 },
	{  0.0, -1.0,  0.0 }, {  0.0, -1.0,  0.0 },
	};

// J[
unsigned short	cube_fcol[TRIANGLE_NUMBER]={
	0x0801, 0x0801,
	0x0802, 0x0802,
	0x0803, 0x0803,
	0x0804, 0x0804,
	0x0805, 0x0805,
	0x0806, 0x0806,
	};

// Cǧ
float dir[3] = { 0.433012, 0.75, 0.5 };

/*
 * C
 */
void
main()
	{
	short	vert[64][3];
	short	fnor[64][3];
	short	*outv = (short *)FARL_RESULT_REG0;
	unsigned short	cube_buf[1024];
	int		cube_cnt;
	int		i, cnt;

	// 
	FX73init();
	FX73_cmap_i4c5();
	FarlInit();
	FarlSetMemReg( FARL_INTERRUPT_MASK_REG, FARL_INTERRUPT_AFL );
	FarlSetTEControlReg( FARL_TE_ICM | FARL_TE_LTEN );
	FarlSetPEICMaskReg( FARL_ICMASK_I4C5 );
	FarlSetLightCoef( FarlFix1015( 0.3 ), FarlFix1015( 0.9 ), 0,
						FarlFix1015( 1.0 ), 0 );
	FarlSetLight( FARL_SET_LIGHT1, FarlFix1015( dir[0] ),
			FarlFix1015( dir[1] ), FarlFix1015( dir[2] ) );
	FarlSetPEClearColorReg( 0x807 );

	// TriangleList
	for ( i = 0; i < TRIANGLE_NUMBER; i++ )
		{
		vert[i*3+0][0]	= FarlFix1015( cube_vert[i*3+0][0] );
		vert[i*3+0][1]	= FarlFix1015( cube_vert[i*3+0][1] );
		vert[i*3+0][2]	= FarlFix1015( cube_vert[i*3+0][2] );

		vert[i*3+1][0]	= FarlFix1015( cube_vert[i*3+1][0] );
		vert[i*3+1][1]	= FarlFix1015( cube_vert[i*3+1][1] );
		vert[i*3+1][2]	= FarlFix1015( cube_vert[i*3+1][2] );

		vert[i*3+2][0]	= FarlFix1015( cube_vert[i*3+2][0] );
		vert[i*3+2][1]	= FarlFix1015( cube_vert[i*3+2][1] );
		vert[i*3+2][2]	= FarlFix1015( cube_vert[i*3+2][2] );

		fnor[i][0]	= FarlFix1015( cube_fnor[i][0] );
		fnor[i][1]	= FarlFix1015( cube_fnor[i][1] );
		fnor[i][2]	= FarlFix1015( cube_fnor[i][2] );
		}
	cube_cnt = FarlDumpTriangleList( FARL_GTYPE_FCFN, TRIANGLE_NUMBER,
			(unsigned short *)vert, (unsigned short *)fnor,
						cube_fcol, NULL, cube_buf );

	cnt = 0;

	// C[v
	while(1)
		{
		FarlSetUnitMatrix187();
		FarlRotateX4x4M187( ( cnt / 2 ) % 3600 );
		FarlCopyDstToSrc();
		FarlTranslate4x4M187( 0x0040, 0x0000, 0x0000 );
		FarlCopyDstToSrc();
		FarlRotateY4x4M187( cnt % 3600 );
		FarlCopyDstToSrc();
		FarlTranslate4x4M187( 0x0000, 0x0000, 0xff80 );
		FarlCopyDstToSrc();
		FarlPerseZ4x4M187( 0xff80 );
		FarlCopyDstToObj();

		FarlSetUnitMatrix1015();
		FarlRotateX3x3M1015( ( cnt / 2 ) % 3600 );
		FarlCopyDstToSrc();
		FarlRotateY3x3M1015( cnt % 3600 );
		FarlCopyDstToNrm();

		FarlWriteFifoHA(cube_buf, cube_cnt);
		FarlSwapWindow();
		cnt += 10;
		}
	}
