/*
 * DEV70.H Version 1.01 (C)1995,1996 HUDSON SOFT
 * HuC6270ph^n|[g` bRpCpwb_[t@C(DEV70.H)
 */

#ifndef _DEV70_H_
#define _DEV70_H_

/* define I/O port */

#define IO_70A_AR 0x0400	/* 7UP-A WX^AhXݒ */
#define IO_70A_SR 0x0400	/* 7UP-A Xe[^X */
#define IO_70A_DR 0x0404	/* 7UP-A f[^ */
#define IO_70B_AR 0x0500	/* 7UP-B WX^AhXݒ */
#define IO_70B_SR 0x0500	/* 7UP-B Xe[^X */
#define IO_70B_DR 0x0504	/* 7UP-B f[^ */

/* define bit string port */

#define BS_70A_RR 0xa4000000	/* 7UP-ArbgXgO [h|[g */
#define BS_70A_WR 0xb4000000	/* 7UP-ArbgXgO Cg|[g */
#define BS_70B_RR 0xa8000000	/* 7UP-BrbgXgO [h|[g */
#define BS_70B_WR 0xb8000000	/* 7UP-BrbgXgO Cg|[g */

/* define register name */

#define _70_MAWR 0x00		/* AhX Cg */
#define _70_MARR 0x01		/* AhX [h */
#define _70_VWR	 0x02		/* uq`lf[^ Cg */
#define _70_VRR	 0x02		/* uq`lf[^ [h */
#define _70_CR	 0x05		/* Rg[ */
#define _70_RCR	 0x06		/* X^o */
#define _70_BXR	 0x07		/* afwXN[ */
#define _70_BYR	 0x08		/* afxXN[ */
#define _70_MWR	 0x09		/*  */
#define _70_HSR	 0x0a		/*  */
#define _70_HDR	 0x0b		/* \ */
#define _70_VPR	 0x0c		/*  */
#define _70_VDW	 0x0d		/* \ */
#define _70_VCR	 0x0e		/* \Ghʒu */
#define _70_DCR	 0x0f		/* cl`Rg[ */
#define _70_SOUR 0x10		/* cl`\[XAhX */
#define _70_DESR 0x11		/* cl`fXeBl[V */
#define _70_LENR 0x12		/* cl`ubN */
#define _70_DVSSR 0x13		/* cl` uq`l|r`sa\[X */

#endif /* _DEV70_H_ */

