/*
 *         Copyright (c) KUBOTA Corporation and HUDSON SOFT,
 *                  1994, 1995 All Rights Reserved
 *
 *  This software comprises unpublished confidential information of
 *  KUBOTA Corp. and HUDSON SOFT. It may not be used, copied or made 
 *  available to anyone, except in accordance with the license under
 *  which it is furnished.
 */
static char SccsId[] = "@(#)acrotysc.c	1.5	9/19/95";
#include <farl.h>
#include <agl.h>

/*
 * ^ꂽsin, cosŃJx]
 */
void
AGLRotateCameraYSC(fix1015 SinYY, fix1015 CosYY)
{
     fix187		siny187, cosy187;

     if (SinYY == 0 && CosYY == 0x7fff) return;
     siny187 = CONV1015TO187(SinYY);
     cosy187 = CONV1015TO187(CosYY);

     /*
      * J̓}gNX̋t]ŎĂ邽߁A
      * sin(-angle), cos(-angle)߂KvB
      * 	sin(-angle) = -sin(angle)
      * 	cos(-angle) =  cos(angle)
      */

     /* camMatrix187] */
     if (__AGLCamera.camChanged == -2) {
	  FarlGetRotateYSC4x4M187(~siny187+1, cosy187,
	  		(unsigned short*)__AGLCamera.camMatrix187);
     } else {
	  FarlSetSrcMatrix((unsigned short*)__AGLCamera.camMatrix187);
	 FarlRotateYSC4x4M187(~siny187+1, cosy187);
	 FarlCopyDstToMem4x4((unsigned short*)__AGLCamera.camMatrix187);
     }

     /* camMatrix1015] */
     if (__AGLCamera.camChanged < 0) {
	  FarlGetRotateYSC3x3M1015(~SinYY+1, CosYY,
	  		(unsigned short*)__AGLCamera.camMatrix1015);
     } else {
	  FarlSetSrcMatrix3x3((unsigned short*)__AGLCamera.camMatrix1015);
	 FarlRotateYSC3x3M1015(~SinYY+1, CosYY);
	 FarlCopyDstToMem3x3((unsigned short*)__AGLCamera.camMatrix1015);
     }
     __AGLCamera.camChanged = 1;
}
