/*
 *         Copyright (c) KUBOTA Corporation and HUDSON SOFT,
 *                  1994, 1995 All Rights Reserved
 *
 *  This software comprises unpublished confidential information of
 *  KUBOTA Corp. and HUDSON SOFT. It may not be used, copied or made 
 *  available to anyone, except in accordance with the license under
 *  which it is furnished.
 */
static char SccsId[] = "@(#)amrdobj.c	1.4 9/19/95";
#include <farl.h>
#include <agl.h>

void
AGLReadObjMatrix()
{
     register int	i;
     static short	oadr[] = {
	  FARL_OBJECT_MATRIX00_ADR, FARL_OBJECT_MATRIX01_ADR,
	  FARL_OBJECT_MATRIX02_ADR, FARL_OBJECT_MATRIX03_ADR,
	  FARL_OBJECT_MATRIX10_ADR, FARL_OBJECT_MATRIX11_ADR,
	  FARL_OBJECT_MATRIX12_ADR, FARL_OBJECT_MATRIX13_ADR,
	  FARL_OBJECT_MATRIX20_ADR, FARL_OBJECT_MATRIX21_ADR,
	  FARL_OBJECT_MATRIX22_ADR, FARL_OBJECT_MATRIX23_ADR,
	  FARL_OBJECT_MATRIX30_ADR, FARL_OBJECT_MATRIX31_ADR,
	  FARL_OBJECT_MATRIX32_ADR, FARL_OBJECT_MATRIX33_ADR};
	  
     printf("ObjectMatrix=\n");
     for (i = 0; i < 16; i++)
	  printf("%x%c", FarlGetTEReg(oadr[i], FARL_BLK), i%4==3? '\n': ',');
}
