static char SccsId[] = "@(#)aslmkspz.c	1.4   10/6/95";
/*
 *         Copyright (c) KUBOTA Corporation and HUDSON SOFT,
 *                  1994, 1995 All Rights Reserved
 *
 *  This software comprises unpublished confidential information of
 *  KUBOTA Corp. and HUDSON SOFT. It may not be used, copied or made
 *  available to anyone, except in accordance with the license under
 *  which it is furnished.
 */

#define	_ASLLIB_
#define	_ASLMKSPZ_C_

#include <farl.h>
#include <asl.h>

/*----------------------------------------------------------------------------*/
void
ASLMakeSpriteWithZ( ASLSource *src,
	short dstX,		short dstY,
	unsigned short zval,	Bool zcmp,		Bool zwen,
							ASLSct *sct )
{
	sct->head	 = ASL_VAL_FNC_NORM_Z
					| ( src->bank & ASL_MSK_BANKSEL );
	sct->cntl	 = ( zcmp ? ASL_VAL_ZCMP : 0 )
					| ( zwen ? ASL_VAL_ZWEN : 0 );
	sct->dsp_x_pos	 = ( dstX - src->x_hot ) & ASL_MSK_DSP_X_POS;
	sct->dsp_y_pos	 = ( dstY - src->y_hot ) & ASL_MSK_DSP_Y_POS;
	sct->dsp_xy_size =
		  ( ( ( src->x_size - 1 ) << ASL_SFT_DSP_X_SIZE )
							& ASL_MSK_DSP_X_SIZE )
		| ( ( ( src->y_size - 1 ) << ASL_SFT_DSP_Y_SIZE )
							& ASL_MSK_DSP_Y_SIZE );
	sct->src_xy_pos	 =
		  ( (  src->x_pos << ASL_SFT_SRC_X_POS ) & ASL_MSK_SRC_X_POS )
		| ( (  src->y_pos << ASL_SFT_SRC_Y_POS ) & ASL_MSK_SRC_Y_POS );
	sct->z		 = zval;
}

/*----------------------------------------------------------------------------*/
