/*
 * Q_񂾒̊px߂
 */
#include <common.h>
#include "spec.h"
#include "math.h"

/*
========================================
  Q_񂾒̊px߂
  Ffloat stX, float stY, float eX, float eY
        stX : n_̂wW
        stY : n_̂xW
        eX  : I_̂wW
        eY  : I_̂xW
  ߂lFdirect_t px
========================================
 */
direct_t
PointMakeDir(float stX, float stY, float eX, float eY)
{
  float difX,difY;
  float tmp;
  float ll;
  int   syougen;

  tmp = stX;
  stX = -stY;
  stY = tmp;

  tmp = eX;
  eX = -eY;
  eY = tmp;

  /* */
  difX = abs(stX - eX);
  difY = abs(stY - eY);
  /* Q_Ԃ̋ */
  ll = sqrt(difX * difX + difY * difY);
  /* sin theta = y / l Asin theta ߂ */
  tmp = difY / ll;
  /* n_𐳋K */
  difX = eX - stX;
  difY = eY - stY;
  /* I_̏ی𔻒肷 */
    if(difX > 0 && difY > 0)
      syougen = 1;
  else
    if(difX < 0 && difY > 0)
      syougen = 2;
  else
    if(difX < 0 && difY < 0)
      syougen = 3;
  else
    if(difX > 0 && difY < 0)
      syougen = 4;
  else
    if(difX == 0 && difY > 0)
      syougen = 2;
  else
    if(difX == 0 && difY < 0)
      syougen = 4;
  else
    if(difX > 0 && difY == 0)
      syougen = 1;
  else
    if(difX < 0 && difY == 0)
      syougen = 3;
  return asin(abs(tmp),syougen);
}

/*
----------------------------------------
  A[NTC߂
  PointMakeDir p ȎgȂ̂
  ʂ̃\[Xɂ͎gȂłB
  Ffloat tmp, int syougen
        tmp A[NTC߂鎞̈
        syougen ی
  ߂lFdirect_t pxiߎlj
----------------------------------------
 */
direct_t
asin(float tmp,int syougen)
{
  float  answer;
  int   i;

  switch(syougen){
    case 1:
      for(i = 0; i < 900; i++){
        answer = sintbl[i];
        if(tmp < answer){
          break;
        }
      }
      break;
    case 2:
      for(i = 900; i < 1800; i++){
        answer = sintbl[i];
        if(tmp > answer){
          break;
        }
      }
      break;
    case 3:
      for(i = 1800; i < 2700; i++){
        answer = sintbl[i];
        if(tmp < abs(answer)){
          break;
        }
      }
      break;
    case 4:
      for(i = 2700; i < 3600; i++){
        answer = sintbl[i];
        if(tmp > abs(answer)){
          break;
        }
      }
      break;
    default:
      i = 0;
      break;
  }
  return i;
}
