/*
 * initdev.c
 * foCX
 */
#include <system.h>
#include <v93.h>
#include <libm.h>
#include <palette.h>
#include <intlib.h>
#include <agl.h>
#include <farl.h>
#include "vardecl.h"
#include "funcdecl.h"

/* 
========================================
  efoCX
========================================
*/
void
UserInitDev()
{
  struct NT_PLO plo;

  /* ӏ */
  DevInit();
  init_70();
  /* J[pbg̓] */
  SetCmapI5c4();

  /* XݒDi͕ύXȂł */
  AGLInit();
  ASLSetSpriteWindow(0, 0, 255, 255);
  FarlSetMemReg(FARL_MISC_STATUS_REG, 
    FARL_MISC_STATUS_SEL | FARL_MISC_STATUS_NTRM);
  
  FarlSetWindowClipReg(0, 0, 255, 255);
  FarlSetWindowScaleReg(128 * SCALE_PERS, 128, -128 * SCALE_PERS, 128);
  FarlSetPEICMaskReg(FARL_ICMASK_I5C4);
  FarlSetTEControlReg(FARL_TE_LTEN | FARL_TE_ICM | FARL_TE_SPEN 
                      | FARL_TE_BCE | FARL_TE_RJM);
  FarlValidateSwap();
  RasterInit();			/* X^荞݋쓮[` */
  PSGInit();			/* PSG [` & X^荞݃[`ɓo^ */
  
  /* pbh */
  init_get_pad();
  set_get_pad_mode(0, KC_IN, 1);
  set_get_pad_mode(1, KC_IN, 1);
  
  /* pbh̓[`荞݋쓮[`ɓo^ */
  IrqSet(int_pad, XINT_KP);
  
  /* ʂ̏ */
  KINGCls(KING_BG0);
  KINGCls(KING_BG1);
  set_nt_mode(line262 | inter_sync); /* Hu6261 ʃ[hݒ */
  if (KINGScreen(0) < 0)
    return;
  
  KINGCylinder(KING_BG0, 1);        /* ݒ */
  KINGChangeSize0(0x9898);        /* ʃTCYݒ 512x256 */
  RasterSet(RASTER_SCROLL1,&BackScroll1);
  RasterSet(RASTER_SCROLL2,&BackScroll2);
  dispon(bg | spr);
  IrqOn(XINT_KP);                /* KPort 荞݂L */
  IrqOn(XINT_72);                /* HuC6272 荞݂L */
  irq_enable();                        /* 荞݂ */
}
