/*
 * initvar.c
 */
#include "spec.h"
#include "vardecl.h"
#include "funcdecl.h"
#include "adp.h"
#include "adpcm.h"

/****************************************
  variable decralations
****************************************/
struct PCMINFO pInfo[MAX_PCM_NUMBER];

zero struct KEYDATA Pad00, Pad10; /* pbhf[^ۑp */
zero int playmode;		/* 1P vs COM / 1P vs 2P̂ǂI */
     int oldplaymode = VSCOM;   /* ȑOɑIꂽQ[[h */
zero int round;			/* ݂̃Eh */
zero int whichFall;		/* ǂ(PLAYER1/PLAYER2) */
/* RAj󂳂ꂽǂ FALSE..܂ TRUE..jς */
zero int destroy[CORE_MAX]; 
zero int destroyBoss;		/* {Xj󂳂ꂽǂ */
int backpos1,backpos2;	/* wiXN[̈ʒu */

/* t@Cǂݍ݂̂߂̈ꎞobt@ */
unsigned short filereadbuf[262144 / 2];

/* tHgobt@ */
unsigned short fontbuf[131072 / 2];

/* @̈ʒu */
float Locate[PLAYER_MAX][3];

/* nʃIuWFNg */
object Ground[GROUND_MAX];
Material groundMaterial;
zero fix187 GroundScale;

/* nʈʒul */
fix187 OrigGroundLoc[GROUND_MAX][3] = {
  {-0xe0, 0xe0, 0}, {-0xa0, 0xe0, 0}, {-0x60, 0xe0, 0}, {-0x20, 0xe0, 0},
  {0x20, 0xe0, 0},  {0x60, 0xe0, 0},  {0xa0, 0xe0, 0},  {0xe0, 0xe0, 0},

  {-0xe0, 0xa0, 0}, {-0xa0, 0xa0, 0}, {-0x60, 0xa0, 0}, {-0x20, 0xa0, 0},
  {0x20, 0xa0, 0},  {0x60, 0xa0, 0},  {0xa0, 0xa0, 0},  {0xe0, 0xa0, 0},

  {-0xe0, 0x60, 0}, {-0xa0, 0x60, 0}, {-0x60, 0x60, 0}, {-0x20, 0x60, 0},
  {0x20, 0x60, 0},  {0x60, 0x60, 0},  {0xa0, 0x60, 0},  {0xe0, 0x60, 0},

  {-0xe0, 0x20, 0}, {-0xa0, 0x20, 0}, {-0x60, 0x20, 0}, {-0x20, 0x20, 0},
  {0x20, 0x20, 0},  {0x60, 0x20, 0},  {0xa0, 0x20, 0},  {0xe0, 0x20, 0},

  {-0xe0, -0x20, 0},{-0xa0, -0x20, 0},{-0x60, -0x20, 0},{-0x20, -0x20, 0},
  {0x20, -0x20, 0}, {0x60, -0x20, 0}, {0xa0, -0x20, 0}, {0xe0, -0x20, 0},

  {-0xe0, -0x60, 0},{-0xa0, -0x60, 0},{-0x60, -0x60, 0},{-0x20, -0x60, 0},
  {0x20, -0x60, 0}, {0x60, -0x60, 0}, {0xa0, -0x60, 0}, {0xe0, -0x60, 0},

  {-0xe0, -0xa0, 0},{-0xa0, -0xa0, 0},{-0x60, -0xa0, 0},{-0x20, -0xa0, 0},
  {0x20, -0xa0, 0}, {0x60, -0xa0, 0}, {0xa0, -0xa0, 0}, {0xe0, -0xa0, 0},

  {-0xe0, -0xe0, 0},{-0xa0, -0xe0, 0},{-0x60, -0xe0, 0},{-0x20, -0xe0, 0},
  {0x20, -0xe0, 0}, {0x60, -0xe0, 0}, {0xa0, -0xe0, 0}, {0xe0, -0xe0, 0},
};
/* nʈʒu */
fix187 GroundLoc[GROUND_MAX][3];
/* nʒ[̍W */
zero float GroundEdgeLoc;

machine Machine[PLAYER_MAX];
Material aMaterial[PLAYER_MAX];

/* 1P/2P @̑Ip */
zero int machPlayer1;
zero int machPlayer2;

machtype MachineType[MACHINE_MAX] = {
  {
    NULL,			/* obj */
    0,				/* width */
    0,				/* height */
    {0},			/* AccTable */
    {0},			/* EngBrakeTable */
    {0},			/* BrakeTable */
    10,				/* Handling */
    1,				/* Bounce */
  }, /* MT_DWARF */
  {NULL, 0, 0, {0}, {0}, {0}, 10, 1}, /* MT_ELF */
  {NULL, 0, 0, {0}, {0}, {0}, 10, 1}, /* MT_BOSS */
  {NULL, 0, 0, {0}, {0}, {0}, 10, 1}, /* MT_HUMAN1 */
  {NULL, 0, 0, {0}, {0}, {0}, 10, 1}, /* MT_HUMAN2 */
};

/* @̑Ip[^C[W */
/* ۂɍ쐬e[ũC[Wɍ悤Ȑ܂ */
/* Oɂ͔płPOSpłT܂ł܂B */
machimage MachineImage[MACHINE_MAX] = {
/* {"Name",Acc,Brk,Hnd,Wgt} */
  {"GAMMAWEEN", 2, 2, 2, 3},
  {"JUDASFIGHT", 5, 4, 3, 1},
  {"GIGADETH", 4, 1, 2, 5},
  {"DIZZY BOSS", 1, 1, 1, 1},
  {"PLAYER", 1, 1, 1, 1},
  {"PLAYER", 1, 1, 1, 1},
};

/* @̃p[^ݒ֐ */
pfunc_t parfunc[MACHINE_MAX] = {
  NormalUnit,			/* 1P vs COM ̎@ */
  LightUnit,			/* round 1 */
  HeavyUnit,			/* round 2 */
  BossUnit,			/* round 3 */
  NormalUnit,			/* 1P vs 2P  1P@ */
  NormalUnit,			/* 1P vs 2P  2P@ */
};

/* @̑֐ */
mfunc_t manfunc[MACHINE_MAX] = {
  HumanMain,			/* MT_HUMAN */
  DwarfMain,			/* MT_DWARF */
  ElfMain,			/* MT_ELF */
  BossMain,			/* MT_BOSS */
  Human1Main,			/* 1P */
  Human2Main,			/* 2P */
};

/* eԂ̐F  I5C4 color */
/* ʂWrbg͖邳 ʂWrbg̓J[R[h */
/* J[R[h͂ꂼȉ̂悤ɂȂĂ܂  */
/* 0 : 
 * 1 : 
 * 2 : F
 * 3 : sNۂF
 * 4 : F
 * 5 : 
 * 6 : 
 * 7 : 
 * 8 : IWۂF
 * 9 : IWۂF̂Q
 * a : 
 * b : 
 * c : 
 * d : 
 * e : ܂ԂF
 * f : FۂF
 */
int CarColor[MACHINE_MAX] = {
  0x1405,         /* MT_HUMAN */
  0x0801,         /* MT_DWARF */
  0x0801,         /* MT_ELF */
  0x0801,         /* MT_BOSS */
  0x1405,         /* 1P */
  0x1405,         /* 2P */
};

/* wif[^t@C */
char *backname[] = {
  "dat/back/bg1.bin",
  "dat/back/bg2.bin",
  "dat/back/bg3.bin",
};

/* nʃf[^t@C */
char *grname[] = {
  "dat/gr/stage-b.aid",
  "dat/gr/stage-e.aid",
  "dat/gr/stage-g.aid",
};

/****************************************
  IuWFNgf[^zu
****************************************/
unsigned short grdat1[] = {	/* nʃIuWFNgf[^ 1 */
#include "txtflo1.h"
};
unsigned short grdat2[] = {	/* nʃIuWFNgf[^ 2 */
#include "txtflo2.h"
};
unsigned short grdat3[] = {	/* nʃIuWFNgf[^ 3 */
#include "txtflo3.h"
};
unsigned short bosscore[] = {
#include "cube.h"
};
unsigned long bosscoreLength = sizeof(bosscore) / sizeof(int);
float bosscoreLocate[4][3]; /* {XRAʒu */

/* nʃf[^e[u */
unsigned short *grdatTable[] = {
  grdat1,
  grdat2,
  grdat3,
};
/* nʃf[^̒ */
unsigned long grdatLength[3] = {
  sizeof(grdat1) / sizeof(int),
  sizeof(grdat2) / sizeof(int),
  sizeof(grdat3) / sizeof(int),
};
/* eԂ̍őlEŏl 蔻Ɏgp */
unsigned short *minmaxTable[] = {
  obj05_minmax,
  obj03_minmax,
  obj04_minmax,
  boss_minmax,
};
