/*
 *  orfȖAʉ`B
 */

#include <vpsg.h>
#include "adpcm.h"

#ifndef    __PSGDEFINE__
#define    __PSGDEFINE__

/*
 * PSG music + effect data ̐擪AhX
 */
#define PSG_STARTADDRESS  0x30000
#define PSG_PRIADDRESS    0x3001c

/*
 * ltrhb
 */

#define MU_TITLE        0x00    /* ^Cg */
#define MU_STAGE1       0x01    /* Xe[WP */
#define MU_STAGE2       0x02    /* Xe[WQ */
#define MU_STAGE3       0x03    /* anrr */
#define MU_ENDING       0x04    /* GfBO */
#define MU_GAMESTART    0x05    /* Xe[WJn */
#define MU_GAMEOVER     0x06    /* Q[I[o[ */
#define MU_YOUWIN       0x07    /*  */
#define MU_SELECT       0x08    /* @I */

/*
 * GtFNg
 */

#define SE_IDLE         0x03    /* AChO */
#define SE_ENGINE       0x05    /* GW */
#define SE_ENGINE_STOP  0x09    /* GWIt */
#define SE_FALL         0x00    /* čs */

/*
 * ^CgEIvVݒ
 */

#define SE_CURMOVE      0x01    /* J[\ړ */
#define SE_CURSEL       0x02    /* I */

extern unsigned char cStageMusic[];

/*
 * orftE~}N
 * GtFNgp`lƂĂbgUgĂ邱Ƃ
 */

#define PSGTitle()        { psg_musicno(MU_TITLE); }
#define PSGGameOver()     { psg_musicno(MU_GAMEOVER); }
#define PSGStage(stage)   { psg_musicno(cStageMusic[stage]); }
#define PSGPlay(number)   { psg_musicno(number); }
#define PSGFadeOut()      { psg_musicfdout(4); }
#define PSGSeOn(number)   { psg_effectstop(); while(psg_effectch()==CH6); psg_effectno(number); }
#define PSGSeOff()        { psg_effectstop(); }
#define PSGClear()        { psg_allstop(); }

#endif /* __PSGDEFINE__ */
