/*
 * ȈՂorfhCo[
 */
#pragma defseg(-C,psgdrv)
#pragma seg(psgdrv)
#pragma seg(dseg)
#pragma seg(bseg)

#include <system.h>
#include <v93.h>
#include <dev30.h>
#include <libm.h>
#include <intlib.h>
#include <common.h>
#include <soundbox.h>
#include <music.h>
#include <psgdrv.h>

#define	T120	(3728)		/* _~[ */
#define TRACK	(6)		/* UgbN */
#define TONE	(128)		/* F */

#ifndef DEBUG
#define LOCAL   static
#else
#define LOCAL
#endif

extern unsigned char nNoteNumber[]; /* m[gio[e[u */
extern unsigned char *cToneBuffer[TONE]; /* wave data */

LOCAL unsigned short  sStepCounter[TRACK]; /* XebvJE^ */
LOCAL unsigned char   *cTrackBuffer[TRACK]; /* gbNobt@|C^ */
LOCAL unsigned char	*cTrackTop[TRACK]; /* gbNobt@擪AhX */
LOCAL unsigned short	sChVolume[TRACK];  /* `l{[ */
LOCAL char            cTrackInfo[TRACK];  /* track info 0:off 1:on */

/*
 * ȈՂorfhCo[荞݃[`
 */
void interrupt
drvplay(void)
{
  regsave r1-r31;		/* WX^ޔ */
  unsigned short ch;		/* WX^ԍiHuC6230j */
  unsigned short value;		/* ޒl */
  unsigned char	 cFrqLow;	/* ge */
  unsigned char	 cFrqHigh;	/* g */
  int	track;			/* track counter */
  /*  */
  for(track = 0; track < TRACK; track++){
    if(sStepCounter[track] != 0){
      sStepCounter[track]--;	/* JE^cĂȂ猸炵Ă܂ */
    } else {			/* JE^cĂȂΓJn */
      __OUTPORTB(IO_SB_CHSEL,track);	/* `lselect */
      while(sStepCounter[track] == 0) {	/* JE^܂ŏ */
	switch(*cTrackBuffer[track]){	/* f[^ɂĕ */
	case    COUNT_WAIT:	/* x */
	  cTrackBuffer[track]++;
	  value = (short)*cTrackBuffer[track];
	  cTrackBuffer[track]++;
	  value |= (short)*cTrackBuffer[track] << 8;
	  sStepCounter[track] = value;	/* ǂݍ񂾒lJE^ɂ܂ */
	  break;
	case    NOTE_WRITE:	/* L[I */
	  cTrackBuffer[track]++; 	/* e[ugE */
	  value = (short)*cTrackBuffer[track];
	  value <<= 1;
	  cFrqHigh = nNoteNumber[value];
	  cFrqLow = nNoteNumber[value + 1];
	  __OUTPORTB(IO_SB_FRQL, cFrqLow); /* HuC6230ɏ */
	  __OUTPORTB(IO_SB_FRQH, cFrqHigh);
	  value = 0x80 | sChVolume[track]; /* Ԃɂ */
	  __OUTPORTB(IO_SB_CHVOL, value);
	  break;
	case    NOTE_OFF:		/* L[It */
	  __OUTPORTB(IO_SB_CHVOL, 0x00); /* Ԃɂ */
	  break;
	case    CHLR_VOL:		/* `lkq{[ */
	  cTrackBuffer[track]++;
	  value = (short)*cTrackBuffer[track];
	  __OUTPORTB(IO_SB_PAN, value); /* HuC6230ɏ */
	  break;
	case    CHVOL:		/* `l{[ */
	  cTrackBuffer[track]++;
	  value = (short)*cTrackBuffer[track];
	  sChVolume[track] = value & 0x1f; /* L[Ipɕۑ */
	  break;
	case    MAINVOL:	/* C{[ */
	  cTrackBuffer[track]++;
	  value = (short)*cTrackBuffer[track];
	  __OUTPORTB(IO_SB_MVOL, value); /* HuC6230ɏ */
	  break;
	case    TEMPO:		/* e|i^C}[JE^j */
	  cTrackBuffer[track]++;		/* timer L */
	  value = (short)*cTrackBuffer[track];
	  cTrackBuffer[track]++;		/* timer H */
	  value |= (short)*cTrackBuffer[track] << 8;
	  _put_timer_tmr( value ); /* G/Ã_EJE^WX^ɏ */
	  break;
	case    GO_TOP:		/* 擪ɖ߂ */
	  cTrackBuffer[track] = cTrackTop[track]; /* |C^擪ɖ߂ */
	  break;
	case    END_OF_MUS:	/* ȏI[ */
	  cTrackInfo[track] = TRACK_OFF; /* Iʒm */
	  cTrackBuffer[track] --;        /* JE^~ */
	  sStepCounter[track] = 2;       /* [v𔲂 */
	  break;
	case	PROG_CHG:	/* FύX */
	  cTrackBuffer[track]++;
	  waveset(track, cToneBuffer[*cTrackBuffer[track]]);
	  break;
	default:		/* ǂłȂꍇ */
	  if((*cTrackBuffer[track] & 0xf0) != REG_WRITE)
	    break;		/* WX^݂ǂ */
	  /* WX^ڑ */
	  ch = *cTrackBuffer[track] & 0x0f; 	/* WX^ԍ擾 */
	  cTrackBuffer[track]++;
	  value = (short)*cTrackBuffer[track]; 	/* ݒl擾 */
	  ch <<= 1;
	  ch |= IO_SB_CHSEL;	/* I/O|[gAhX쐬 */
	  __OUTPORTB(ch,value);	/*  */
	  break;
	}
	cTrackBuffer[track]++;	/* |C^ */
      }
      sStepCounter[track]--;	/* JE^炷 */
    }
  }
  _put_timer_tcr(0x0003);	/* ^C}[JEgĊJ */
}
/*
 * w`lɉFݒ肷B
 */
void
waveset(unsigned char track, unsigned char *wave_data)
{
  int i;
  __OUTPORTB(IO_SB_CHSEL, track); /* `lI */
  __OUTPORTB(IO_SB_CHVOL, 0x00); /* Fݒ胂[hɂ */
  for(i = 0; i < 32; i++) {	/* g`f[^ */
    __OUTPORTB(IO_SB_WAVE, *wave_data); 
    wave_data++;
  }
}
/*
 * orfhCo[
 */
void 
drvinit(void)
{
  int	i;
  /* C{[O */
  __OUTPORTB(IO_SB_MVOL, 0x00);
  /* S`lIt  {[O */
  for (i = 0; i < TRACK; i++){
    __OUTPORTB(IO_SB_CHSEL, i);	/* `lO`TI */
    __OUTPORTB(IO_SB_CHVOL, 0x00); /* `l{[O */
    __OUTPORTB(IO_SB_NOISE, 0x00); /* mCYIt */
    __OUTPORTB(IO_SB_LFOFRQ, 0x01); /* lfo freq. */
    __OUTPORTB(IO_SB_LFOCR, 0x00); /* lfo off */
    sStepCounter[i] = 0;	/* XebvJE^[NA */
    cTrackInfo[i] = TRACK_OFF;	/* ~ */
  }
  IrqSet(drvplay  , XINT_TIM);	/* 荞݃[`o^ */
  _put_timer_tmr( T120 );	/* Nׂ̈̃_~[JE^ݒ */
  _put_timer_tcr(0x0001);	/* TIEN = 1, TCE = 0, TIREQ = 0 */
}
/*
 * tJn
 */
void
playstart(void)
{
  int track;
  /*  */
  for(track = 0; track < TRACK; track++){
    cTrackBuffer[track] = cTrackTop[track]; /* obt@|C^Ȃ̐擪 */
    cTrackInfo[track] = TRACK_ON; /* t */
    sStepCounter[track] = 0;	/* XebvJE^[NA */
  }
  _put_timer_tcr(0x0001);	/* ^C}[ݒ */
  _put_timer_tcr(0x0003);
  IrqOn(XINT_TIM);		/* 荞݋ */
}
/*
 * t~
 */
void
playstop(void)
{
  drvinit();			/* hCo */
  _put_timer_tcr(0x0000);	/* ^C}[~ */
  IrqOff(XINT_TIM);		/* 荞݃[`~ */
}
/*
 * ȃf[^o^
 */
void
dataset(unsigned char *cMusicBuffer[])
{
  cTrackTop[0] = cMusicBuffer[0];	/* ϐɑ */
  cTrackTop[1] = cMusicBuffer[1];	/* ϐɑ */
  cTrackTop[2] = cMusicBuffer[2];	/* ϐɑ */
  cTrackTop[3] = cMusicBuffer[3];	/* ϐɑ */
  cTrackTop[4] = cMusicBuffer[4];	/* ϐɑ */
  cTrackTop[5] = cMusicBuffer[5];	/* ϐɑ */
}
/*
 * tԂ𓾂
 * ԂlF	O     SgbN~
 *		Pȏ ꂩ̃gbNt
 *		ibit 0`5 ܂łgbN 0`5 ܂ł̉t
 *		  O͒~AP͉tj
 */
char
gettrackinfo( void )
{
  char  alltrack;
  int   i;
  /*  */
  alltrack = 0;			/*  */
  for(i = 0; i < TRACK; i++){
    alltrack |= cTrackInfo[i] << i; /* egbN̉tԌvZ */
  }
  return alltrack;		/* lĕԂ */
}
