/*
 * CDRSCSI.C Version 1.00 (C)1996 HUDSON SOFT
 * SCSI CD-ROM ANZX֐(CDRSCSI.C)
 */
#include    <system.h>
#include    <scsi.h>
#include    "cdrscsi.h"

/* scsi() Ŏgp SCSI \̂̎
 * execute_scsi() ֐œeݒ肵 scsi() ɓn܂B
 */
static SCSI	sccmd;

/* SCSI \̂ɕKvȃp[^ݒ肵 scsi() Ăяo scsi R}hs
 * ܂B
 *
 * ́F
 * int		    id;    CD-ROMi^[Qbgj SCSI ID
 * unsigned char    *cdb;  s scsi R}hubNւ̃|C^
 * void		    *dat;  f[^]Ɏgpf[^̈ւ̃|C^
 * int		    siz;   f[^]oCgiɋw肷鎖j
 * int		    mod;   ][hiREAD_MRAM,READ_KRAM,READ_KRAM_DMAj
 *
 * óF
 * int		    -1	   scsi R}h̎sɎs
 * 		    0	   scsi R}h̎sɐ
 */
static int	execute_scsi(id,cdb,dat,siz,mod)
int		id;
unsigned char	*cdb;
void		*dat;
int		siz;
int		mod;
{
    sccmd.istat=0;
    sccmd.tstat=0;
    sccmd.unit=(0x01<<id);
    sccmd.mess=0;
    sccmd.data=dat;
    sccmd.count=siz;
    sccmd.block=2048;
    sccmd.mode=mod;
    sccmd.cmd=cdb;
    scsi(&sccmd);

    if ( sccmd.istat != INIT_OK || sccmd.tstat != TRGT_GOOD ) {
	return(-1);
    } else {
	return(0);
    }
}

/* CD-ROM  TEST UNIT READY R}h𔭍s܂B
 * reset_scsi() śAK TEST UNIT READY R}hsȂ΂
 * ܂B
 *
 * ́F
 * int		    id;    CD-ROMi^[Qbgj SCSI ID
 *
 * óF
 * int		    -1	   scsi R}h̎sɎs
 * 		    0	   scsi R}h̎sɐ
 */
int	cdrom_unit_ready(id)
int	id;
{
    static unsigned char	cdb_buff[] = {
	0x00,	/* 0 */
	0x00,	/* 1 */
	0x00,	/* 2 */
	0x00,	/* 3 */
	0x00,	/* 4 */
	0x00	/* 5 */
    };

    return ( execute_scsi(id,cdb_buff,NULL,0,0) );
}

/* CD-ROM  READ TOC R}h𔭍s܂B
 *
 * ́F
 * int		    id;    CD-ROMi^[Qbgj SCSI ID
 * void		    *dat;  CD  TOC i[f[^̈ւ̃|C^
 *			   iʏ struct CDROM_TOC ւ̃|C^w肷鎖j
 * unsigned int	    siz;   CD  TOC i[f[^̈̃oCg
 *			   iʏ sizeof(CDROM_TOC)w肷鎖j
 * int		    mod;   Ԃ CD-ROM ʒǔ`̎w
 *			   0 ʒu͘_ubN`
 *			   1 ʒu͕bt[`
 * int		    trk;   TOC vgbN
 *
 * óF
 * int		    0	   scsi R}h̎sɐ
 */
int	cdrom_toc(id,dat,siz,mod,trk)
int		id;
void		*dat;
unsigned int	siz;
int		mod;
int		trk;
{
    static unsigned char	cdb_buff[] = {
	0x43,	/* 0 */
	0x00,	/* 1 */
	0x00,	/* 2 */
	0x00,	/* 3 */
	0x00,	/* 4 */
	0x00,	/* 5 */
	0x00,	/* 6 */
	0x00,	/* 7 */
	0x00,	/* 8 */
	0x00	/* 9 */
    };
    int	    res;

    cdb_buff[1] = 0x00 ;
    if ( mod != 0 ) {
	cdb_buff[1] = 0x02 ;
    }
    cdb_buff[6] = trk ;
    cdb_buff[7] = (siz>>8) ;
    cdb_buff[8] = siz ;

    while ( execute_scsi(id,cdb_buff,dat,siz,READ_MRAM) != 0 )
	;

    return( 0 ) ;
}

/* CD-ROM  READ TOC R}h𔭍sA擪gbNԍƍŏIgbNԍ
 * ܂B
 *
 * ́F
 * int		    id;    CD-ROMi^[Qbgj SCSI ID
 * CD_INFO_TNUM	    *dat;  擾gbNԍi[\̂ւ̃|C^
 *			   gbNԍ 1 ` 99 ̒lŊi[܂
 *
 * óF
 * int		    0	   scsi R}h̎sɐ
 */
int	cdrom_info_tnum(id,dat)
int		id;
CD_INFO_TNUM	*dat;
{
    int			res;
    static CDROM_TOC	toc;

    res = cdrom_toc( id, &toc, sizeof(toc), 0, 1 ) ;
    dat->min_track = toc.head.first_track;
    dat->max_track = toc.head.last__track;

    return( res );
}

/* CD-ROM  READ TOC R}h𔭍sALEAD OUT ʒu擾܂B
 *
 * ́F
 * int		    id;    CD-ROMi^[Qbgj SCSI ID
 * CD_INFO_LOUT	    *dat;  擾 LEAD OUT i[\̂ւ̃|C^
 *			   LEAD OUT ͕bt[Ŋi[܂
 *
 * óF
 * int		    0	   scsi R}h̎sɐ
 */
int	cdrom_info_lout(id,dat)
int		id;
CD_INFO_LOUT	*dat;
{
    int			res;
    static CDROM_TOC	toc;

    res = cdrom_toc( id, &toc, sizeof(toc), 1, 0xaa ) ;
    dat->leadout_min = toc.data[0].d1;
    dat->leadout_sec = toc.data[0].d2;
    dat->leadout_fra = toc.data[0].d3;

    return( res );
}

/* CD-ROM  READ TOC R}h𔭍sAwgbN̈ʒuibt[j
 * 擾܂B
 *
 * ́F
 * int		    id;    CD-ROMi^[Qbgj SCSI ID
 * CD_INFO_TIME	    *dat;  擾ʒui[\̂ւ̃|C^
 *			   ʒu͕bt[Ŋi[܂
 * int		    trk;   ʒuvgbN
 *
 * óF
 * int		    0	   scsi R}h̎sɐ
 *		    -1	   w肵gbNԍ
 */
int	cdrom_info_time(id,dat,trk)
int		id;
CD_INFO_TIME	*dat;
int		trk;
{
    int			res;
    static CD_INFO_LOUT	lout;
    static CD_INFO_TNUM	tnum;
    static CDROM_TOC	toc;

    dat->typ = -1 ;
    if ( (res=cdrom_info_tnum(id,&tnum)) != 0 ) {
	return(res);
    }
    if ( trk < tnum.min_track ) {
	return(-1);
    } if ( trk > tnum.max_track ) {
	res = cdrom_info_lout( id, &lout ) ;
	dat->min = lout.leadout_min;
	dat->sec = lout.leadout_sec;
	dat->fra = lout.leadout_fra;
    } else {
	res = cdrom_toc( id, &toc, sizeof(toc), 1, trk ) ;
	dat->min = toc.data[0].d1;
	dat->sec = toc.data[0].d2;
	dat->fra = toc.data[0].d3;
	dat->typ = (toc.data[0].adr_control & 0x0f) ;
    }
    return( res );
}

/* CD-ROM  READ TOC R}h𔭍sAwgbN̈ʒui_ubNj
 * 擾܂B
 * _ubNʒúAOQbOt[OɂȂ܂B
 *
 * ́F
 * int		    id;    CD-ROMi^[Qbgj SCSI ID
 * CD_INFO_SECT	    *dat;  擾ʒui[\̂ւ̃|C^
 *			   ʒu͘_ubNŊi[܂
 * int		    trk;   ʒuvgbN
 *
 * óF
 * int		    0	   scsi R}h̎sɐ
 *		    -1	   w肵gbNԍ
 */
int	cdrom_info_sect(id,dat,trk)
int		id;
CD_INFO_SECT	*dat;
int		trk;
{
    int			res;
    static CD_INFO_TIME time;
    unsigned int	sect;

    res = cdrom_info_time(id,&time,trk);
    sect  = time.min;
    sect *= 60 ;
    sect += time.sec;
    sect *= 75 ;
    sect += time.fra;
    sect -= ( 75 * 2 ) ;
    dat->sect = sect ;
    dat->typ = time.typ;
    return(res);
}

/* CD-ROM  READ EXTENDED R}h𔭍sAwubNw肵ubN
 * ̃f[^Cɓǂݍ݂܂B
 *
 * ́F
 * int		    id;    CD-ROMi^[Qbgj SCSI ID
 * unsigned int	    sect;  ǂݍ݊JnubNʒu
 * void		    *buff; ǂݍ񂾃f[^i[̈ւ̃|C^
 *			   ï̑傫͓ǂݍ݃ubN~2048oCgKvj
 * unsigned int	    ssiz;  ǂݍ݃ubN
 *
 * óF
 * int		    0	   scsi R}h̎sɐ
 *
 * ӁF
 * G[ꍇ͒PɍĎs܂B]āAI[fBIgbNɑ΂
 * ǂݍݓAǂݍ݉\͈͊O̓ǂݍ݂Ȃǂ̂悤ɁAKG[
 * ĂяosȂƁAɍĎsJԂAłȂȂ܂BsȌ
 * яo͂ȂŉB
 */
int	cdrom_read( id, sect, buff, ssiz )
int		id;
unsigned int	sect;
void		*buff;
unsigned int	ssiz;
{
    static unsigned char	cdb_buff[] = {
	0x28,	/* 0 */
	0x00,	/* 1 */
	0x00,	/* 2 */
	0x00,	/* 3 */
	0x00,	/* 4 */
	0x00,	/* 5 */
	0x00,	/* 6 */
	0x00,	/* 7 */
	0x00,	/* 8 */
	0x00	/* 9 */
    };

    cdb_buff[2]=(sect>>24);
    cdb_buff[3]=(sect>>16);
    cdb_buff[4]=(sect>>8);
    cdb_buff[5]=(sect>>0);
    cdb_buff[7]=(ssiz>>8);
    cdb_buff[8]=(ssiz>>0);

    while ( execute_scsi(id,cdb_buff,buff,(ssiz * 2048),READ_MRAM) != 0 )
	;

    return(0);
}

/* CD-ROM  EJECT R}h𔭍sACD-ROM CWFNg܂B
 *
 * ́F
 * int		    id;    CD-ROMi^[Qbgj SCSI ID
 *
 * óF
 * int		    0	   scsi R}h̎sɐ
 *
 * ӁF
 * ̃TvvOł́ÃR}hzXg}ṼvOɃG[
 * 𔺂̏IʒmړIŎgpĂ܂B
 * zXg}ṼTvvOł́ÃR}hɂăCWFNgw
 * ƓI DOS ɖ߂悤ɍ쐬Ă܂B
 * ]āÃR}hśAPC-FXGA vOIȂ
 * ΂Ȃ܂B
 */
int	cdrom_eject(id)
int	id;
{
    static unsigned char	cdb_buff[] = {
	0xdc,	/* 0 */
	0x00,	/* 1 */
	0x00,	/* 2 */
	0x00,	/* 3 */
	0x00,	/* 4 */
	0x00,	/* 5 */
	0x00,	/* 6 */
	0x00,	/* 7 */
	0x00,	/* 8 */
	0x00	/* 9 */
    };
    return ( execute_scsi(id,cdb_buff,NULL,0,0) );
}

/* CD-ROM  START/STOP UNIT R}h𔭍sACD-ROM CWFNg܂B
 *
 * ́F
 * int		    id;    CD-ROMi^[Qbgj SCSI ID
 *
 * óF
 * int		    0	   scsi R}h̎sɐ
 *
 * ӁF
 * ̃TvvOł́ÃR}hzXg}ṼvOɓ
 * IʒmړIŎgpĂ܂B
 * zXg}ṼTvvOł́ÃR}hɂăCWFNgw
 * ƓI DOS ɖ߂悤ɍ쐬Ă܂B
 * ]āÃR}hśAPC-FXGA vOIȂ
 * ΂Ȃ܂B
 */
int	cdrom_stop(id)
int	id;
{
    static unsigned char	cdb_buff[] = {
	0x1b,	/* 0 */
	0x00,	/* 1 */
	0x00,	/* 2 */
	0x00,	/* 3 */
	0x02,	/* 4 */
	0x00	/* 5 */
    };
    return ( execute_scsi(id,cdb_buff,NULL,0,0) );
}
