/*
 * CDRSCSI.H Version 1.00 (C)1996 HUDSON SOFT
 * SCSI CD-ROM ANZX֐pwb_[t@C(CDRSCSI.H)
 */

#ifndef __CDRSCSI_H
#define __CDRSCSI_H

/* READ TOC ֘Å֐Ŏgp\̌^̒`
 * ̍\̂ CDRSCSI.C Ŏgp܂B
 */

/* __cdrom_info_tnum() Ŏgp\̌^̒` */
typedef struct {
    unsigned char   min_track;		/* ŏgbNԍ */
    unsigned char   max_track;		/* őgbNԍ */
} CD_INFO_TNUM ;

/* __cdrom_info_lout() Ŏgp\̌^̒` */
typedef struct {
    unsigned char   leadout_min;	/* [hAEgE */
    unsigned char   leadout_sec;	/* [hAEgEb */
    unsigned char   leadout_fra;	/* [hAEgEt[ */
} CD_INFO_LOUT;

/* __cdrom_info_time() Ŏgp\̌^̒` */
typedef struct {
    unsigned char   min;		/*  */
    unsigned char   sec;		/* b */
    unsigned char   fra;		/* t[ */
    unsigned char   typ;		/* ^Cv */
} CD_INFO_TIME;

/* __cdrom_info_sect() Ŏgp\̌^̒` */
typedef struct {
    unsigned int    sect;		/* ubN */
    unsigned char   typ;		/* ^Cv */
} CD_INFO_SECT;

/* TOC ̃wb_\̍\̌^̒` */
typedef struct {
    unsigned char   len_0;		/*  */
    unsigned char   len_1;		/*  */
    unsigned char   first_track;	/* 擪gbNԍ */
    unsigned char   last__track;	/* ŏIgbNԍ */
} CDROM_TOC_HEAD;

/* TOC ̖{̍\̍\̌^̒` */
typedef struct {
    unsigned char   resv0;		/* \ */
    unsigned char   adr_control;	/* AhXƃRg[^Cv */
    unsigned char   track;		/* gbNԍ */
    unsigned char   resv1;		/* \ */
    unsigned char   d0;			/* ----     / ubNŏ */
    unsigned char   d1;			/*        / ubN */
    unsigned char   d2;			/* b       / ubN */
    unsigned char   d3;			/* t[ / ubNŉ */
} CDROM_TOC_TRKD;

/* __cdrom_toc() Ŏgp\̌^̒` */
typedef struct {
    CDROM_TOC_HEAD  head;		/* TOC wb_ */
    CDROM_TOC_TRKD  data[1];		/* TOC { */
} CDROM_TOC;

/* CDRSCSI.C ̊֐̊֐vg^Cv錾
 */
int	cdrom_unit_ready(int);
int	cdrom_toc(int,void *,unsigned int,int,int);
int	cdrom_info_tnum(int,CD_INFO_TNUM *);
int	cdrom_info_lout(int,CD_INFO_LOUT *);
int	cdrom_info_time(int,CD_INFO_TIME *,int);
int	cdrom_info_sect(int,CD_INFO_SECT *,int);
int	cdrom_read(int,unsigned int,void *,unsigned int);
int	cdrom_eject(int);
int	cdrom_stop(int);

#endif	/* __CDRSCSI_H */
