/*  static char SccsId[] = "@(#)attfile.h	1.4 7/31/95";
 *
 *		Copyright (c) KUBOTA Corporation,
 *		1994, 1995 All Rights Reserved
 *
 *  This software comprises unpublished confidential information of 
 *  KUBOTA Corp. and may not be used, copied or made available to anyone,
 *  except in accordance with the license under which it is furnished.
 */

#ifndef __ATT_FILE_HEADER__
#define	__ATT_FILE_HEADER__

#include	"actype.h"		/* Aurora Data type header */

/*******************************************************
	ATT File Format
********************************************************/

/********************************************************************/
/* define type of file image structure */

typedef struct { 
	CARD16	texture_id;		/* 0..1 */
	CARD16	bank;			/* 2..3 */
	CARD16	x_offset;		/* 4..5 */
	CARD16	y_offset;		/* 6..7 */
	CARD16	x_size;			/* 8..9 */
	CARD16	y_size;			/* 10..11 */
	CARD8	txtname[16];		/* 12..27 */
	CARD8	filename[16];		/* 28..43 */
	CARD8	comment[32];		/* 44..75 */
	void 	*next;			/* Depend on machine */
	void	*prev;			/* Depend on machine */
	void 	*imagehdr;		/* Depend on machine */
} attdata_t;


/*

<id> <BNK> <X> <Y> <Xsize> <Ysize> <texture name> <filename> #<comment>

0     0    128 128   64     64     tree           tree.aid   # Tree texture
1     0      0   0  128     64     rock1          rock.aid   # Black rock texture
2     1      0   0  128     64     rock2          rock.aid   # White rock texture

*/

#endif
