/*-----------------------------------------------------------------*/
#include <stdio.h>
#include "prottype.h"

static long addr=0L,imode=0;
/*-----------------------------------------------------------------*/
void setdump(long adr,long im)
{
    addr = adr;
    imode= im;
}
/*-----------------------------------------------------------------*/
void dump(char *buf,int len)
{
    int i,c,j;
    i = len/16;
    c = len%16;
    while(i--) {
	printf("%08lx: ",addr);
	for(j=0;j<16;j++) printf("%02x ",*(buf++)&0xff);
	printf("\n");
	addr += (imode==0)? 16:16/imode;
    }

    if(c) printf("%08lx: ",addr);
    while(c--) {
	printf("%02x ",*buf++);
    }
    printf("\n");
    addr += (imode==0)? 16:16/imode;
}

/*-----------------------------------------------------------------*/
void dumps(short *buf,int len)
{
    int i,c,j;
    i = len/8;
    c = len%8;
    while(i--) {
	printf("%08lx: ",addr);
	for(j=0;j<8;j++) printf("%04x ",*buf++);
	printf("\n");
	addr += (imode==0)? 16:16/imode;
    }

    if(c) printf("%08lx: ",addr);
    while(c--) {
	printf("%04x ",*buf++);
    }
    printf("\n");
    addr += (imode==0)? 16:16/imode;
}

/*-----------------------------------------------------------------*/
void dumpl(long *buf,int len)
{
    int i,c,j;
    i = len/4;
    c = len%4;
    while(i--) {
	printf("%08lx: ",addr);
	for(j=0;j<4;j++) printf("%08lx ",*buf++);
	printf("\n");
	addr += (imode==0)? 16:16/imode;
    }

    if(c) printf("%08lx: ",addr);
    while(c--) {
	printf("%08lx ",*buf++);
    }
    printf("\n");
    addr += (imode==0)? 16:16/imode;
}

/* EOF */
