/*
 * DEV72.H Version 1.01 (C)1995,1996 HUDSON SOFT
 * HuC6272ph^n|[g` bRpCpwb_[t@C(DEV72.H)
 */

#ifndef _DEV72_H_
#define _DEV72_H_

/* define I/O port */

#define IO_KING_AR 0x0600	/* WX^AhXݒ */
#define IO_KING_SR 0x0600	/* Xe[^X */
#define IO_KING_SRL 0x0600	/* Xe[^X(low half word) */
#define IO_KING_SRH 0x0602	/* Xe[^X (high half word) */
#define IO_KING_DR 0x0604	/* f[^ */
#define IO_KING_DRL 0x0604	/* f[^ (low half word) */
#define IO_KING_DRH 0x0606	/* f[^ (high half word) */

/* define bit string port */

#define BS_KING_RR 0xac000000	/* rbgXgO [h|[g */
#define BS_KING_WR 0xbc000000	/* rbgXgO Cg|[g */

/* define register name */

/* rbrh */
#define _SCSI_ODATA 0x00	/* AEgvbgf[^ */
#define _SCSI_CDATA 0x00	/* Jgf[^ */
#define _SCSI_ICMD 0x01		/* CjVG[^f[^ */
#define _SCSI_MODE 0x02		/* [h */
#define _SCSI_TCMD 0x03		/* ^[QbgR}h */
#define _SCSI_SELECT 0x04	/* ZNgCl[u */
#define _SCSI_CBSTAT 0x04	/* JgoXXe[^X */
#define _SCSI_DMASEND 0x05	/* X^[gcl`Zh */
#define _SCSI_BUSSTAT 0x05	/* oX  Xe[^X */
#define _SCSI_PSEDMA 0x05	/* ^cl` [hECg(IO_KING_DRH) */
#define _SCSI_TDMASEND 0x06	/* X^[gcl` ^[QbgV[u */
#define _SCSI_IDATA 0x06	/* Cvbgf[^ */
#define _SCSI_DMARCV 0x07	/* X^[gcl` CjVG[^[V[u */
#define _SCSI_IRQRESET 0x07	/* ZbgC^vg */
#define _CDROM_SUBCTRL 0x08	/* TuR[h */
#define _CDROM_SUBDATA 0x08	/* TuR[hf[^ */
#define _SCSI_DMASTART 0x09	/* cl`X^[gAhX */
#define _SCSI_DMACNT 0x0a	/* cl`oCgJEg */
#define _SCSI_DMACR 0x0b	/* cl`Rg[ */
/* jq`l */
#define _KRAM_ARR 0x0c		/* [hAhX */
#define _KRAM_CARR 0x0c		/* Jg[hAhX */
#define _KRAM_AWR 0x0d		/* CgAhX */
#define _KRAM_CAWR 0x0d		/* JgCgAhX */
#define _KRAM_DATA 0x0e		/* q^vf[^ */
#define _KRAM_PAGE 0x0f		/* y[Wݒ */
#define _KRAM_MODE 0x61		/* [hݒ */
/* jaf */
#define _BG_MODE 0x10		/* af `ݒ */
#define _BG_PRI	 0x12		/* af vCIeBݒ */
#define _BG_MPAR 0x13		/* }CNvO [hAhX */
#define _BG_MPDR 0x14		/* }CNvO f[^ */
#define _BG_MPCR 0x15		/* }CNvO Rg[ */
#define _BG_SSCR 0x16		/*  ݒ */
#define _BG_BAT0 0x20		/* afO  a`sAhX  */
#define _BG_CG0	 0x21		/* afO  bfAhX */
#define _BG_SBAT0 0x22		/* afO  a`sAhX  */
#define _BG_SCG0 0x23		/* afO  bfAhX */
#define _BG_BAT1 0x24		/* afP 啛 a`sAhX  */
#define _BG_CG1	 0x25		/* afP 啛 bfAhX */
#define _BG_BAT2 0x28		/* afQ 啛 a`sAhX  */
#define _BG_CG2	 0x29		/* afQ 啛 bfAhX */
#define _BG_BAT3 0x2a		/* afR 啛 a`sAhX  */
#define _BG_CG3	 0x2b		/* afR 啛 bfAhX */
#define _BG_SIZE0 0x2c		/* afO TCY */
#define _BG_SIZE1 0x2d		/* afP TCY */
#define _BG_SIZE2 0x2e		/* afQ TCY */
#define _BG_SIZE3 0x2f		/* afR TCY */
#define _BG_BSX0 0x30		/* afO XN[ */
#define _BG_BSY0 0x31		/* afO XN[ */
#define _BG_BSX1 0x32		/* afP XN[ */
#define _BG_BSY1 0x33		/* afP XN[ */
#define _BG_BSX2 0x34		/* afQ XN[ */
#define _BG_BSY2 0x35		/* afQ XN[ */
#define _BG_BSX3 0x36		/* afR XN[ */
#define _BG_BSY3 0x37		/* afR XN[ */
#define _BG_AFINA 0x38		/* AtBW ` */
#define _BG_AFINB 0x39		/* AtBW a */
#define _BG_AFINC 0x3a		/* AtBW b */
#define _BG_AFIND 0x3b		/* AtBW c */
#define _BG_AFINX 0x3c		/* AtBW S wW */
#define _BG_AFINY 0x3d		/* AtBW S xW */
/* jq] */
#define _KR_CR	 0x40		/* ]Rg[ */
#define _KR_TSA	 0x41		/* ]f[^JnAhX */
#define _KR_TSR	 0x42		/* ]JnX^ */
#define _KR_LEN	 0x43		/* ]ubN */
#define _RASTER_COUNT 0x44	/* X^Ď */
/* jr] */
#define _KS_MODE 0x50		/* Đ[h */
#define _KS_CR0	 0x51		/* ]Rg[ O */
#define _KS_CR1	 0x52		/* ]Rg[ P */
#define _KS_STAT 0x53		/* Xe[^X */
#define _KS_START0 0x58		/* X^[gAhX O */
#define _KS_END0 0x59		/* GhAhX O */
#define _KS_HALF0 0x5a		/* n[tAhX O */
#define _KS_START1 0x5c		/* X^[gAhX P */
#define _KS_END1 0x5d		/* GhAhX P */
#define _KS_HALF1 0x5e		/* n[tAhX P */

#endif /* _DEV72_H_ */
