static char SccsId[] = "@(#)aslchgcd.c	1.4   10/6/95";
/*
 *         Copyright (c) KUBOTA Corporation and HUDSON SOFT,
 *                  1994, 1995 All Rights Reserved
 *
 *  This software comprises unpublished confidential information of
 *  KUBOTA Corp. and HUDSON SOFT. It may not be used, copied or made
 *  available to anyone, except in accordance with the license under
 *  which it is furnished.
 */

#define	_ASLLIB_
#define	_ASLCHGCD_C_

#include <farl.h>
#include <asl.h>

/*----------------------------------------------------------------------------*/
void
ASLChangeCollisionDetection( ASLSct *sct, Bool enable, int index,
			unsigned short set_bits, unsigned short check_mask )
{
	sct->cntl = ( sct->cntl & ~( ASL_MSK_CDEN | ASL_MSK_CDRES_IDX
				| ASL_MSK_FLAG_SET | ASL_MSK_FLAG_CHK ) )
					| ( enable ? ASL_VAL_CDEN : 0 )
					| ( index	<< ASL_SFT_CDRES_IDX )
					| ( set_bits	<< ASL_SFT_FLAG_SET  )
					| ( check_mask	<< ASL_SFT_FLAG_CHK  );
}

/*----------------------------------------------------------------------------*/
