static char SccsId[] = "@(#)aslexec.c	1.8   10/6/95";
/*
 *         Copyright (c) KUBOTA Corporation and HUDSON SOFT,
 *                  1994, 1995 All Rights Reserved
 *
 *  This software comprises unpublished confidential information of
 *  KUBOTA Corp. and HUDSON SOFT. It may not be used, copied or made
 *  available to anyone, except in accordance with the license under
 *  which it is furnished.
 */

#define	_ASLLIB_
#define	_ASLEXEC_C_

#include <farl.h>
#include <asl.h>

/*----------------------------------------------------------------------------*/
void
ASLExecuteSprite( int bank, int sctNo, int num )
{
#if defined( __ASL_DEPEND_ON_FARL )
	FarlSpbsySpin();
	FarlSpriteGo( bank, sctNo, num );
#else
	while ( *( (unsigned short *)FARL_MISC_STATUS_REG )
						& FARL_MISC_STATUS_SBSY );
	*( (unsigned short *)FARL_SCT_ADDRESS_REG ) = ( (num) & 0x0700 )
		| ( ( bank & 0x001f ) << 3 ) | ( ( sctNo & 0xff00 ) >> 8 );
	*( (unsigned short *)FARL_SP_CONTROL_REG )  =
			  ( ( sctNo & 0x00ff ) << 8 ) | ( num & 0xff );
#endif
}

/*----------------------------------------------------------------------------*/
