static char SccsId[] = "@(#)aslsetpt.c	1.5   10/6/95";
/*
 *         Copyright (c) KUBOTA Corporation and HUDSON SOFT,
 *                  1994, 1995 All Rights Reserved
 *
 *  This software comprises unpublished confidential information of
 *  KUBOTA Corp. and HUDSON SOFT. It may not be used, copied or made
 *  available to anyone, except in accordance with the license under
 *  which it is furnished.
 */

#define	_ASLLIB_
#define	_ASLSET_C_

#include <farl.h>
#include <asl.h>

/*----------------------------------------------------------------------------*/
void
ASLSetParameterTable( int ptBank, int ptOffAddr, int num, ASLPt *pt )
{
#if defined( __ASL_DEPEND_ON_FARL )
	register int		escBank;

	escBank = FarlGetMemReg( FARL_CMT_BANK_SELECT_REG );
	FarlSetMemReg( FARL_CMT_BANK_SELECT_REG, ptBank );
	FarlSetSpParamTbl( ptOffAddr, ( num * sizeof( ASLPt ) ), pt );
	FarlSetMemReg( FARL_CMT_BANK_SELECT_REG, escBank );
#else
	register unsigned int	*buf, *ptWin;
	register int		i, j, k, escBank;

	ptWin	= (unsigned int *)( FARL_TEXTURE_BUFFER + ptOffAddr );
	buf = (unsigned int *)pt;
	j = num * ( sizeof( ASLPt ) / sizeof( unsigned int ) );
	escBank = *( (unsigned short *)FARL_CMT_BANK_SELECT_REG );
	*( (unsigned short *)FARL_CMT_BANK_SELECT_REG ) = ptBank;
	for ( i = 0; i < j; i++ ) {
		ptWin[i] = buf[i];
	}
	*( (unsigned short *)FARL_CMT_BANK_SELECT_REG ) = escBank;
#endif
}

/*----------------------------------------------------------------------------*/
