/*
 * `coblt@Ci.adpj zXg}V
 * [hAjq`lɃZbg
 * 傫Ȃ`coblt@Cǂݍ܂Ɛɓ삵Ȃꍇ܂
 */
#include <system.h>
#include <v93.h>
#include <common.h>
#include <king.h>
#include <king_ks.h>
#include <soundbox.h>
#include <adp.h>
#include "vardecl.h"
#include "adpcm.h"

/* adpt@C̃wb_[̃TCYiύXȂłj */
#define PCM_HEADERSIZE  sizeof(ADPCMHEADER)
/* tH[}bgmFphc */
#define fourch(c0, c1, c2, c3) ( \
  (long)(char)(c0) \
  | ((long)(char)(c1)<<8) \
  | ((long)(char)(c2)<<16) \
  | ((long)(char)(c3)<<24) )
#define ID_RIFF fourch('R','I','F','F')
#define FM_WAVE fourch('W','A','V','E')
#define ID_fmt  fourch('f','m','t',' ')

/*
 #undef __DEBUG__  #define  __DEBUG__ ɂƁA`cobl[h
   t@C\A[hIɎۂɖ炷悤ɂȂ܂B 
 */
#undef __DEBUG__

/*
 * ǂݍރt@C
 * Tvf[^ adpt@CɕϊāA̔z
 * t@CނƁẢŌʉȂ܂B
 * őgݍ񂾃t@CƓԂ ADPCM.H
 * ̂Ă܂B
 */
unsigned char *FileName[]={
  "dat/adpcm/hit3.adp",       /* ԂԂ */
  "dat/adpcm/slip3.adp",      /* Ԃɂׂ鉹 */
  "dat/adpcm/bomb.adp",       /* ݖgp */
  "dat/adpcm/monster1.adp",   /* {Xꂽ */
  "dat/adpcm/m_bomb3.adp",    /* {X̃RAꂽ */
  "dat/adpcm/pause.adp",      /* |[Y */
  "dat/adpcm/start.adp",      /* Q[X^[gI */
  "dat/adpcm/youwon.adp",     /* [EHI */
  "dat/adpcm/youlost.adp",    /* [XgI */
  "dat/adpcm/over4.adp"       /* Q[I[o[ */
};

/*
========================================
  f[^jq`lɃZbg
  FȂ
  ߂lFȂ
========================================
 */
void
APLSetData (void)
{
  unsigned short uKb;
  int           i,offset;
  int           fh;
  unsigned char cBuf;
  long          filelength;
  ADPCMHEADER   aPcmHead;

#ifdef __DEBUG__
  AdpcmVolume(CHANNEL_1,MIN_PCM_VOLUME,MIN_PCM_VOLUME);
  AdpcmVolume(CHANNEL_2,MIN_PCM_VOLUME,MIN_PCM_VOLUME);
  AdpcmInit();
  AdpcmVolume(CHANNEL_1,MAX_PCM_VOLUME,MAX_PCM_VOLUME);
#else
  pio_putstr("ADPCM Loading");
#endif

  /* obľ[v */
  uKb  = 0;
  for( i = 0; i < MAX_PCM_NUMBER; i++){

#ifdef __DEBUG__
    pio_putstr("\nLoading:");
    pio_putstr(FileName[i]);
#else
    pio_putstr(".");
#endif
    /* t@CJ */
    if((fh = pio_fopen(FileName[i],"rb")) == -1){
      pio_putstr(FileName[i]);
      pio_putstr(" J܂B\n");
      _exit();
    }
    offset = 0;
    /* wb_[ǂݍ */
    if(pio_fread(fh,PCM_HEADERSIZE, &aPcmHead) != PCM_HEADERSIZE){
      /* ǂݍ݂ɎsG[\ */
      pio_putstr(FileName[i]);
      pio_putstr(" ̓ǂݍ݂Ɏs܂B\n");
      _exit();
    }
    /* ȈՓIɃwb_[𒲍 */
    if (aPcmHead.fileid != ID_RIFF || aPcmHead.format_type != FM_WAVE || 
        aPcmHead.info.fileid != ID_fmt) {
        /* Ⴄwb_[G[\ */
        pio_putstr(FileName[i]);
        pio_putstr(" ̃wb_[ȂΉ̃tH[}bgłB\n");
        _exit();
    }
    /* t@CŌ܂œǂݍ */
    pio_fseek(fh,0L,0);
    filelength = aPcmHead.info.datasize + PCM_HEADERSIZE;
    /* t@C̓ǂݍ */
    if(pio_fread(fh, filelength, (char *)filereadbuf) != filelength){
      pio_putstr(FileName[i]);
      pio_putstr(" ̓ǂݍ݂Ɏs܂B\n");
      _exit();
    }
    /* ǂݍ񂾃f[^̂jq`lւ̃Zbg */
    uKb += AdpcmDataSet(&pInfo[i],filereadbuf,uKb,PCM_NORMAL);
    /* t@C */
    pio_fclose(fh);

#ifdef __DEBUG__
    /* `cobl炷 */
    AdpcmPlay(CHANNEL_1,&pInfo[i]);
    AdpcmWait(CHANNEL_1);
#endif
  }
#ifdef __DEBUG__
  /* I܂ő҂ */
  AdpcmWait(CHANNEL_1);
  AdpcmVolume(CHANNEL_1,MIN_PCM_VOLUME,MIN_PCM_VOLUME);
  AdpcmVolume(CHANNEL_2,MIN_PCM_VOLUME,MIN_PCM_VOLUME);
  VSyncWait();
#endif
  pio_putstr("\n");
}
