/*
 * Tv (elf.c)
 * enemy-unit 2 Made by M.
 * p[^݂̂ŏĂƂB
 * g݂΂̂Ǝ_ĂBi܂łȂǁj
 */
#include <system.h>
#include <v93.h>
#include <common.h>
#include "spec.h"
#include "vardecl.h"
#include "service.h"

#define ELF_MIN_SPEED   0.043   /* ȉ̃Xs[hȂANZ */
#define ELF_LIMIT_SPEED 0.045   /* ȏ̃Xs[hȂu[L */
#define ELF_LIMIT_DIST  1.300   /* [ȉɋߕt瓦 */
#define ELF_DOWN_SPEED  0.005   /* ȂƂɂȏȂ猸 */
#define ELF_ENEMY_DIST  0.010   /* ȉɓGɋߕtȂ */
#define ELF_ATTACK_SPEED 0.080  /* ̑x܂łȂA^bN */

typedef enum {          /* enumŐ錾Ă */
  D_FRONT,
  D_BACK,
  D_LEFT,
  D_RIGHT,
  D_NULL
}DIR;

DIR ElfBrain(int);    /* ܂̐錾 */

/*
--------------------------------------------------------------
 * C[`
 * ӓ_F[v͍ȂB
 *         A̓ŁAS_TurnLeft,S_TurnRight͂PxĂ
--------------------------------------------------------------
 */
void
ElfMain(int which)
{
  int         iLRflag;
  int         iFBflag;
  QuadDist    *qDistance;
  direct_t    EnemyDir;

  iFBflag = D_NULL;
  iLRflag = D_NULL;
  qDistance = S_CheckDist(which);

  /* Xs[h𗎂Ƃ */
  if (S_GetSpeed(which) >= ELF_LIMIT_SPEED){
    iFBflag = D_BACK;
  }
  /* [߂瓦 */
  if(qDistance->dFrontDist < ELF_LIMIT_DIST){
    if (S_GetSpeed(which) >= ELF_DOWN_SPEED){
      iFBflag = D_BACK;
    }
    /* ǂɋȂǂ̂čl */
    EnemyDir = S_SearchEnemy(which);
    /* GɂȂAȂ֋Ȃ */
    if(EnemyDir < 0){
      iLRflag = ElfBrain(which);
    } else {
      if(EnemyDir < 900) {
        iLRflag = D_LEFT;
      }
      if(EnemyDir > 2700) {
        iLRflag = D_RIGHT;
      }
    }
  } else {
/*----------------------------
[߂ȂAGT
----------------------------*/
    EnemyDir = S_SearchEnemy(which);
    if(EnemyDir < 0) {
      /* ɂȂAEɋȂ */
      iLRflag = D_RIGHT;
    }
    else{
      if(EnemyDir < 900) {
        /* ɂȂAɋȂ */
        iLRflag = D_LEFT;
      }
      if(EnemyDir > 2700) {
        /* EɂȂAEɋȂ */
        iLRflag = D_RIGHT;
      }
      if(EnemyDir <= 200 || EnemyDir >= 3400) {
        /* ʂɂȂA */
        /* ̎߂Ȃωēɍs */
        if(S_CalcEnemyDist(which) < ELF_ENEMY_DIST){
          iLRflag = ElfBrain(which);
          if(S_GetSpeed(which) >= ELF_ATTACK_SPEED){
            iFBflag = D_NULL;
          } else {
            iFBflag = D_FRONT;
          }
        } else {
          iLRflag = D_NULL;
          iFBflag = D_FRONT;
        }
      }
    }
/*
--------------------------
xXs[h
--------------------------
 */
    if (S_GetSpeed(which) <= ELF_MIN_SPEED) {
      iFBflag = D_FRONT;
    }
  }
  /* ɒ[ڋ߂ĂAEɋȂ */
  if(qDistance->dLeftDist < ELF_LIMIT_DIST){ iLRflag = D_RIGHT; }

  /* Eɒ[ڋ߂ĂAɋȂ */
  if(qDistance->dRightDist < ELF_LIMIT_DIST){ iLRflag = D_LEFT; }

  /* 낪߂Xs[h Ɠɒ[瓦 */
  if (qDistance->dBackDist < ELF_LIMIT_DIST){
    iFBflag = D_FRONT; 
    iLRflag = ElfBrain(which);
  }

/*
----------------------------------------------------
肳ꂽsp^[AۂɍsɂB
----------------------------------------------------
 */
  switch(iLRflag){
    case D_LEFT:
      S_TurnLeft(which);
      break;
    case D_RIGHT:
      S_TurnRight(which);
      break;
    default:
      break;
  }
  switch(iFBflag){
    case D_FRONT:
      S_Forward(which);
      break;
    case D_BACK:
      S_Backward(which);
      break;
    default:
      break;
  }
}

/*
--------------------------------------------------------------
 * 
 *iǂɋȂ邩l)
 * Aǂ߂ꍇ̂݁B
 * dwarfɎgĂ锻胋[`ƓłB
--------------------------------------------------------------
 */
DIR
ElfBrain(int which)
{
  float     fMyX,fMyY;
  direct_t  dtMyDir;
  DIR       DWhich;

  /* ̏E */
  /* px0.1PʂȂ̂ŁA10Ŋ */
  /* ł̂wxWƊpx́AwO̐OƂ
     Ă̂ŕϊs */
  fMyX = -1 * S_CheckY(which);
  fMyY = S_CheckX(which);
  dtMyDir = S_CheckDir(which) / 10;

  /* tB[hSTPʂłWA
     ꏊƌɂċȂ߂ */
  if( fMyX > 0 && fMyY > 0 ){
    if( fMyX > fMyY ){
/* 1 */
      if(dtMyDir > 0 && dtMyDir < 180)
        DWhich = D_LEFT;
      else
        DWhich = D_RIGHT;
    }
    else{
/* 2 */
      if(dtMyDir < 90 || dtMyDir > 270 )
        DWhich = D_RIGHT;
      else
        DWhich = D_LEFT;
    }
  }
  else
  if( fMyX < 0 && fMyY > 0 ){
    if( abs(fMyX) > abs(fMyY) ){
/* 4 */
      if(dtMyDir > 0 && dtMyDir < 180)
        DWhich = D_RIGHT;
      else
        DWhich = D_LEFT;
    } else {
/* 3 */
      if(dtMyDir < 90 || dtMyDir > 270 )
        DWhich = D_RIGHT;
      else
        DWhich = D_LEFT;
    }
  } else
  if( fMyX < 0 && fMyY < 0 ){
    if( fMyX > fMyY ){
/* 6 */
      if(dtMyDir < 90 || dtMyDir > 270)
        DWhich = D_LEFT;
      else
        DWhich = D_RIGHT;
    } else {
/* 5 */
      if(dtMyDir > 0 && dtMyDir < 180)
        DWhich = D_RIGHT;
      else
        DWhich = D_LEFT;
    }
  } else {
    if( fMyX > 0 && fMyY < 0 ){
      if( abs(fMyX) < abs(fMyY) ){
/* 7 */
        if(dtMyDir > 0 && dtMyDir < 180)
          DWhich = D_RIGHT;
        else
          DWhich = D_LEFT;
      } else {
/* 8 */
        if(dtMyDir < 90 || dtMyDir > 270)
          DWhich = D_LEFT;
       else
          DWhich = D_RIGHT;
        }
      } else {
      DWhich = D_RIGHT;
    }
  }
  return DWhich;
}

