/*
 * funcdecl.h
 */

#ifndef __FUNCDECL_H__
#define __FUNCDECL_H__

#include "spec.h"

/* @̑֐n */
void HumanMain(int);
void DwarfMain(int);
void ElfMain(int);
void BossMain(int);
void Human1Main(int);
void Human2Main(int);

/* texture.c */
void SetTexture(unsigned short *addr, int bank);
void SetPackedTexture(unsigned short *addr, int bank);
void SetTextureBank(unsigned short *objAddr, int *bankOffsetTable, int bank);

/* game.c */
time_t GetRestTime(void);
int random(void);
void BackScroll1(void);
void BackScroll2(void);

/* tblmake.c */
void NormalUnit(machtype *);
void HeavyUnit(machtype *);
void LightUnit(machtype *);
void BossUnit(machtype *);

/* fall.c */
int IfFall(void);

/* ground.c */
void InitGround(int round);
void SetGround(void);

/* camera.c */
SetCamera(int which);

/* object.c */
void InitCollision(void);
boolean ObjectMan(void);
void DrawObjects(int rotx, int roty, int which);
void DrawGround(void);
boolean BossObjectMan(void);
void BossDrawObjects(void);

/* fileio.c */
char *ultod(unsigned long val);
char *ultoh(unsigned long val);
ReadTexture(int packed, char *fname, int bank);
ReadBG(char *fname);

/* title.c */
void InitTitle(void);
void MoveTitle(void);

/* select.c */
void SelectCar(void);

/* msl.c */
void MSLSync(void);
void MSLPutRadar(int which, short RadarX, short RadarY);
void MSLPutRadar2(direct_t angle, distance dist);
void MSLPutDec(char cNum, short x, short y);
void GameOver(void);
void GameStart(void);
void YouWon(void);
void YouLost(void);
void WhoWon(void);
void CurPut(int x, int y);
void CurErase(void);
void Pause(void);
void GoodJob(void);

#endif /* __FUNCDECL_H__ */
