/*
 * Q[}l[W (game.c)
 */
#include <system.h>
#include <v93.h>
#include <vpsg.h>
#include <libm.h>
#include <intlib.h>
#include <farl.h>
#include "spec.h"
#include "funcdecl.h"
#include "vardecl.h"
#include "service.h"
#include "psgdef.h"
#include "math.h"

#ifndef LOCAL
#define LOCAL
#endif

#define STRLENGTH   (8)		/* "BULLYOFF"̕ */
/* wi 180 256 hbg܂B */
#define DEGPERDOTS  (256.0 / 180.0)

/*
  ----------------------------------------
  [Jϐ
  ----------------------------------------
  */
LOCAL int gameTimer;                        /* c莞 */
LOCAL struct object obj[8];                 
LOCAL int iRotateAngle;                     /* ^CgANVJE^ */
LOCAL int iFontColor;                       /* ^CgtHgF */
LOCAL unsigned short BullyXRot[STRLENGTH];  /* ^CgtHg̉]̓x*/
LOCAL unsigned short BullySize[STRLENGTH];  /* ^CgtHg̊g嗦 */
LOCAL unsigned short BullyZSize[STRLENGTH]; /* ^CgtHg̏c̊g嗦 */
LOCAL float BullyYPos[STRLENGTH];           /* ^CgtHg̏cʒu */
LOCAL float BullyXPos[STRLENGTH] = {        /* ^CgtHg̉ʒu */
      -0.24,    /* b */
      -0.17,    /* u */
      -0.105,   /* l */
      -0.045,   /* l */
       0.018,   /* y */
       0.110,   /* o */
       0.180,   /* f */
       0.245,   /* f */
       };
/* eNX`AADPCM f[^ǂݍ񂾂ǂ̃tO: This is dirty flag */
LOCAL int alreadyRead = FALSE;
LOCAL Material BullyMaterial;               /* ^CgtHg̃}eA */

/* 
----------------------------------------
  [J֐
----------------------------------------
*/
LOCAL void FontInit(void);                  /* tHg */
LOCAL void FontMove(void);                  /* tHgړ */
LOCAL void SetDefaultCar(int round);        /* @̃p[^ݒ */

/* 
----------------------------------------
  VSCOM ̃IuWFNgݒ
----------------------------------------
*/
enum {
  ORDER0,                        /* @ */
  ORDER1,
  ORDER2,
  ORDER3,
  ORDER_MAX,
};

#define START_ROUND (1)                /* JnEh */
#define BOSS_ROUND (3)                /* {XoꃉEh */

typedef struct {
  unsigned short *obj;
  long len;
  float width;
  float h_plus;
  float h_minus;
} machOrder;
LOCAL machOrder order[ORDER_MAX]; /* 3 round */

/* 
----------------------------------------
  EhɑΉ@̂I
  ŏIʂ̓{X̃eNX`t@C
  ǂݍ݁Aݒ肷
  ɏĂ 03,04,05ȊOɂ
  Ԃ̃f[^̂łgݍ
  ĂB
  Ԃς鎞́AIʂłς悤
  select.c ̒ς悤ɂĂB
  ܂AeNX`[f[^ύXȂ
  Ȃ܂BResetGame
  ReadTexture œǂݍރt@CύX
  ĂB
----------------------------------------
*/
LOCAL void
SetDefaultCar(int round)
{
  float scale = FarlFloat187(SCALE_CAR) * OBJ_SCALE / 0.8;

  if (round == ORDER1) {
    /* 
     * Eh̍ŏł낢돉
     */
    order[ORDER0].obj     = obj05_g;
    order[ORDER0].len     = obj05_g_length / sizeof(int);
    order[ORDER0].width   = ( FarlFloat1015(obj05_minmax[MAXX]) / scale) * 0.2;
    order[ORDER0].h_plus  = FarlFloat1015(obj05_minmax[MAXZ]) / scale;
    order[ORDER0].h_minus = FarlFloat1015(obj05_minmax[MINZ]) / scale;
    /* round 1 */
    order[ORDER1].obj     = obj03_g;
    order[ORDER1].len     = obj03_g_length / sizeof(int);
    order[ORDER1].width   = ( FarlFloat1015(obj03_minmax[MAXX]) / scale) * 0.2;
    order[ORDER1].h_plus  = FarlFloat1015(obj03_minmax[MAXZ]) / scale;
    order[ORDER1].h_minus = FarlFloat1015(obj03_minmax[MINZ]) / scale;
    /* round 2 */
    order[ORDER2].obj     = obj04_g;
    order[ORDER2].len     = obj04_g_length / sizeof(int);
    order[ORDER2].width   = ( FarlFloat1015(obj04_minmax[MAXX]) / scale) * 0.2;
    order[ORDER2].h_plus  = FarlFloat1015(obj04_minmax[MAXZ]) / scale;
    order[ORDER2].h_minus = FarlFloat1015(obj04_minmax[MINZ]) / scale;
    /* round 3 */
    order[ORDER3].obj     = boss_g;
    order[ORDER3].len     = boss_g_length / sizeof(int);
    order[ORDER3].width   = ( FarlFloat1015(boss_minmax[MAXX]) / scale);
    order[ORDER3].h_plus  = FarlFloat1015(boss_minmax[MAXZ]) / scale;
    order[ORDER3].h_minus = FarlFloat1015(boss_minmax[MINZ]) / scale;

    /* 1P object */
    machPlayer1 = PLAYER_DUMMY;
    Machine[PLAYER1].type->obj.geometryTop = (int *)order[ORDER0].obj;
    Machine[PLAYER1].type->obj.geometryLength = order[ORDER0].len;
    Machine[PLAYER1].type->width = order[ORDER0].width;
    Machine[PLAYER1].type->h_plus = order[ORDER0].h_plus;
    Machine[PLAYER1].type->h_minus = order[ORDER0].h_minus;
    Machine[PLAYER1].type->obj.material = &aMaterial[PLAYER1];
  }
  if (round == BOSS_ROUND) {
    KINGScreen(1);
    KINGCls(KING_BG0);
    KINGScroll(KING_BG0, 0, 0);
    NowLoading();
    dispon(bg0 | bg | spr);
    ReadTexture(FALSE, "dat/cartex/boss.aid", TBANK_P3); /* {XԃeNX` */
    SetTextureBank(boss_g, boss_g_tindex, TBANK_P3);
  }
  /* 2P object */
  machPlayer2 = round;
  Machine[PLAYER2].type->obj.geometryTop = (int *)order[round].obj;
  Machine[PLAYER2].type->obj.geometryLength = order[round].len;
  Machine[PLAYER2].type->obj.material = &aMaterial[PLAYER2];
  Machine[PLAYER2].type->width = order[round].width;
  Machine[PLAYER2].type->h_plus = order[round].h_plus;
  Machine[PLAYER2].type->h_minus = order[round].h_minus;
}

/*
----------------------------------------
  ^C}[Z
----------------------------------------
*/
LOCAL void
TimerDecrement()
{
  static int timer = 0;

  timer++;
  if (timer >= 60) {
    timer = 0;
    gameTimer--;
  }
}

/*
========================================
  c莞Ԃ𓾂
========================================
*/
time_t
GetRestTime()
{
  return gameTimer;
}

/*
========================================
  0-65535̋[Ԃ
========================================
*/
int
random()
{
  static int seed = 7;

  seed = 13 * seed + 31;
  return seed % 65536;
}

/*
----------------------------------------
  [hݒ

  Opening() Ă΂
----------------------------------------
*/
LOCAL void
SelectGame()
{
  dispon(bg | spr);
  playmode = VSCOM;
  FontInit();

  /* pbh */
  get_pad();
  /* run ꂽI */
  while (1) {
    VSyncWait();
    /* RUN 1ꂽ甲 */
    get_pad();
    if ((pad00.KD_TRG & KP_run) || (pad00.KD_TRG & KP_1))
      break;
    /* ォꂽ烂[hςĉȂ炷 */
    if ((pad00.KD_TRG & KP_up) || (pad00.KD_TRG & KP_down)) {
      playmode = (playmode == VSCOM) ? VSPLAYER : VSCOM;
      PSGSeOn(SE_CURMOVE);
    }
    /* tHg𓮂 */
    FontMove();
    /* J[\\ */
    CurPut(64, 162 + ((playmode == VSCOM) ? 0 : 18));
    /* \I܂ő҂ */
    ASLSync();
    AGLShot();
    MSLSync();
  }
  /* 艹Ȃ炵ăJ[\ */
  PSGSeOn(SE_CURSEL);
  CurErase();
}

/*
----------------------------------------
  Q[I[vjO
----------------------------------------
*/
LOCAL void
Opening()
{
  playmode_t pmPlaymode;
  
  /* obl̏ */
  AdpcmVolume(CHANNEL_1, MIN_PCM_VOLUME, MIN_PCM_VOLUME);
  AdpcmVolume(CHANNEL_2, MIN_PCM_VOLUME, MIN_PCM_VOLUME);
  AdpcmInit();
  AdpcmVolume(CHANNEL_1, MAX_PCM_VOLUME, MAX_PCM_VOLUME);

  /* ӏ */
  DevInit();
  UserInitDev();
  /* XN[WX^̏ */
  KINGScroll(KING_BG0, 0, 0);
  /* orf~߂ */
  PSGClear();
  /* \It */
  dispoff(bg | spr | bg0);
  KINGDispOff();
  /* bUQVQʐݒ */
  KINGScreen(1);
  KINGChangeSize0(DISP_NORMAL);
  KINGKanjiMode(PSET, YUV_WHITE);
  /* \ */
  KINGPuts(48,  68, "     u[It");
  KINGPuts(48, 162, "     1P vs COM");
  KINGPuts(48, 180, "     1P vs 2P");
  KINGPuts(48, 198, "PC-FXGA SAMPLE SOFT");
  /* 񒆂\353\257  (C)ł܂BSptHgłB */
  /* bUQVQ\I */ 
  KINGDispOn();
  dispon(bg | spr | bg0);
  /* 荞݋ */
  irq_enable();
  
  round = START_ROUND;      /* Eh */
  
  /* ^CgȂȂ炷 */
  PSGTitle();
  /* [hI[`Ă */
  SelectGame();
  
  /* orf̃tF[hAEg */
  PSGFadeOut();
  
  /* Cg */
  AGLResetLight(AGL_LIGHT0);
  AGLResetLight(AGL_LIGHT1);
  AGLSetLight(AGL_LIGHT0, 0xf000, 0xf000, 0x200, 0x7fff);
  AGLRotateLightY(AGL_LIGHT0, 700);
  AGLRotateLightZ(AGL_LIGHT0, 2700);
  
  /* ʕ\It */
  dispoff(bg | spr | bg0);
}

/*
----------------------------------------
  낢돉
----------------------------------------
*/

LOCAL void
ResetGame()
{
  int i;

  /* [fBOʍ쐬 */
  dispoff(bg0 | bg | spr);
  KINGScreen(1);
  KINGCls(KING_BG0);
  KINGScroll(KING_BG0, 0, 0);
  KINGKanjiMode(PSET, YUV_WHITE);
  KINGPuts(5, 5, "Font Loading...");
  dispon(bg0);
  /* tOĂȂ΃tHgǂ */
  if (alreadyRead == FALSE) {
    alreadyRead = TRUE;
    /* tHgtHgobt@ɓ] */
    ReadFont("dat/font/spl2.aid");
    NowLoading();
    dispon(bg | spr);
    dispoff(bg0);
    /* eNX`obt@֓] */
    /*
     *  SetDefaultCar() Őݒ肵Ă order[] 
     * select.c  SelectCar() Őݒ肵Ă selorder[] 
     * ڂɊ֌WĂ̂Œ
     */
    /* 1 eNX` 1 */    
    ReadTexture(FALSE, "dat/cartex/ctx5_1.aid", TBANK_P1); 
    /* 1 eNX` 2 */
    ReadTexture(FALSE, "dat/cartex/ctx5_2.aid", TBANK_P1 + 1); 
    SetTextureBank(obj05_g, obj05_g_tindex, TBANK_P1);

    /* 2 pbNgeNX` 1 */    
    ReadTexture(FALSE, "dat/cartex/ctx3_1.aid", TBANK_P2); 
    /* 2 pbNgeNX` 2 */
    ReadTexture(FALSE, "dat/cartex/ctx3_2.aid", TBANK_P2 + 1); 
    SetTextureBank(obj03_g, obj03_g_tindex, TBANK_P2);
    
    /* 4 eNX` 1 */
    ReadTexture(FALSE, "dat/cartex/ctx4_1.aid", TBANK_P3); 
    SetTextureBank(obj04_g, obj04_g_tindex, TBANK_P3);
    APLSetData();                /* ADPCM f[^ǂݍ KRAM Ɋi[ */
  }
  
  InitPlayer();      /* vC[ϐ̏ */

  /* ގ */
  for (i = PLAYER_DUMMY; i < PLAYER_MAX; i++) {
    aMaterial[i].ambient  = 0x1000;
    aMaterial[i].diffuse  = 0x3000;
    aMaterial[i].specular = 0x1fff;
    AGLSetMaterial(&aMaterial[i], 1);
  }

  /* {XRAʒu */
  bosscoreLocate[0][LX] = FarlFloat1015(boss_minmax[MAXX]) * BOSS_BODY_RATIO;
  bosscoreLocate[0][LY] = 0;
  bosscoreLocate[0][LZ] = -FarlFloat1015(boss_minmax[MINY]);
  bosscoreLocate[1][LX] = 0;
  bosscoreLocate[1][LY] = FarlFloat1015(boss_minmax[MAXZ]) * BOSS_BODY_RATIO;
  bosscoreLocate[1][LZ] = -FarlFloat1015(boss_minmax[MINY]);
  bosscoreLocate[2][LX] = FarlFloat1015(boss_minmax[MINX]) * BOSS_BODY_RATIO;
  bosscoreLocate[2][LY] = 0;
  bosscoreLocate[2][LZ] = -FarlFloat1015(boss_minmax[MINY]);
  bosscoreLocate[3][LX] = 0;
  bosscoreLocate[3][LY] = FarlFloat1015(boss_minmax[MINZ]) * BOSS_BODY_RATIO;
  bosscoreLocate[3][LZ] = -FarlFloat1015(boss_minmax[MINY]);
}

/* 
----------------------------------------
  Q[Jn̏
----------------------------------------
*/
void
InitGame()
{
  int i;

  i = PLAYER1;
  /* ʒǔ */
  Locate[i][LX] = -5.0;
  Locate[i][LY] = 0.0;
  Locate[i][LZ] = 0.0;
  Machine[i].vector.x = 0.0;    /* init X moving vector */
  Machine[i].vector.y = 0.0;    /* init Y moving vector */
  Machine[i].vector.z = 0.0;    /* init Z moving vector */
  Machine[i].colvec.x = 0.0;    /* init X collision vector */
  Machine[i].colvec.y = 0.0;    /* init Y collision vector */
  Machine[i].colvec.z = 0.0;    /* init Z collision vector */
  Machine[i].direct = 900;        /* init degree of direction */
  Machine[i].fbflag = FB_STOP;  /* ~ */

  i = PLAYER2;
  /* ʒǔ */
  if (round == BOSS_ROUND) {
    Locate[i][LX] = 0.0;
    Locate[i][LZ] = 0.12;
  } else {
    Locate[i][LX] = 5.0;
    Locate[i][LZ] = 0.0;
  }
  Locate[i][LY] = 0.0;
  Machine[i].vector.x = 0.0;    /* init X moving vector */
  Machine[i].vector.y = 0.0;    /* init Y moving vector */
  Machine[i].vector.z = 0.0;    /* init Z moving vector */
  Machine[i].colvec.x = 0.0;    /* init X collision vector */
  Machine[i].colvec.y = 0.0;    /* init Y collision vector */
  Machine[i].colvec.z = 0.0;    /* init Z collision vector */
  Machine[i].direct = 2700;        /* init degree of direction */
  Machine[i].fbflag = FB_STOP;  /* ~ */

  InitGround(round);                /* nʊ֌W */
  InitCollision();                /* Փˊ֌W */
  gameTimer = 99;                /* Q[Ԃ̐ݒ */
  whichFall = PLAYER_DUMMY;        /* ǂĂȂ */

  /* 샋[`̓o^Ȇ̐ݒ */
  if (playmode == VSCOM) {
    SetDefaultCar(round);        /* round 1 */
    SetMachine(PLAYER1, MT_HUMAN); /* vC[͕Kl */
    SetMachine(PLAYER2, round); /* roundʖڂ̓G */
    Machine[PLAYER1].type->color = CarColor[MT_HUMAN];
    Machine[PLAYER2].type->color = CarColor[round];
  } else {
    SelectCar();
    SetMachine(PLAYER1, MT_HUMAN1);
    parfunc[machPlayer1](Machine[PLAYER1].type);
    SetMachine(PLAYER2, MT_HUMAN2);
    parfunc[machPlayer2](Machine[PLAYER2].type);
    PSGFadeOut();
  }
  dispoff(bg0);
  NowLoading();
  dispon(bg | spr);

  /* nʂ̃eNX`ǂݍ */
  /*
    ȑObotΐ킾珰eNX`[ǂ
   */
  if (oldplaymode == VSCOM){
    ReadTexture(FALSE, grname[round - 1], TBANK_GR); 
  }
  dispoff(bg0);
  ReadBG(backname[round - 1]);  /* wif[^̓ǂݍ */
  /* L̔Ɏgߌ݂̃[hۑB*/
  oldplaymode = playmode;
  /* Ô߂ɉʂXbv */
  ASLSync();
  AGLShot();
  MSLSync();
  /* wif[^̕\ */
  KINGScreen(0);
  KINGCylinder(KING_BG0, 1);
  KINGChangeSize0(DISP_WIDE);
  KINGDispOn();
  dispon(bg | spr | bg0);
}

/*
----------------------------------------
  Q[{
----------------------------------------
*/
LOCAL int
GameMain()
{
  get_pad();                        /* pbhZX */
  Pad00 = pad00;
  Pad10 = pad10;

  if ((Pad00.KD_TRG & KP_run) || (Pad10.KD_TRG & KP_run)) {
    VSyncUnset();
    PSGSeOff();
    Pause();
    VSyncSet(&TimerDecrement);
  }

  if (round != BOSS_ROUND) {
    if (ObjectMan() != FALSE)        /* o^[`ɂ铮p^[̏ */
      return TRUE;                /* ǂ */
  } else {                        /* {XEhʏ */
    if (BossObjectMan() != FALSE)
      return TRUE;                /* vC[{Xj󂳂ꂽ */
  }
  VSyncWait();
  SetGround();                        /* nʈʒuE傫vZ */
  if (playmode == VSCOM) {        /* 1P vs COM */
    SetCamera(PLAYER1);                /* Jݒ */
    /* IuWFNg` */
    if (round != BOSS_ROUND) {
      DrawObjects(0, 0, PLAYER2);
      DrawGround();
    } else
      BossDrawObjects();
  } else {                        /* 1P vs 2P */
#ifdef DOUBLEVIEW
    /* PLAYER1̎_ʏɕ` */
    FarlSetWindowClipReg(0, 0, 255, 119);
    FarlSetWindowScaleReg(128 * SCALE_PERS, 128, -128 * SCALE_PERS, 60);
    SetCamera(PLAYER1);
    DrawObjects(0, 0, PLAYER2);
    DrawGround();
    /* PLAYER2̎_ʉɕ` */
    FarlSetWindowClipReg(0, 120, 255, 239);
    FarlSetWindowScaleReg(128 * SCALE_PERS, 128, -128 * SCALE_PERS, 120 + 60);
    SetCamera(PLAYER2);
    DrawObjects(0, 0, PLAYER1);
    DrawGround();
#endif
#ifdef BIRDVIEW
    FarlSetWindowClipReg(0, 0, 255, 255);
    FarlSetWindowScaleReg(128 * SCALE_PERS, 128, -128 * SCALE_PERS, 128);
    SetCamera(PLAYER_DUMMY);
    DrawObjects(0, 0, PLAYER1);
    DrawObjects(0, 0, PLAYER2);
    DrawGround();
#endif
  }
  /* vC[Ƃ̏Ă */
  Machine[PLAYER1].manFunc(PLAYER1);
  Machine[PLAYER2].manFunc(PLAYER2);
  /* wiʒǔvZ */
  /* _gdvZȂ̂Ŋ荞݃[`Oōs */
  backpos1 
    = (short)(((3600 - Machine[PLAYER1].direct) / 10.0) * DEGPERDOTS);
  backpos2 
    = (short)(((3600 - Machine[PLAYER2].direct) / 10.0) * DEGPERDOTS);
  if (playmode == VSCOM)
    MSLPutDec(gameTimer, TIMER_X, TIMER_Y); /* c莞ԕ\ */
  else
    MSLPutDec(gameTimer, TIMER2_X, TIMER2_Y); /* c莞ԕ\ */
  {
    static int flag = FALSE;

    if ((Pad00.KD_TRG & KP_2)) {
      flag = TRUE;
      PSGSeOn(SE_ENGINE);
    }
    if (flag == TRUE && !(Pad00.KD_DAT & KP_2)) {
      flag = FALSE;
      PSGSeOn(SE_ENGINE_STOP);
    }
  }
  ASLSync();
  AGLShot();                        /* `ʌ */
  MSLSync();

  if (gameTimer <= 0)
    return TRUE;
  return FALSE;
}

/*
========================================
  EhEQ[I
========================================
*/
LOCAL void
GameMatch()
{
  if (playmode == VSCOM) {
    if (whichFall == PLAYER1) {
    /* 荞݂ɓo^Ă֐Ă΂Ȃ悤ɂ */
      VSyncUnset();                
      YouLost();
      GameOver();
    } else {
      if (round != BOSS_ROUND) {
        YouWon();
        dispoff(bg | spr | bg0);
        round++;
        return;
      } else
        PSGSeOff();
      BossBang();                /* {Xj */
    }
  } else {
    WhoWon();                        /* ΐ펞̏ */
  }
  ASLSync();                         /* XvCg */
  AGLShot();
  MSLSync();
  if (round >= ROUND_MAX) {
    /* {X̃eNX`܂Ă̂œǂ݂Ȃ */
    ReadTexture(FALSE, "dat/cartex/ctx4_1.aid", TBANK_P3);
    SetTextureBank(obj04_g, obj04_g_tindex, TBANK_P3);
  }
  Opening();
}

/*
========================================
  Q[
========================================
*/
void
game()
{
  Opening();
  while (1) {
    InitGame();
    BackScroll1();
    GameStart();
    /* Q[JnȂ̂Ń^C}[ZJn */
    if (playmode == VSCOM)
      MSLPutDec(gameTimer, TIMER_X, TIMER_Y);
    else
      MSLPutDec(gameTimer, TIMER2_X, TIMER2_Y);
    VSyncWait();
    VSyncSet(&TimerDecrement);
    if (playmode == VSCOM) {
      RasterOn(RASTER_SCROLL1);
    } else {
      RasterOn(RASTER_SCROLL1);
      RasterOn(RASTER_SCROLL2);
    }
    PSGStage(round);
    PSGSeOn(SE_IDLE);
    /* Q[Jn */
    while (1)
      if (GameMain())
        break;
    
    GameMatch();    /* s𔻒 */
    VSyncUnset();
    RasterOff(RASTER_SCROLL1);
    RasterOff(RASTER_SCROLL2);
  }
}
/*
----------------------------------------
  ^CgptHgZbg̓o^
  int fontset
    fontset: 0 tbgVF[fBOf
             1 O[[VF[fBOf
----------------------------------------
*/
LOCAL void
FontSet(int fontset)
{
  switch (fontset) {
    case 0:
      obj[0].geometryTop = (int *)alpha_b_f;
      obj[0].geometryLength = alpha_b_f_length / sizeof(int);
      obj[1].geometryTop = (int *)alpha_u_f;
      obj[1].geometryLength = alpha_u_f_length / sizeof(int);
      obj[2].geometryTop = (int *)alpha_l_f;
      obj[2].geometryLength = alpha_l_f_length / sizeof(int);
      obj[3].geometryTop = (int *)alpha_l_f;
      obj[3].geometryLength = alpha_l_f_length / sizeof(int);
      obj[4].geometryTop = (int *)alpha_y_f;
      obj[4].geometryLength = alpha_y_f_length / sizeof(int);
      obj[5].geometryTop = (int *)alpha_o_f;
      obj[5].geometryLength = alpha_o_f_length / sizeof(int);
      obj[6].geometryTop = (int *)alpha_f_f;
      obj[6].geometryLength = alpha_f_f_length / sizeof(int);
      obj[7].geometryTop = (int *)alpha_f_f;
      obj[7].geometryLength = alpha_f_f_length / sizeof(int);
      break;
    case 1:
      obj[0].geometryTop = (int *)alpha_b_g;
      obj[0].geometryLength = alpha_b_g_length / sizeof(int);
      obj[1].geometryTop = (int *)alpha_u_g;
      obj[1].geometryLength = alpha_u_g_length / sizeof(int);
      obj[2].geometryTop = (int *)alpha_l_g;
      obj[2].geometryLength = alpha_l_g_length / sizeof(int);
      obj[3].geometryTop = (int *)alpha_l_g;
      obj[3].geometryLength = alpha_l_g_length / sizeof(int);
      obj[4].geometryTop = (int *)alpha_y_g;
      obj[4].geometryLength = alpha_y_g_length / sizeof(int);
      obj[5].geometryTop = (int *)alpha_o_g;
      obj[5].geometryLength = alpha_o_g_length / sizeof(int);
      obj[6].geometryTop = (int *)alpha_f_g;
      obj[6].geometryLength = alpha_f_g_length / sizeof(int);
      obj[7].geometryTop = (int *)alpha_f_g;
      obj[7].geometryLength = alpha_f_g_length / sizeof(int);
      break;
  }
}
/*
----------------------------------------
  ^CgptHgZbg̏
----------------------------------------
*/
#define FLAT_FONT    0
#define GOURAUD_FONT 1
LOCAL void 
FontInit()
{
  int i;

  /* _̐ݒ */
  AGLResetCamera();
  AGLTranslateCamera(0, -0x10, 0);
  AGLRotateCameraX(900);
  AGLPerspectiveCamera(0xffc0 * SCALE_PERS);
  AGLZoomCamera(0x100, 0x100, 0x100);
  /* Cg */
  AGLResetLight(AGL_LIGHT0);
  AGLResetLight(AGL_LIGHT1);
  AGLSetLight(AGL_LIGHT0, 0xf000, 0xf000, 0x200, 0x6000);
  AGLRotateLightY(AGL_LIGHT0, 700);
  AGLRotateLightZ(AGL_LIGHT0, 3300);
  FontSet( FLAT_FONT );
  /* eϐ */
  iRotateAngle = 0;
  iFontColor = 1;
  BullyMaterial.ambient = 0x1000;
  BullyMaterial.diffuse = 0x6000;
  BullyMaterial.specular = 0x7fff;
  for (i = 0; i < STRLENGTH; i++ ) {
    BullySize[i] = 0x60;
    BullyZSize[i] = 0x60;
    BullyYPos[i] = 0.35;
    BullyXRot[i] = 0;
    obj[i].material = &BullyMaterial;
  }
  AGLSetMaterial(&BullyMaterial, 1);
}

/*
----------------------------------------
  ^CgtHgANV
----------------------------------------
*/
LOCAL void
FontMove()
{
  int i;
  static int fontset = FLAT_FONT;

  /* ̃[v */
  for (i = 0; i < STRLENGTH; i++) {
    AGLResetObj(&obj[i]);
    /* ftHgJ[ݒ */    
    FarlSetDefColorReg(0x1401 + i + iFontColor);
    /* XP[ */
    AGLScaleObj(&obj[i], 0x60, BullySize[i], BullyZSize[i]);
    /*  */
    AGLRotateObjX(&obj[i], 900);
    AGLRotateObjY(&obj[i], 0);
    AGLRotateObjZ(&obj[i], BullyXRot[i]);
    /* ʒu */
    AGLTranslateObj(&obj[i],
                    FarlFix187(BullyXPos[i]),
                    FarlFix187(0.06),  /* 0.06 */
                    FarlFix187(BullyYPos[i])
                    );
    /* ` */
    AGLFixPutObj(&obj[i]);
  }
  /* ̃[v */
  for (i = 0; i < STRLENGTH; i++) {
    /* ^C~ÔP  */
    if (iRotateAngle >= (20 * i) && iRotateAngle < (360 + 20 * i)) {
      BullyYPos[i] -= 0.01;
      BullyXRot[i] += 50; /* T܂ */
    }
    /* ^C~ÔQ  */
    if (iRotateAngle >= (360 + 20 * i) && iRotateAngle < (600 + 20 * i)) {
      BullyYPos[i] += 0.01;
      BullyXRot[i] += 50; /* T܂ */
    }
    /* ^C~ÔR ܂ */
    if (iRotateAngle >= (600 + 20 * i) && iRotateAngle < (780 + 20 * i)) {
      BullyYPos[i] -= 0.01;
      BullyXRot[i] += 50; /* T܂ */
    }
    /* ^C~ÔS ̏ŋt] */
    if (iRotateAngle >= (1600 + 20 * i) && iRotateAngle <= (1780 + 20 * i)) {
      BullyXRot[i] -= 200; /* QO܂ */
      /* TCYς iLтj */
      BullySize[i] += costbl[(iRotateAngle - 1600 - 20 * i)] * 5;
      BullyZSize[i] += costbl[(iRotateAngle - 1600 - 20 * i)] * 5;
    }
    /* ^C~ÔT k */
    if (iRotateAngle >= (1790 + 20 * i) && iRotateAngle <= (1970 + 20 * i)) {
      /* TCYς ikށj */
      BullySize[i] -= costbl[(iRotateAngle - 1790 - 20 * i)] * 5;
      BullyZSize[i] -= costbl[(iRotateAngle - 1790 - 20 * i)] * 5;
    }
    /* ^C~ÔU ɋA */
    if (iRotateAngle >= (2000 + 20 * i) && iRotateAngle < (2300 + 20 * i)) {
      BullyYPos[i] += 0.01;
      BullyXRot[i] += 50;
    }
    /* オꂽ狐剻 */
    if (pad10.KD_DAT & KP_up)
      BullySize[i] = 0x100;
    /* ꂽk */
    if (pad10.KD_DAT & KP_down)
      BullySize[i] = 0x20;
    /* Eꂽ猳ɖ߂ */
    if (pad10.KD_DAT & KP_left || pad10.KD_DAT & KP_right)
      BullySize[i] = 0x60;
  }
  /* ̏ł܂ƂɐFς */
  if (iRotateAngle == 1780) {
    iFontColor = (iFontColor + 1) & 0x07;
  }
  /* ^C~OJE^̑ */
  iRotateAngle += 10;
  /* Ōゾ珉 */
  if (iRotateAngle > 2500) {
    iRotateAngle = 0;
    for (i = 0; i < STRLENGTH; i++ ) {
      BullyYPos[i] = 0.35;
      BullyXRot[i] = 0;
    }
  }
  /* ZNgꂽFς */
  if (pad10.KD_TRG & KP_select)
    iFontColor = (iFontColor + 1) & 0x07;
  /* RUNꂽtHgς */
  if (pad10.KD_TRG & KP_run) {
    if (fontset == FLAT_FONT)
      fontset = GOURAUD_FONT;
    else
      fontset = FLAT_FONT;
    FontSet(fontset);
  }
}


/*
========================================
  ̓ɂ킹ĔwiXN[
  FȂ
  ߂lFȂ
========================================
*/
void
BackScroll1(void)
{
  KINGScroll(KING_BG0, backpos1 & 0x1ff, RASTER_SCROLL1);
}

void
BackScroll2(void)
{
  KINGScroll(KING_BG0, backpos2 & 0x1ff, RASTER_SCROLL2);
}
