/*
 * ground.c
 *
 * nʊ֌W
 */
#include "spec.h"
#include "vardecl.h"
#include "funcdecl.h"

/*
========================================
  nʊ֌W
========================================
*/
static time_t lim;

void
InitGround(int round)
{
  int i, j;

  lim = 0;
  GroundScale = DEFGRSCALE * OBJ_SCALE; /* nʂ̑傫̏ */
  GroundEdgeLoc = DEFGREDGE; /* nʒ[̍W */
  /*  */
  groundMaterial.ambient  = 0x3fff;
  groundMaterial.diffuse  = 0x3fff;
  groundMaterial.specular = 0x00ff;
  AGLSetMaterial(&groundMaterial, 1);
  for (i = GROUND0; i < GROUND_MAX; i++) {
    Ground[i].geometryTop = (int *)grdatTable[round - 1];
    Ground[i].geometryLength = grdatLength[round - 1];
    Ground[i].material = &groundMaterial;
  }
  /* nʈʒȕ */
  for (i = GROUND0; i < GROUND_MAX; i++) {
    int j;

    for (j = 0; j < 3; j++)
      GroundLoc[i][j] = OrigGroundLoc[i][j] * DEFGREDGE / OBJ_SCALE;
  }
}

/*
========================================
  nʈʒuEc莞Ԃɂ傫vZ
========================================
*/
#define TIMELIMIT (15)        /* nʂȂn߂鎞 */
#define LIM (TIMELIMIT * 10)	/* v */

void
SetGround()
{
  int i;
  time_t tim;

  /* c^C~bgɒBĂ邩H */
  tim = GetRestTime();
  if (tim >= TIMELIMIT)
    return;

  if (lim == 0)
    lim = LIM;

  GroundScale = (DEFGRSCALE * OBJ_SCALE * lim) / LIM;
  GroundEdgeLoc = (DEFGREDGE * lim) / LIM;

  for (i = GROUND0; i < GROUND_MAX; i++) {
    GroundLoc[i][LX] = 
      ((int)OrigGroundLoc[i][LX] * DEFGREDGE / OBJ_SCALE * lim) / LIM;
    GroundLoc[i][LY] = 
      ((int)OrigGroundLoc[i][LY] * DEFGREDGE / OBJ_SCALE * lim) / LIM;
  }
  lim--;
}
