/*
 * IuWFNg}l[W (object.c)
 */
#include <system.h>
#include <v93.h>
#include <nt.h>
#include <farl.h>
#include <agl.h>
#include <common.h>
#include "spec.h"
#include "vardecl.h"
#include "funcdecl.h"
#include "math.h"
#include "adpcm.h"

#ifndef LOCAL
#define LOCAL
#endif

/* 
----------------------------------------
  [Jϐ
----------------------------------------
*/
#define COL_COUNT (80)                /* ˕Ԃʎ */

LOCAL int ColCount;                /* ˕Ԃ莞ԃJE^ */

LOCAL struct colloc {                /* Փ˂_ */
  float x;
  float y;
} colloc;
 
/* 
========================================
  Փˊ֌W
========================================
*/
void
InitCollision()
{
  int i;

  ColCount = 0;                        /* ˕Ԃ莞ԃJE^ */
  for (i = 0; i < CORE_MAX; i++)
    destroy[i] = FALSE;                /* jRAtO */
  destroyBoss = FALSE;
}

/* 
========================================
  nʕ`
========================================
*/
void
DrawGround()
{
  register object *gp;
  int i;

  /* nʂ̃}gNXvZE` */
  for (i = GROUND0; i < GROUND_MAX; i++) {
    gp = &Ground[i];
    /* IuWFNg}gNX */
    AGLResetObj(gp);
    /* ftHgJ[ݒ */
    FarlSetDefColorReg(0x0801);
    /* XP[ݒ */
    AGLScaleObj(gp, GroundScale, GroundScale, 1);
    /* zu */
    AGLTranslateObj(gp,
                    GroundLoc[i][LX],
                    GroundLoc[i][LY],
                    GroundLoc[i][LZ] + 4);
    /* ] */
    AGLRotateObjX(gp, 1800);
    /* ` */
    AGLFixPutObj(gp);
  }
}

/* 
----------------------------------------
  Փ˔Tu
----------------------------------------
*/
LOCAL boolean
colsub()
{
  tvector new[4];
  register machine *mp1, *mp2;
   float cos, sin;
  int i, dir;

  mp1 = &Machine[PLAYER1];
  mp2 = &Machine[PLAYER2];
  dir = (3600 + mp2->direct - mp1->direct) % 3600;
  cos = costbl[dir];
  sin = sintbl[dir];

  /* K PLAYER1 ̍Wɂ킹 PLAYER2 ̍W]Eړ */
  new[0].x = cos * (-mp2->type->width) - sin * mp2->type->h_plus +
      Locate[PLAYER2][LX] - Locate[PLAYER1][LX];
  new[0].y = sin * (-mp2->type->width) + cos * mp2->type->h_plus +
      Locate[PLAYER2][LY] - Locate[PLAYER1][LY];

  new[1].x = cos * mp2->type->width - sin * mp2->type->h_plus +
      Locate[PLAYER2][LX] - Locate[PLAYER1][LX];
  new[1].y = sin * mp2->type->width + cos * mp2->type->h_plus +
      Locate[PLAYER2][LY] - Locate[PLAYER1][LY];

  new[2].x = cos * (-mp2->type->width) - sin * mp2->type->h_minus + 
      Locate[PLAYER2][LX] - Locate[PLAYER1][LX];
  new[2].y = sin * (-mp2->type->width) + cos * mp2->type->h_minus +
      Locate[PLAYER2][LY] - Locate[PLAYER1][LY];

  new[3].x = cos * mp2->type->width - sin * mp2->type->h_minus +
      Locate[PLAYER2][LX] - Locate[PLAYER1][LX];
  new[3].y = sin * mp2->type->width + cos * mp2->type->h_minus +
      Locate[PLAYER2][LY] - Locate[PLAYER1][LY];

  for (i = 0; i < 4; i++) {
    /* PLAYER1̐K`PLAYER2 ̒_NĂՓ˂Ă */
    if (mp1->type->width >= new[i].x && mp1->type->h_plus >= new[i].y
        && new[i].x >= -mp1->type->width && new[i].y >= mp1->type->h_minus) {
      colloc.x = new[i].x;
      colloc.y = new[i].y;
      return TRUE;
    }
  }

  dir = (3600 + mp1->direct - mp2->direct) % 3600;
  cos = costbl[dir];
  sin = sintbl[dir];

  /* K PLAYER2 ̍Wɂ킹 PLAYER1 ̍W]Eړ */
  new[0].x = cos * (-mp1->type->width) - sin * mp1->type->h_plus +
      Locate[PLAYER1][LX] - Locate[PLAYER2][LX];
  new[0].y = sin * (-mp1->type->width) + cos * mp1->type->h_plus +
      Locate[PLAYER1][LY] - Locate[PLAYER2][LY];
  
  new[1].x = cos * mp1->type->width - sin * mp1->type->h_plus +
      Locate[PLAYER1][LX] - Locate[PLAYER2][LX];
  new[1].y = sin * mp1->type->width + cos * mp1->type->h_plus +
      Locate[PLAYER1][LY] - Locate[PLAYER2][LY];
  
  new[2].x = cos * (-mp1->type->width) - sin * mp1->type->h_minus +
      Locate[PLAYER1][LX] - Locate[PLAYER2][LX];
  new[2].y = sin * (-mp1->type->width) + cos * mp1->type->h_minus +
      Locate[PLAYER1][LY] - Locate[PLAYER2][LY];
  
  new[3].x = cos * mp1->type->width - sin * mp1->type->h_minus +
      Locate[PLAYER1][LX] - Locate[PLAYER2][LX];
  new[3].y = sin * mp1->type->width + cos * mp1->type->h_minus +
      Locate[PLAYER1][LY] - Locate[PLAYER2][LY];

  for (i = 0; i < 4; i++) {
    /* PLAYER2̐K`PLAYER1 ̒_NĂՓ˂Ă */
    if (mp2->type->width >= new[i].x && mp2->type->h_plus >= new[i].y
        && new[i].x >= -mp2->type->width && new[i].y >= mp2->type->h_minus) {
      colloc.x = new[i].x;
      colloc.y = new[i].y;
      return TRUE;
    }
  }

  return FALSE;
}

/*
----------------------------------------
  2̂̏̕Փ
----------------------------------------
*/
LOCAL void
IfCollision()
{
  /* Փ˂Ă */
  if (colsub()) {
    register machine *mp1, *mp2;
    float gammax1, gammay1, gammax2, gammay2;
    int i;

    /* ՓˌʎԂ̃Zbg */
    ColCount = COL_COUNT;

    mp1 = &Machine[PLAYER1];
    mp2 = &Machine[PLAYER2];
    
    /* ̐is̉x */
    mp1->colvec.x = mp1->type->Bounce * mp2->vector.x;
    mp1->colvec.y = mp1->type->Bounce * mp2->vector.y;
    mp2->colvec.x = mp2->type->Bounce * mp1->vector.x;
    mp2->colvec.y = mp2->type->Bounce * mp1->vector.y;

    /*
     * Փˎ̉]
     */
    for (i = PLAYER1; i < PLAYER_MAX; i++) {
      register machine *mp;
      float x, y;

      /* ՓˍW̐K */
      mp = &Machine[i];
      /* _t] */
      x = costbl[mp->direct] * colloc.x + sintbl[mp->direct] * colloc.y; 
      y = costbl[mp->direct] * colloc.y - sintbl[mp->direct] * colloc.x; 

      if ((x > 0.0 && y > 0.0) || (x < 0.0 && y < 0.0)) { /* 1,3ی */
        mp->direct += mp->type->Handling * 2; /* ] */
        x = costbl[mp->type->Handling * 2] * mp->vector.x
            - sintbl[mp->type->Handling * 2] * mp->vector.y;
        y = sintbl[mp->type->Handling * 2] * mp->vector.x
            + costbl[mp->type->Handling * 2] * mp->vector.y;
      } else { /* 2,4ی */
        mp->direct -= mp->type->Handling * 2; /* E] */
        x = costbl[mp->type->Handling * 2] * mp->vector.x
            + sintbl[mp->type->Handling * 2] * mp->vector.y;
        y = -sintbl[mp->type->Handling * 2] * mp->vector.x
            + costbl[mp->type->Handling * 2] * mp->vector.y;
      }
      mp->vector.x = x;
      mp->vector.y = y;
      /* pxC */
      if (mp->direct < 0)
        mp->direct += 3600;
      mp->direct %= 3600;
    }
    /*
     * ՓˉĐ xN^̑傫ɂĈႤɂȂ
     */
    {
      register machine *mp1, *mp2;
      int vec;
      int vel;

      mp1 = &Machine[PLAYER1];
      mp2 = &Machine[PLAYER2];
      vec = GETA_RAD * sqrt((mp1->vector.x + mp2->vector.x)
                 * (mp1->vector.x + mp2->vector.x)
                 + (mp1->vector.y + mp2->vector.y)
                 * (mp1->vector.y + mp2->vector.y));
      if (vec < 20)
        vel = 0;
      else if (vec < 50)
        vel = 2;
      else if (vec < 80)
        vel = 4;
      else
        vel = 6;
      AdpcmVolume(CHANNEL_1, MAX_PCM_VOLUME - vel, MAX_PCM_VOLUME - vel);
      AdpcmPlay(CHANNEL_1, &pInfo[P_HIT3]);
    }
  }
}

/*
========================================
  IuWFNgړEՓˁE
========================================
*/
boolean
ObjectMan()
{
  int i;

  IfCollision();
  for (i = PLAYER1; i < PLAYER_MAX; i++) {
    register machine *mp = &Machine[i];

    if (ColCount-- <= 0)
      ColCount = 0;
    if (ColCount == 0) {
      /* Փ˃xN^̃Zbg */
      mp->colvec.x = mp->colvec.y = mp->colvec.z = 0.0; 
    } else {
      /* Փ˃xN^ */
      mp->colvec.x = mp->colvec.x * ColCount / COL_COUNT;
      mp->colvec.y = mp->colvec.y * ColCount / COL_COUNT;
      mp->colvec.z = mp->colvec.z * ColCount / COL_COUNT;
      if (ColCount < COL_COUNT - 5 && ColCount > COL_COUNT - 9) {
        AdpcmVolume(CHANNEL_2, MAX_PCM_VOLUME, MAX_PCM_VOLUME);
        AdpcmPlay(CHANNEL_2, &pInfo[P_SLIP1]);
      }
    }
    /* Փ˃xN^̉Z */
    Locate[i][LX] += mp->colvec.x;
    Locate[i][LY] += mp->colvec.y;
    Locate[i][LZ] += mp->colvec.z;

    Locate[i][LX] += mp->vector.x; /* ړxN^ɂ X W̏C */
    Locate[i][LY] += mp->vector.y; /* ړxN^ɂ Y W̏C */
    Locate[i][LZ] += mp->vector.z; /* ړxN^ɂ Z W̏C */
  }
  return IfFall();
}

/*
========================================
  IuWFNg`

  
  rotx X]p
  roty Y]p
  which ǂPLAYER\邩
       PLAYER1
       PLAYER2
  ߂l
  Ȃ
========================================
*/
void
DrawObjects(int rotx, int roty, int which)
{
  register machine *mp;
  register object *gp;
  int i;

  /* Ԃ̃}gNXvZ */
  mp = &Machine[which];
  AGLResetObj(&mp->type->obj);        /* IuWFNg}gNX */
  FarlSetDefColorReg(mp->type->color);        /* ftHgJ[ݒ */
  
  /* XP[ */
  AGLScaleObj(&mp->type->obj, SCALE_CAR, SCALE_CAR, SCALE_CAR);
  /*  */
  /* قcɉ */
  AGLRotateObjX(&mp->type->obj, 
    (900 + ((rotx > 0 && which == whichFall) ? rotx : 0)) % 3600); 
  AGLRotateObjY(&mp->type->obj,
    ((roty > 0 && which == whichFall) ? roty : 0)); 
  AGLRotateObjZ(&mp->type->obj, mp->direct);
  /* ʒu */
  AGLTranslateObj(&mp->type->obj,
                  FarlFix187(Locate[which][LX]),
                  FarlFix187(Locate[which][LY]),
                  FarlFix187(Locate[which][LZ]));
  /* ` */
  AGLFixPutObj(&mp->type->obj);
}

/************************************************************/
/************************************************************/

/* 
----------------------------------------
  {XƂ̏Փ˔ {̂Ƃ̏Փ
----------------------------------------
*/
#define BOSS_CRAW_RATIO (0.9)

LOCAL boolean
BossColsub()
{
  static tvector new[4];
  register machine *mp1, *mp2;
  float cos, sin;
  int i, dir;

  mp1 = &Machine[PLAYER1];
  mp2 = &Machine[PLAYER2];

  /* RA̓蔻 */

  cos = costbl[3600 - mp1->direct];
  sin = sintbl[3600 - mp1->direct];

  for (i = 0; i < CORE_MAX; i++) {
    float x, y, cx, cy;
    float cos2, sin2;

    /* RǍ݈ʒu߂ */
    cos2 = costbl[mp2->direct];
    sin2 = sintbl[mp2->direct];
    cx = cos2 * bosscoreLocate[i][LX] - sin2 * bosscoreLocate[i][LY];
    cy = sin2 * bosscoreLocate[i][LX] + cos2 * bosscoreLocate[i][LY];

    /* vC[̍W𐳋KɂƂȂRA̍Wړ */
    x = cos * (cx - Locate[PLAYER1][LX]) - sin * (cy - Locate[PLAYER1][LY]);
    y = sin * (cx - Locate[PLAYER1][LX]) + cos * (cy - Locate[PLAYER1][LY]);

    /* vC[̐K`ɃRA̒S_NĂ
       RAɏՓ˂Ă */
    if (destroy[i] == FALSE
        && mp1->type->width >= x && mp1->type->h_plus >= y
        && x >= -mp1->type->width && y >= mp1->type->h_minus) {
      destroy[i] = TRUE;
      AdpcmVolume(CHANNEL_1, MAX_PCM_VOLUME, MAX_PCM_VOLUME);
      AdpcmPlay(CHANNEL_1, &pInfo[P_COREBREAK]);
      return TRUE;
    }
  }

  /* {̂̓蔻 */

  dir = (3600 + mp1->direct - mp2->direct) % 3600;
  cos = costbl[dir];
  sin = sintbl[dir];

  /* K{X̍Wɂ킹 PLAYER1 ̍W]Eړ */
  new[0].x = cos * (-mp1->type->width) - sin * mp1->type->h_plus
          + Locate[PLAYER1][LX] - Locate[PLAYER2][LX];
  new[0].y = sin * (-mp1->type->width) + cos * mp1->type->h_plus
          + Locate[PLAYER1][LY] - Locate[PLAYER2][LY];
  
  new[1].x = cos * mp1->type->width - sin * mp1->type->h_plus
          + Locate[PLAYER1][LX] - Locate[PLAYER2][LX];
  new[1].y = sin * mp1->type->width + cos * mp1->type->h_plus
          + Locate[PLAYER1][LY] - Locate[PLAYER2][LY];
  
  new[2].x = cos * (-mp1->type->width) - sin * mp1->type->h_minus
          + Locate[PLAYER1][LX] - Locate[PLAYER2][LX];
  new[2].y = sin * (-mp1->type->width) + cos * mp1->type->h_minus
          + Locate[PLAYER1][LY] - Locate[PLAYER2][LY];
  
  new[3].x = cos * mp1->type->width - sin * mp1->type->h_minus
          + Locate[PLAYER1][LX] - Locate[PLAYER2][LX];
  new[3].y = sin * mp1->type->width + cos * mp1->type->h_minus
          + Locate[PLAYER1][LY] - Locate[PLAYER2][LY];

  for (i = 0; i < 4; i++) {
    /* {X̐K{̋`PLAYER1̒_NĂՓ˂Ă */
    if (mp2->type->width * BOSS_BODY_RATIO >= new[i].x
        && mp2->type->h_plus * BOSS_BODY_RATIO >= new[i].y
        && new[i].x >= -mp2->type->width * BOSS_BODY_RATIO 
        && new[i].y >= mp2->type->h_minus * BOSS_BODY_RATIO) {
      colloc.x = new[i].x;
      colloc.y = new[i].y;
      return TRUE;
    }
  }

  /* p̓蔻 */

  dir = (3600 + mp2->direct - mp1->direct) % 3600;
  cos = costbl[dir];
  sin = sintbl[dir];

  /* K PLAYER1 ̍Wɂ킹ă{X̍W]Eړ */
  new[0].x = cos * (-mp2->type->width) - sin * mp2->type->h_plus
          + Locate[PLAYER2][LX] - Locate[PLAYER1][LX];
  new[0].y = sin * (-mp2->type->width) + cos * mp2->type->h_plus
          + Locate[PLAYER2][LY] - Locate[PLAYER1][LY];
  
  new[1].x = cos * mp2->type->width - sin * mp2->type->h_plus
          + Locate[PLAYER2][LX] - Locate[PLAYER1][LX];
  new[1].y = sin * mp2->type->width + cos * mp2->type->h_plus
          + Locate[PLAYER2][LY] - Locate[PLAYER1][LY];
  
  new[2].x = cos * (-mp2->type->width) - sin * mp2->type->h_minus
          + Locate[PLAYER2][LX] - Locate[PLAYER1][LX];
  new[2].y = sin * (-mp2->type->width) + cos * mp2->type->h_minus
          + Locate[PLAYER2][LY] - Locate[PLAYER1][LY];
  
  new[3].x = cos * mp2->type->width - sin * mp2->type->h_minus
          + Locate[PLAYER2][LX] - Locate[PLAYER1][LX];
  new[3].y = sin * mp2->type->width + cos * mp2->type->h_minus
          + Locate[PLAYER2][LY] - Locate[PLAYER1][LY];

  for (i = 0; i < 4; i++) {
    /* PLAYER1 ̐K` PLAYER2 ̒_NĂ
       {X̊pՓ˂Ă */
    if (mp1->type->width >= new[i].x * BOSS_CRAW_RATIO
        && mp1->type->h_plus >= new[i].y * BOSS_CRAW_RATIO
        && new[i].x >= -mp1->type->width * BOSS_CRAW_RATIO
        && new[i].y >= mp1->type->h_minus * BOSS_CRAW_RATIO) {
      colloc.x = new[i].x;
      colloc.y = new[i].y;
      return TRUE;
    }
  }


  return FALSE;
}

/* 
----------------------------------------
  {XƂ̏Փ
----------------------------------------
*/
LOCAL void
IfBossCollision()
{
  if (BossColsub()) {
    register machine *mp1, *mp2;
    float gammax1, gammay1, gammax2, gammay2;
    int i;

    /* ՓˌʎԂ̃Zbg */
    ColCount = COL_COUNT;

    mp1 = &Machine[PLAYER1];        /* vC[ */
    mp2 = &Machine[PLAYER2];        /* {X */
   
    /* ̉x{X̔ˌWɂĒ˕Ԃ */
    mp1->colvec.x = mp2->type->Bounce * -mp1->vector.x;
    mp1->colvec.y = mp2->type->Bounce * -mp1->vector.y;
    /*
     * Փˎ̉]
     */
    for (i = PLAYER1; i < PLAYER_MAX; i++) {
      register machine *mp;
      float x, y;

      /* ՓˍW̐K */
      mp = &Machine[i];
      /* _t] */
      x = costbl[mp->direct] * colloc.x + sintbl[mp->direct] * colloc.y; 
      y = costbl[mp->direct] * colloc.y - sintbl[mp->direct] * colloc.x; 

      if ((x > 0.0 && y > 0.0) || (x < 0.0 && y < 0.0)) { /* 1,3ی */
        mp->direct += mp->type->Handling * 2; /* ] */
        x = costbl[mp->type->Handling * 2] * mp->vector.x
            - sintbl[mp->type->Handling * 2] * mp->vector.y;
        y = sintbl[mp->type->Handling * 2] * mp->vector.x
            + costbl[mp->type->Handling * 2] * mp->vector.y;
      } else { /* 2,4ی */
        mp->direct -= mp->type->Handling * 2; /* E] */
        x = costbl[mp->type->Handling * 2] * mp->vector.x
            + sintbl[mp->type->Handling * 2] * mp->vector.y;
        y = -sintbl[mp->type->Handling * 2] * mp->vector.x
            + costbl[mp->type->Handling * 2] * mp->vector.y;
      }
      mp->vector.x = x;
      mp->vector.y = y;
      /* pxC */
      if (mp->direct < 0)
        mp->direct += 3600;
      mp->direct %= 3600;
    }
    /*
     * ՓˉĐ xN^̑傫ɂĈႤɂȂ
     */
    {
      register machine *mp1, *mp2;
      int vec;
      int vel;

      mp1 = &Machine[PLAYER1];
      mp2 = &Machine[PLAYER2];
      vec = GETA_RAD * sqrt((mp1->vector.x + mp2->vector.x)
            * (mp1->vector.x + mp2->vector.x)
            + (mp1->vector.y + mp2->vector.y) 
            * (mp1->vector.y + mp2->vector.y));
      if (vec < 20)
        vel = 0;
      else if (vec < 50)
        vel = 2;
      else if (vec < 80)
        vel = 4;
      else
        vel = 6;
      AdpcmVolume(CHANNEL_1, MAX_PCM_VOLUME - vel, MAX_PCM_VOLUME - vel);
      AdpcmPlay(CHANNEL_1, &pInfo[P_HIT3]);
    }
  }
}

/* 
========================================
  {XEhpIuWFNg}l[W
========================================
*/
boolean
BossObjectMan()
{
  /* Փ˂ɂړΏۂ̓vC[̂ */
  register machine *mp = &Machine[PLAYER1]; 
  int i;

  IfBossCollision();

  if (ColCount-- <= 0)
    ColCount = 0;
  if (ColCount == 0) {
    /* Փ˃xN^̃Zbg */
    mp->colvec.x = mp->colvec.y = mp->colvec.z = 0.0; 
  } else {
    /* Փ˃xN^ */
    mp->colvec.x = mp->colvec.x * ColCount / COL_COUNT;
    mp->colvec.y = mp->colvec.y * ColCount / COL_COUNT;
    mp->colvec.z = mp->colvec.z * ColCount / COL_COUNT;
    if (ColCount < COL_COUNT - 5 && ColCount > COL_COUNT - 9) {
      AdpcmVolume(CHANNEL_2, MAX_PCM_VOLUME, MAX_PCM_VOLUME);
      AdpcmPlay(CHANNEL_2, &pInfo[P_SLIP1]);
    }
  }
  /* Փ˃xN^̉Z ˕Ԃ̂̓vC[̂ */
  Locate[PLAYER1][LX] += mp->colvec.x;
  Locate[PLAYER1][LY] += mp->colvec.y;
  Locate[PLAYER1][LZ] += mp->colvec.z;
  
  Locate[PLAYER1][LX] += mp->vector.x; /* ړxN^ɂ X W̏C */
  Locate[PLAYER1][LY] += mp->vector.y; /* ړxN^ɂ Y W̏C */
  Locate[PLAYER1][LZ] += mp->vector.z; /* ړxN^ɂ Z W̏C */

  {
    int i, count;

    /* RAׂ͂Ĕj󂳂ꂽ */
    for (count = 0, i = 0; i < CORE_MAX; i++) {        
      if (destroy[i] == TRUE)
        count++;
    }
    if (count == CORE_MAX) {
      destroyBoss = TRUE;        /* {X͔j󂳂ꂽ */
      return TRUE;
    }
    destroyBoss = FALSE;
  }
  return IfFall();                /* vC[ */
}

/* 
========================================
  {XEhpIuWFNg`
========================================
*/
void
BossDrawObjects()
{
  register machine *mp;
  register object *gp;
  int i, which;

  /* {X{̂̃}gNXvZ */
  mp = &Machine[PLAYER2];
  AGLResetObj(&mp->type->obj); /* IuWFNg}gNX */
  FarlSetDefColorReg(mp->type->color); /* ftHgJ[ݒ */

  /* XP[ */
  AGLScaleObj(&mp->type->obj, SCALE_CAR, SCALE_CAR, SCALE_CAR);
  /*  */
  AGLRotateObjX(&mp->type->obj, 900);
  AGLRotateObjZ(&mp->type->obj, mp->direct);
  /* ʒu */
  AGLTranslateObj(&mp->type->obj,
                  FarlFix187(Locate[PLAYER2][LX]),
                  FarlFix187(Locate[PLAYER2][LY]),
                  FarlFix187(Locate[PLAYER2][LZ]));
  /* ` */
  AGLFixPutObj(&mp->type->obj);

  /* {XRA}gNXvZE\ */
  for (i = 0; i < CORE_MAX; i++) {
    static object Obj;
    int dir;
    float cos, sin;

    if (destroy[i] == TRUE)        /* RAj󂳂Ă\Ȃ */
      continue;

    Obj.geometryTop = (int *)bosscore;
    Obj.geometryLength = bosscoreLength;
    Obj.material = &groundMaterial;

    dir = Machine[PLAYER2].direct;
    cos = costbl[dir];
    sin = sintbl[dir];

    AGLResetObj(&Obj);
    FarlSetDefColorReg(0x0505);        /*  */
    AGLScaleObj(&Obj, 0x4, 0x4, 0x4);
    AGLRotateObjX(&Obj, 900);
    AGLRotateObjZ(&Obj, dir);
    AGLTranslateObj(&Obj, 
        FarlFix187(cos * bosscoreLocate[i][LX] - sin * bosscoreLocate[i][LY]),
        FarlFix187(sin * bosscoreLocate[i][LX] + cos * bosscoreLocate[i][LY]),
        FarlFix187(bosscoreLocate[i][LZ])
        );
    AGLFixPutObj(&Obj);
  }
  
  DrawGround();                        /* nʕ` */
}
