/*
 * psg.c
 */
#include <system.h>
#include <v93.h>
#include <vpsg.h>
#include <intlib.h>
#include "spec.h"
#include "psgdef.h"

/*
  orf荞ݏ̑I
  #define __USE_RASTER__ ɂƃX^[쓮
  #undef  __USE_RASTER__ ɂƃ^C}[쓮
  ɂȂ܂B
  */
#define __USE_RASTER__

unsigned char cStageMusic[] = {
  0x01,		        /* _~[ */
  MU_STAGE1,		/* 1 */
  MU_STAGE2,		/* 2 */
  MU_STAGE3,		/* 3 */
};

/*
========================================
  X^[荞݋쓮[`
  KȃX^[ɓo^Ďg܂B
  ͂P^PQO^C~ŐȂĝ
  130X^[ɌĂяo悤
  Qo^Ďg܂B
========================================
*/
void
PSGInt()
{
  psg_drvcall();
}
/*
========================================
  ^C}[荞݃[`
  P^PQOb̃^C~OŌĂяo܂
  FȂ
  ߂lFȂ
========================================
*/
void interrupt
TimerInt(void)
{
  regsave   r1-r31;
  _put_timer_tcr(0x0003);
  irq_disable();
  psg_drvcall();
  irq_enable();
}

/*
========================================
  PSG 
  FȂ
  ߂lFȂ
========================================
*/
void
PSGInit()
{
  /* orfhCo[̏AAhXݒ */
  psg_drvinit();
  psg_dataset((struct vpsgdata *)PSG_STARTADDRESS);
  psg_priset((unsigned char *)(*((unsigned char *)PSG_PRIADDRESS)));
  /* 荞݃[`̒ǉAJn */
#ifdef __USE_RASTER__
  RasterSetOn(RASTER_PSG1,&PSGInt);
  RasterSetOn(RASTER_PSG2,&PSGInt);
#else
  IrqSet(TimerInt,XINT_TIM);
  /* PQÔPb荞݃^C~O̍ */
  /* PJEg 1 / 1431818 (b) Ȃ̂ŁC   */
  /*  (1/120) / (1/1431818) = 11932           */
  _put_timer_tmr(11932);  
  _put_timer_tcr(0x0001);
  _put_timer_tcr(0x0003);
  IrqOn(XINT_TIM);
#endif
  psg_drvon();
}
