/*
 * spec.h
 *
 * 萔,\̒`wb_
 */

#ifndef __SPEC_H__
#define __SPEC_H__

#include <agl.h>

#define RASTER_PSG1 (18)   	/* PSG 쓮X^ԍ1 */
#define RASTER_PSG2 (147)	/* PSG 쓮X^ԍ2 */
/* 1P vs 2P pwiXN[JnX^ */
#define RASTER_SCROLL1 (0)
#define RASTER_SCROLL2 (140)

#define TABLEMIN (0)		/* e[u̐擪 */
#define TABLESIZ (128)		/*   u[L Ȃǂ̃e[uTCY */

#define OBJ_SCALE (2)

#define DEFGREDGE (6.0)		/* nʂ̒[̍Wl */
#define DEFGRSCALE (0xC0)	/* nʂ̑傫l */

/* eNX`obt@ 0-7 Ng */
#define TBANK_GR (0)		/* use 0 */
#define TBANK_FONT (1)		/* use 1 */
#define TBANK_P1 (2)		/* use 2, 3 */
#define TBANK_P2 (4)		/* use 4, 5 */
#define TBANK_P3 (6)		/* use 6, 7 */
#define TBANK_MAX (8)

#define MIN_RAD (0.001)		/* ŏړP */
#define MAX_RAD (10.0)		/* őړP */
#define GETA_RAD (1000.0)	/* xK̃Q^ 1/MIN_RAD */

/* ݂̐is */
#define FB_FORWARD (1)
#define FB_STOP (0)
#define FB_BACKWARD (-1)

/* JAO */
#define CAM_ANGLE (900)		/* 90x */
/* J{ */
#define CAM_ZOOM (0x200)	/* 512{ */
/* p[X */
#define SCALE_PERS (2)
/* Ԃ̃XP[ */
#define SCALE_CAR (0x40)	/* 1/2{ */

#define TIMER_X (96)		/* 1P vs COM c莞 X \ʒu */
#define TIMER_Y (0)		/* 1P vs COM c莞 Y \ʒu */

#define TIMER2_X (192)		/* 1P vs 2P c莞 X \ʒu */
#define TIMER2_Y (0)		/* 1P vs 2P c莞 Y \ʒu */

#define RADAR_X1   (20)    /* [_[̈ʒu */
#define RADAR_Y1   (22)    /* [_[̈ʒu */
#define RADAR_X2   (20)    /* [_[̈ʒu */
#define RADAR_Y2   (142)    /* [_[̈ʒu */

#define GROUND0 (0)
#define GROUND_MAX (64)

#define ROUND_MAX (3)		/* SEh */
#define CORE_MAX (4)		/* {XRAő吔 */
#define BOSS_BODY_RATIO (0.7)	/* {X{̋`̊ */

typedef float distance;		/* P */
typedef float accel_t;		/* xP */
typedef unsigned int degree;	/* P */
typedef unsigned int time_t;	/* ԒP */
typedef int handle;
typedef int direct_t;
typedef void (*mfunc_t)(int);	/* ֐|C^ */

/****************************************
  DOUBLEVIEW  define  2ʃ[hɂȂ܂B
  BIRDVIEW  define Ɛ^ォ猩[hɂȂ܂B
   define Ă͂܂B
****************************************/
#define DOUBLEVIEW
#undef BIRDVIEW

typedef enum {
    FALSE,
    TRUE,
} boolean;

typedef enum {			/* Q[@ */
  VSCOM,			/* 1P vs COM */
  VSPLAYER,			/* 1P vs 2P */
} playmode_t;

enum {				/* vC[ʗp */
  PLAYER_DUMMY,			/* @Ip_~[ */
  PLAYER1,
  PLAYER2,
  PLAYER_MAX,
};

enum MachType {			/* @̎ */
  MT_HUMAN,			/* 1P vs COM p */
  MT_DWARF,
  MT_ELF,
  MT_BOSS,
  MT_HUMAN1,			/* 1P vs 2P p 1P  */
  MT_HUMAN2,			/* 1P vs 2P p 2P  */
  MACHINE_MAX,
};

enum {				/* location */
  LX, LY, LZ,
};

enum {				/* object minmax table index */
  MINX, MINY, MINZ, MAXX, MAXY, MAXZ,
};

typedef struct {
  float x;
  float y;
  float z;
} tvector;

typedef struct {
  object obj;
  float AccTable[TABLESIZ];	/* e[u */
  float EngBrakeTable[TABLESIZ]; /* e[u */
  float BrakeTable[TABLESIZ];	/* u[Le[u */
  handle Handling;		/* nhOW */
  float Bounce;			/* ˌW */
  float width;			/* @̂̉ */
  float h_plus;			/* @̂̐ */
  float h_minus;		/* @̂̕ */
  int color;			/* @̐F */
} machtype;

typedef void (*pfunc_t)(machtype *); /* p[^֐ւ̃|C^ */

typedef struct {
  machtype *type;
  tvector vector;		/* ړxN^ */
  tvector colvec;		/* Փ˃xN^ */
  direct_t direct;		/* ݌Ă */
  short fbflag;			/* OiEރtO */
  mfunc_t manFunc;		/* ֐ւ̃|C^ */
} machine;

/* Sɑ΂Ă̋ */
typedef struct {
  distance  dFrontDist;		/* O */
  distance  dBackDist;		/*  */
  distance  dLeftDist;		/*  */
  distance  dRightDist;		/* E */
} QuadDist;

/* @̂̃C[W */
typedef struct {
  unsigned char *MachineName;   /* O */
  char AccelLevel;              /*  */
  char BrakeLevel;              /* u[L */
  char Handling;                /* nhO */
  char Weight;                  /* di˕Ԃj */
} machimage;

#endif /* __SPEC_H__ */
