/*
 * texture.c
 */
#include <farl.h>
#include <pio.h>
#include "funcdecl.h"
#include "vardecl.h"

/*
========================================
  eNX`obt@֓]

  addr: eNX`f[^̃AhX
  bank: ]oN
========================================
*/
void
SetTexture(unsigned short *addr, int bank)
{
  int x, y;
      
  FarlSetMemReg(FARL_CMT_BANK_SELECT_REG, bank);
  for (y = 0; y < 256; y++)
    for (x = 0; x < 256; x++)
      FarlWriteTxtXYUnpk(x, y, *(addr + x + y * 256));
}

/* 
========================================
  pbNgeNX`obt@֓]

  addr: eNX`f[^̃AhX
  bank: ]oN
========================================
*/
void
SetPackedTexture(unsigned short *addr, int bank)
{
  int x, y;
      
  FarlSetMemReg(FARL_CMT_BANK_SELECT_REG, bank);
  for (y = 0; y < 256; y++)
    for (x = 0; x < 256; x++)
      FarlWriteTxtXY(x, y, *(addr + x + y * 256));
}

 
/* 
========================================
  IuWFNgf[^̃eNX`oNI؂ւ

  objAddr: IuWFNgf[^擪AhX
  bankOffsetTable: QƃeNX`oN
                   IuWFNgf[^擪AhX
                   ItZbge[u
  bank: ̃oNpɏ

  QƃeNX`oÑf[^͑ΓIɏ邽
  0/1 łȂ΂ȂȂ
========================================
*/
void
SetTextureBank(unsigned short *objAddr, int *bankOffsetTable, int bank)
{
  int i;

  for (i = 0; bankOffsetTable[i] != -1; i++) {
    /* 
     * eNX`oNɑ΂Đf[^ǂm߂
     */
    if (objAddr[bankOffsetTable[i] + 1] > 7) {
      pio_putstr("illegal bank value ");
      pio_putstr(ultoh((unsigned long)&objAddr[bankOffsetTable[i] + 1]));
      pio_putstr(" (");
      pio_putstr(ultoh(objAddr[bankOffsetTable[i] + 1]));
      pio_putstr(")\n");
      _exit();
    }      
    /* ܂ĂȂ珑 */
    if (objAddr[bankOffsetTable[i] + 1] < TBANK_P1)
      objAddr[bankOffsetTable[i] + 1] += bank;
  }
}
