/* C code produced by gperf version 2.1 (K&R C version) */
/* Command-line: gperf -gtopT -K code -N in_note_set noteset.inp  */


/*
 * noteset.inp
 *
 * $Revision: 1.3 $
 */

#include <string.h>
#include "type.h"

#define MIN_WORD_LENGTH 1
#define MAX_WORD_LENGTH 2
#define MIN_HASH_VALUE 1
#define MAX_HASH_VALUE 61
/*
   28 keywords
   61 is the maximum key range
*/

#ifdef __GNUC__
inline
#endif
static int
hash (str, len)
     register char *str;
     register unsigned int  len;
{
  static unsigned char hash_table[] =
    {
     61, 61, 61, 61, 61, 61, 61, 61, 61, 61,
     61, 61, 61, 61, 61, 61, 61, 61, 61, 61,
     61, 61, 61, 61, 61, 61, 61, 61, 61, 61,
     61, 61, 61, 61, 61, 10, 61, 61, 61, 61,
     61, 61, 61,  5, 61,  0, 61, 61, 61, 61,
     61, 61, 61, 61, 61, 61, 61, 61, 61, 61,
     61, 61, 61, 61, 61, 61, 61, 61, 61, 61,
     61, 61, 61, 61, 61, 61, 61, 61, 61, 61,
     61, 61, 61, 61, 61, 61, 61, 61, 61, 61,
     61, 61, 61, 61, 61, 61, 61,  4, 22, 15,
     30, 23, 16,  0, 61, 61, 61, 61, 61, 61,
     61, 61, 61, 61, 61, 61, 61, 61, 61, 61,
     61, 61, 61, 61, 61, 61, 61, 61,
    };
  return len + hash_table[str[len - 1]] + hash_table[str[0]];
}

#ifdef __GNUC__
inline
#endif
struct CODE *
in_note_set (str, len)
     register char *str;
     register unsigned int len;
{

  static struct CODE  wordlist[] =
    {
      {"",}, 
      {"g", 	7},
      {"g-", 	6},
      {"",}, {"",}, {"",}, 
      {"a-", 	8},
      {"g+", 	8},
      {"",}, 
      {"a", 	9},
      {"",}, 
      {"a+", 	10},
      {"g#", 	8},
      {"",}, {"",}, {"",}, 
      {"a#", 	10},
      {"c-", 	-1},
      {"f-", 	4},
      {"",}, {"",}, {"",}, 
      {"c+", 	1},
      {"f+", 	6},
      {"b-", 	10},
      {"e-", 	3},
      {"",}, 
      {"c#", 	1},
      {"f#", 	6},
      {"b+", 	12},
      {"e+", 	5},
      {"c", 	0},
      {"d-", 	1},
      {"f", 	5},
      {"b#", 	12},
      {"e#", 	5},
      {"",}, 
      {"d+", 	3},
      {"",}, {"",}, {"",}, {"",}, 
      {"d#", 	3},
      {"",}, {"",}, 
      {"b", 	11},
      {"",}, 
      {"e", 	4},
      {"",}, {"",}, {"",}, {"",}, {"",}, {"",}, {"",}, {"",}, {"",}, 
      {"",}, {"",}, {"",}, {"",}, 
      {"d", 	2},
    };

  if (len <= MAX_WORD_LENGTH && len >= MIN_WORD_LENGTH)
    {
      register int key = hash (str, len);

      if (key <= MAX_HASH_VALUE && key >= MIN_HASH_VALUE)
        {
          register char *s = wordlist[key].code;

          if (*s == *str && !strcmp (str + 1, s + 1))
            return &wordlist[key];
        }
    }
  return 0;
}
