/*

 */
#include <system.h>
#include <v93.h>
#include <sup.h>
#include <mouse.h>
#include "libm.h"
#include "intlib.h"

#define SUP_XMAX    32			/* HuC6270-BG  */
#define SUP_YMAX    32			/* HuC6270-BG c */
#define SAT_TOP     0x2000		/* SAT擪AhX */
#define SAT_SIZE    0x2 * 4		/* SATɂPɕKvȃTCY */
#define PATTERN_TOP 0x4000		/* SPRITEp^[擪AhX */
#define SPRITE_TOP  (PATTERN_TOP >> 5)	/* p^[ԍ擪 */
#define FONT_TOP    0x0400		/* HuC6270-BG tHg擪AhX */

struct SAT {				/* SAT \ */
  unsigned short pos_y;			/* xW */
  unsigned short pos_x;			/* wW */
  unsigned short pattern_no;		/* p^[ԍ */
  unsigned char  color;			/* XvCgJ[ */
  unsigned char  spbg;			/* SP:1 /BG:0 D揇 */
  unsigned char  cgx;			/* 0:16dot 1:32dot */
  unsigned char  x_bar;			/* 0:ʏ 1:] */
  unsigned char  cgy;			/* c 0:16 1:32 2:48 3:64 dot */
  unsigned char  y_bar;			/* 0:ʏ 1:c] */
};

extern unsigned short KINGBack[];	/* HuC6272 wi */
extern unsigned short KINGColor[];	/* J[pbg */
extern unsigned short SUPBack[];	/* HuC6270 wi */
extern unsigned short SUPSprite[];	/* XvCgp^[ */
void DeviceSet(void);
void SUPClear(char);
void SUPLine(char, char);
void SUPSatClear(void);
void SUPSatWrite(struct SAT *sat_entry, unsigned short dist_no);
void shoot(void);

/*------------------------------------------------------------------


  ------------------------------------------------------------------*/
char shot;				/* ^}ꂽǂ */
unsigned short tmpX;			/* ^}̂wW */
unsigned short tmpY = 0;		/* ^}̂xW */
struct SAT     tmp_att;			/* ^}̂r`s */
/*------------------------------------------------------------------


  ------------------------------------------------------------------*/
void
main(void)
{
  int i;
  unsigned char counter;		/* Aj[Vp */
  struct SCRL70 scrl70;			/* XN[p\ */
  struct SAT    sprite_att;		/* @r`s */
  struct SAT    fire_att;		/* Ήr`s */

  DeviceSet();				/* ݒ */
  init_get_mouse(0x0001,60);

  /* sprite param. set */
  sprite_att.pos_x = 100;
  sprite_att.pos_y = 100;
  sprite_att.pattern_no = SPRITE_TOP;
  sprite_att.color = 0;
  sprite_att.spbg = 0;
  sprite_att.cgx = 0;
  sprite_att.x_bar = 0;
  sprite_att.cgy = 0;
  sprite_att.y_bar = 0;

  mouse_curst(100,100,0);
  mouse_limit(0+32,0+64,256,240,0);

  fire_att.pos_x = 100 - 16;
  fire_att.pos_y = 100;
  fire_att.pattern_no = SPRITE_TOP + 2;
  fire_att.color = 0;
  fire_att.spbg = 0;
  fire_att.cgx = 0;
  fire_att.x_bar = 0;
  fire_att.cgy = 0;
  fire_att.y_bar = 0;

  tmp_att.pos_y = 0;
  tmp_att.pattern_no = SPRITE_TOP + 6;
  tmp_att.color = 0;
  tmp_att.spbg = 0;
  tmp_att.cgx = 0;
  tmp_att.x_bar = 0;
  tmp_att.cgy = 0;
  tmp_att.y_bar = 0;

  /* sprite put */
  SUPSatWrite(&sprite_att, 0);		/* @r`s */
  SUPSatWrite(&fire_att, 1);		/* Ήr`s */
  /* dummy */
  get_mouse_pad();
  
  shot = 0;				/* ^}͌ĂȂ */
  /* main routin */
  for (i = 0; i <= 512; i++){		/* [v */
    get_mouse_pad();			/* pbh */
    i = i & 0x1ff;			/* iv[vɂ邽 */
    KINGScroll(0, (i / 2) & 0xff, 0);	/* HuC6272 XN[ */
    scrl70.bxr70 = i & 0xff;
    scrl70.byr70 = 0;
    set_70_scrl(&scrl70, DEV70A);	/* HuC6270 XN[ */
    if (mouse_getdt(0) & MOUSE_LSW && shot == 0) { /* {^Fire! */
      shot = 1;				/* ^} */
      tmpX = sprite_att.pos_x + 16;	/* ̍W */
      tmpY = sprite_att.pos_y;
    }
    /* E{^ςȂŃ_bVI */
    if (mouse_getdt(0) & MOUSE_RSW)
	mouse_mickey(1200,0);
    else
    	mouse_mickey(400,0);

    /* ʒuW̏ */
    sprite_att.pos_y = mouse_curgt(0) & 0xffff;
    sprite_att.pos_x = mouse_curgt(0) >> 16;

    /* Ήʒu */
    fire_att.pos_y = sprite_att.pos_y;
    fire_att.pos_x = sprite_att.pos_x - 16;
    /* ΉAj[V */
    fire_att.pattern_no = SPRITE_TOP + 2 + ((counter & 0x04) >> 1);
    /* ^}ĂȂA */
    if (shot == 1) shoot();
    /* r`s */
    SUPSatWrite(&sprite_att, 0);
    SUPSatWrite(&fire_att, 1);
    /* UÔPb҂ */
    sat_trans_trg(SAT_TOP, DEV70A);	/* XvCg\v */
    VSyncWait();
    /* JE^[𑝂₷ */
    counter++;
  }
}

/*------------------------------------------------------------------
  I
  ------------------------------------------------------------------*/
void
shoot(void)
{
    /* ʒu */
    tmp_att.pos_x = tmpX;
    tmp_att.pos_y = tmpY;
    /* Oɐi߂ */
    tmpX += 4;
    /* ʊO܂ōs^}͌ĂȂƂɂ */
    if(tmpX > 280){
        shot = 0;
        tmp_att.pos_y = 0;
    }
    /* r`s */
    SUPSatWrite(&tmp_att, 2);
}
/*------------------------------------------------------------------
  
  ------------------------------------------------------------------*/
void
DeviceSet(void)
{
  /*  */
  DevInit();
  RasterInit();
  init_70();
  /* \It */
  dispoff(bg0 | bg1 | bg2 | bg3 | bg | spr | rain);
  /* HuC6272 ݒ */
  KINGScreen(2);		/* hbg256F + OubN256F */
  KINGCylinder(0, 1);		/* [h */
  KINGCls(0);			/* hbgʃNA */
  KINGCls(2);			/* OubNʃNA */
  KINGTrans(0, KINGBack, 1);	/* hbgʂɔwi] */
  fill_kram(0x20000, 0x0000, 0xefff); /* OubNʃtHgNA */
  /* HuC6261 J[pbgݒ */
  write_pallet_datas(0, KINGColor, 256);
  /* HuC6261 XvCgJ[pbgݒ */
  write_pallet_datas(0x100, KINGColor, 256);
  /* HuC6270 ݒ */
  /* aftHg]iWPXQoCgj */
  mram_to_vram(FONT_TOP, SUPBack, 8192 / sizeof(short), DEV70A);
  /* XvCg] iWPXQoCgj*/
  SUPSatClear();		/* r`sNA */
  mram_to_vram(PATTERN_TOP, SUPSprite, /* XvCgtHg] */
	       8192 / sizeof(short), DEV70A);
  set_70_mode(SPR_BG_ON, DEV70A); /* XvCg^af\I */
  SUPClear(0x40);		/* afʂ0x40i󔒃tHgj Fill */
  SUPLine(26, 0x41);		/* ʍ쐬 */
  SUPLine(27, 0x43);
  SUPLine(28, 0x43);
  SUPLine(29, 0x43);
  /* 荞ݐݒ */
  /* pbh */
  init_get_mouse(0x0001,60);
  init_mouse_reset_check(0,0);
  /* pbh̓[`荞݋쓮[`ɓo^ */
  IrqSet(int_pad, XINT_KP);
  IrqOn(XINT_KP);                /* KPort 荞݂L */
  IrqOn(XINT_72);                /* HuC6272 荞݂L */
  irq_enable();                        /* 荞݂ */
  /* \I */
  dispon(bg0 | bg | spr);
}
/*------------------------------------------------------------------
  HuC6270 afʂɑ΂PCɃLN^ׂ
  ------------------------------------------------------------------*/
void
SUPLine(char y, char chnum)
{
  unsigned short supAddress;

  supAddress = SUP_XMAX * y;
  fill_vram(supAddress, (unsigned short)chnum, SUP_YMAX, DEV70A);
}
/*------------------------------------------------------------------
  HuC6270 afʂwLN^ŃNA
  iRQ~RQ[ĥ݁j
  ------------------------------------------------------------------*/
void
SUPClear(char chnum)
{
  fill_vram(0, (unsigned short)chnum, SUP_XMAX * SUP_YMAX, DEV70A);
}
/*------------------------------------------------------------------
  r`s
  ------------------------------------------------------------------*/
void
SUPSatWrite(struct SAT *sat_entry, unsigned short dist_no)
{
  unsigned short satentry[4];
  unsigned short write_address;

  satentry[0] = sat_entry->pos_y & 0x3ff;
  satentry[1] = sat_entry->pos_x & 0x3ff;
  satentry[2] = sat_entry->pattern_no & 0x7ff;
  satentry[3] = sat_entry->color & 0x0f;
  satentry[3] |= (sat_entry->spbg & 1) << 7 || (sat_entry->cgx & 1) << 8;
  satentry[3] |= (sat_entry->x_bar & 1) << 11 || (sat_entry->cgy & 2) << 12;
  satentry[3] |= (sat_entry->y_bar & 1) << 15;
  write_address = SAT_TOP + SAT_SIZE * dist_no;
  mram_to_vram(write_address, satentry, SAT_SIZE, DEV70A);
}
/*------------------------------------------------------------------
  r`sNA
  ------------------------------------------------------------------*/
void
SUPSatClear(void)
{
  fill_vram(SAT_TOP, 0x00, SAT_SIZE * 64, DEV70A);
}
