/*
 * LIST.C Version 1.01 (C)1996 HUDSON SOFT
 * MIX ĐTvvO t@CXg(LIST.C)
 */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "mixplay.h"

filelist far *file_list_top = NULL;

/* t@CXgɒǉ܂B
 *
 * 
 * char		    *name  ǉt@C
 *
 * o
 * Ȃ
 */
void add_file_list(char *name)
{
    unsigned long l,ln;
    filelist far *lp,far *gp;
    char mesbuf[256];
    if (!file_exist_check(name)) {
	sprintf(mesbuf,"t@C(%s)܂",name);
	error(mesbuf);
    }
    ln = sizeof(filelist) + strlen(name);
    if ((gp = my_malloc(ln)) == NULL) error("܂");
    l = get_file_size(name);
    gp->next = NULL;
    gp->lsize = (l + 2047L) & 0xfffff800;
    if (!gp->lsize) gp->lsize = 2048;
    gp->psize = l;
    gp->sec_len = gp->lsize >> 11;
    gp->type = 0x04;
    _fstrcpy(gp->name,(char far *)name);
    if (file_list_top) {
	lp = file_list_top;
	while (lp->next != NULL) lp = lp->next;
	lp->next = gp;
	gp->sec_top = lp->sec_end + 1;
	gp->sec_end = gp->sec_top + gp->sec_len - 1;
	gp->track = lp->track + 1;
    } else {
	file_list_top = gp;
	gp->sec_top = 0;
	gp->sec_end = gp->sec_len - 1;
	gp->track = 1;
    }
}

/* t@CXgJ܂B
 *
 * 
 * Ȃ
 *
 * o
 * Ȃ
 */
void free_file_list(void)
{
    filelist far *p0,far *p1;
    for(p0 = file_list_top;p0;) {
	p1 = p0->next;
	my_free(p0);
	p0 = p1;
    }
    file_list_top = NULL;
}

/* w肵ZN^܂ރt@CXg̃|C^߂܂B
 *
 * 
 * unsigned long    sec    ZN^ʒu
 *
 * o
 * filelist far *   NULL   Xg͈̔͊O
 *		    LO Xg̃|C^
 */
filelist far *get_sec_list(unsigned long sec)
{
    filelist far *p;
    for (p = file_list_top;p;) {
	if ((sec >= p->sec_top) && (sec <= p->sec_end)) break;
	p = p->next;
    }
    return(p);
}

/* w肵gbNɑ΂t@CXg̃|C^߂܂B
 *
 * 
 * int		    trk    gbNԍ
 *
 * o
 * filelist far *   NULL   Xg͈̔͊O
 *		    LO Xg̃|C^
 */
filelist far *get_track_list(int trk)
{
    filelist far *p;
    for (p = file_list_top;p;) {
	if (trk == p->track) break;
	p = p->next;
    }
    return(p);
}
