/*
 * MISC.C Version 1.01 (C)1996 HUDSON SOFT
 * MIX ĐTvvOʊ֐Q(MISC.C)
 */
#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>
#include <dos.h>
#include <dir.h>
#include "mixplay.h"

/* fobO[h̏ꍇɂ̂݃bZ[W\܂B
 *
 * 
 * char		    *fmt   printftH[}bg
 * ...		    ...    
 *
 * o
 * Ȃ
 */
void dprintf(char *fmt, ...)
{
    va_list arg;
    if (debug_flag) {
	va_start(arg,fmt);
	vprintf(fmt,arg);
	va_end(arg);
    }
}

/* t@C̑݃`FbNs܂B
 *
 * 
 * char		    *file  `FbNt@C
 *
 * o
 * int		    0      t@C݂Ȃ
 *		    0 ȊO t@C݂
 */
int file_exist_check(char *file)
{
    struct find_t fb;
    if (_dos_findfirst(file,_A_NORMAL,&fb)) return(FALSE);
    if (fb.attrib & (_A_VOLID | _A_SUBDIR)) return(FALSE);
    return(TRUE);
}

/* t@C̒𒲂ׂ܂B
 *
 * 
 * char		    *file  ׂt@C
 *
 * o
 * unsigned long	   t@C̒
 */
unsigned long get_file_size(char *file)
{
    struct find_t fb;
    if (_dos_findfirst(file,_A_NORMAL,&fb)) return(0L);
    if (fb.attrib & (_A_VOLID | _A_SUBDIR)) return(0L);
    return(fb.size);
}

/* Q BCD lʏ̐lɕϊ܂B
 *
 * 
 * int              bcd    BCD l
 *
 * o
 * int		    0 ȏ ϊl
 *		    ̐ ϊłȂ
 */
int bcd2bin(int bcd)
{
    int rs;
    rs = (bcd >> 4);
    if (rs > 9) return(-1);
    bcd &= 0x0f;
    if (bcd > 9) return(-1);
    return(rs * 10 + bcd);
}

/* ʏ̐lQ BCD lɕϊ܂B
 *
 * 
 * int              bcd    ʏ̐l
 *
 * o
 * int		    0 ȏ ϊ BCD l
 *		    ̐ ϊłȂ
 */
int bin2bcd(int bin)
{
    int rs;
    if ((bin < 0) | (bin > 99)) return(-1);
    rs = bin / 10;
    bin %= 10;
    return((rs << 4) + bin);
}

/* DOS 烁mۂ܂B
 *
 * 
 * unsigned long    sz     mۂTCY
 *
 * o
 * void far *	    NULL   mۂłȂ
 *		    LO mۂ̃|C^
 */
void far *my_malloc(unsigned long sz)
{
    unsigned int psz,seg;
    psz = ((sz + 15L) >> 4) & 0xffff;
    if (!psz) return((void far *)NULL);
    if (_dos_allocmem(psz,&seg) != 0) return((void far *)NULL);
    return(MK_FP(seg,0));
}

/* DOS mۂJ܂B
 *
 * 
 * void far         *ptr   J郁
 *
 * o
 * Ȃ
 */
void my_free(void far *ptr)
{
    _dos_freemem(FP_SEG(ptr));
}

/* t@CV[N܂B
 *
 * 
 * int		    fhd    V[Nt@Cnh
 * long		    ofs    V[NItZbg
 * int		    from   V[N̊_
 *
 * o
 * Ȃ
 */
void my_seek(int fhd,long ofs,int from)
{
    asm push bx
    asm push cx
    asm mov bx,fhd
    asm mov ax,from
    asm mov ah,042h
    asm mov dx,word ptr ofs
    asm mov cx,word ptr ofs+2
    asm int 21h
    asm pop cx
    asm pop bx
}

/* foCXɑ΂IOCTLs܂B
 *
 * 
 * int		    fhd    IOCTLt@Cnh
 * int		    fnc    IOCTL@\ԍ
 * void far	    *ptr   f[^|C^
 * int		    len    f[^
 *
 * o
 * int		    ??     ]
 */
int my_ioctl(int fhd,int fnc,void far *buf,int len)
{
    asm push ds
    asm push bx
    asm push cx
    asm mov bx,fhd
    asm mov ax,fnc
    asm mov ah,044h
    asm mov cx,len
    asm lds dx,buf
    asm int 21h
    asm jnc my_ioctl_ok
    asm sbb ax,ax
my_ioctl_ok:
    asm pop cx
    asm pop bx
    asm pop ds
    return(_AX);
}

/* pX̃hCuAfBNgcAt@CAgqւ
 * B
 *
 * 
 * char		    *src   ̃pX
 * char		    *name  Vt@C
 * char		    *ext   Vgq
 * char		    *buf   VpX̊i[|C^
 *
 * o
 * Ȃ
 */
void change_file_ext(char *src,char *name,char *ext,char *buf)
{
    char drive[MAXDRIVE];
    char dir[MAXDIR];
    fnsplit(src,drive,dir,NULL,NULL);
    fnmerge(buf,drive,dir,name,ext);
}
