/*
 * MIXLIB.C Version 1.00 (C)1996 HUDSON SOFT
 * MIX ĐCu֐(MIXLIB.C)
 */

/* K-RAM ̐擪AhX̒`
 * KG_kram_A ADPCM #0Ɠ
 * KG_kram_B ADPCM #1
 */
#define	KG_kram_A		0x00000000
#define	KG_kram_B		0x00020000

#include    <system.h>
#include    <scsi.h>
#include    <nt.h>
#include    <king_kr.h>
#include    <king_ks.h>
#include    <soundbox.h>
#include    "cdrscsi.h"
#include    "mixlib.h"

/* sXe[^X */
#define	MIX_PLAY_STATUS_WAIT	0
#define	MIX_PLAY_STATUS_EXEC	1

/* t@C̃wb_TCY */
#define	MAX_MIX_HEAD		128

/* K-RAM ̑傫i16bit P[hƂ̃[hj */
#define	KRAM_SIZE		(128*1024)

/* ubNiO`PTjɂ _KR_TSR A_KR_LEN ɏޒl̕\
 * ubN͓t@C̃wb_擾܂B
 */
static unsigned int	mix_dct[16][2] = {
    (8*1),  15,	    /* 0 */
    (8*15), 1,	    /* 1 */
    (8*14), 2,	    /* 2 */
    (8*13), 3,	    /* 3 */
    (8*12), 4,	    /* 4 */
    (8*11), 5,	    /* 5 */
    (8*10), 6,	    /* 6 */
    (8*9),  7,	    /* 7 */
    (8*8),  8,	    /* 8 */
    (8*7),  9,	    /* 9 */
    (8*6),  10,	    /* 10 */
    (8*5),  11,	    /* 11 */
    (8*4),  12,	    /* 12 */
    (8*3),  13,	    /* 13 */
    (8*2),  14,	    /* 14 */
    (8*1),  15,	    /* 15 */
};

/* f[^ǂݍׂ݂̈̃[Nϐ */
int			mix_tsr_ofs=0;
static unsigned int	mix_dct_tsr;
static unsigned int	mix_dct_len;
unsigned int		mix_play_errt=0;

/* ADPCM Đׂ̈̃p[^\ */
static struct KS adpcm = {
    0x00,				/* unsigned short	ksmode;   */
    0x07,				/* unsigned short	kscr0;	  */
    0x07,				/* unsigned short	kscr1;	  */
    (KG_kram_A|0)>>8,			/* unsigned short	ksstart0; */
    (KG_kram_A|(KRAM_SIZE)-1),		/* unsigned long	ksend0;   */
    (KG_kram_A|(KRAM_SIZE/2))>>6,	/* unsigned short	kshalf0;  */
    (KG_kram_B|0)>>8,		 	/* unsigned short	ksstart1; */
    (KG_kram_B|(KRAM_SIZE)-1),	 	/* unsigned long	ksend1;   */
    (KG_kram_B|(KRAM_SIZE/2))>>6,	/* unsigned short	kshalf1;  */
};

/* ADPCM ̍ĐԂ[Nϐ */
static unsigned int	adpcm_flag[2]={
    0,
    0,
};

/* Đׂ̈̃[Nϐ */
static int		mix_play_status=MIX_PLAY_STATUS_WAIT;
static unsigned int	mix_play_vsync=0;
static int		mix_play_scsi=0;
static MIX_HEAD		*mix_play_mixp=NULL;

/* read28() ׂ̈̍\ */
READ28	read28_stat;

/* A̓ǂݍ݈ʒuAĐʒu𐧌䂷郏[Nϐ */
static unsigned int	*read_mixp;
static unsigned int	*disp_mixp;
static unsigned int	read_adp[2];
static unsigned int	exec_adp[2];
static unsigned int	read_dct;
static unsigned int	exec_dct;
static unsigned int	disp_dct;
static unsigned int	back_dct;
static int		read_exec;

/* w ADPCM ̍Đw܂B
 * ۂ̍ĐJn mix_play_adpcm_check() ōsȂ܂B
 *
 * ́F
 * int		    ch;    Đ ADPCM ̃`lԍ
 *
 * óF
 * Ȃ
 */
static void	mix_play_adpcm_exec(ch)
int	ch;
{
    adpcm_flag[ch]=1;
}

/* w ADPCM ̒~w܂B
 * ۂ̍Đ~ mix_play_adpcm_check() ōsȂ܂B
 *
 * ́F
 * int		    ch;    ~ ADPCM ̃`lԍ
 *
 * óF
 * Ȃ
 */
static void	mix_play_adpcm_stop(ch)
int	ch;
{
    adpcm_flag[ch]=0;
}

/* ADPCM ̍ĐԂ[Nϐ ADPCM ̍ĐJnƍĐ~sȂ
 * B
 *
 * ́F
 * Ȃ
 *
 * óF
 * Ȃ
 */
static void	mix_play_adpcm_check(void)
{
    unsigned int	ch;
    unsigned int	ef;
    unsigned int	mm;
    unsigned int	mode_back;
    unsigned int	mode_next;

    ef = 0 ;
    mode_back = adpcm.ksmode ;
    mode_next = adpcm.ksmode ;

    for ( ch=0 ; ch < 2 ; ch++ ) {
	mm = (0x01 << ch) ;
	if ( adpcm_flag[ch] != 0 ) {
	    mode_next |= mm ;
	} else {
	    mode_next &= ~mm ;
	}
    }
    if ( mode_back == mode_next ) {
	return;
    }

    adpcm.ksmode = mode_next;
    set_ks_pram(&adpcm);
}

/* read28() ɂobNOEh CD-ROM ǂݍ݂Jn܂B
 *
 * ́F
 * int		    id;    CD-ROMi^[Qbgj SCSI ID
 * unsigned int	    sect;  ǂݍ݊JnubNʒu
 * unsigned int	    size;  ǂݍ݃ubN
 *
 * óF
 * int		    0      ǂݍ݂Jnꂽ
 *		    -1     ǂݍ݂Ɏs
 */
static int	mix_read_start(id,sect,size)
int		id;
unsigned int	sect;
unsigned int	size;
{
    read28_stat.id_bit = (0x01<<id);
    read28_stat.block = sect;
    read28_stat.blklen = size;
    return( open_read28( &read28_stat ) );
}

/* K-RAM ɓǂݍ܂ꂽf[^Af[^̓]𐧌䂵AĐJnAĐ~
 * sȂ܂B
 *
 * ȉ̏Ԃɂꍇ͉ȂŖ߂܂B
 *  ĚĂяo read28()  CD-ROM ǂݍݒ̏ꍇ
 *  E̕\t[^C~OɒBĂȂꍇ
 *  E\ׂf[^܂ǂݍ܂ĂȂꍇ
 *
 * ȉ̏Ԃɂꍇ͍ĐI܂B
 *  EɍĐׂf[^Af[^̏IɒBꍇ
 *
 * ȉ̏Ԃɂꍇ͍Đ𒆒fĈُI܂B
 *  Ef[^̕\Ԃɍ킸\t[^C~OʂzĂ܂ꍇ
 *
 * ́F
 * Ȃ
 *
 * óF
 * Ȃ
 */
static void	mix_disp()
{
    unsigned int	disp;
    unsigned int	rsiz;
    unsigned int	rpos;
    unsigned int	vsync_next;

    if ( mix_play_vsync == 0 ) {	/* ̌ĂяoH */
	switch( read28_stat.stat ) {
	case READ28_READ:
	    return;			/* ܂ǂݍݒłΉȂ */
	default:
	    mix_play_vsync = vsync_count ;
	    break;			/* Ǎς݂łΌ݂̕\t[ */
	}				/* ^C~OL^ďp */
    }

    if ( mix_play_vsync > vsync_count ) {
	return;				/* ̕\^C~OɒBĂȂ */
    }

    switch( (mix_play_mixp->fps) ) {	/* PbԂ̃t[Ɏ̕\ */
    case  1:	vsync_next=60;	break;	/* t[^C~O߂ */
    case  2:	vsync_next=30;	break;
    case  3:	vsync_next=20;	break;
    case  4:	vsync_next=15;	break;
    case  5:	vsync_next=12;	break;
    case  6:	vsync_next=10;	break;
    case 10:	vsync_next=6;	break;
    case 12:	vsync_next=5;	break;
    case 15:	vsync_next=4;	break;
    case 20:	vsync_next=3;	break;
    case 30:	vsync_next=2;	break;
    case 60:	vsync_next=1;	break;
    default:	vsync_next=2;	break;
    }

    disp=*disp_mixp;			/* f[^ƃf[^擾 */
    rsiz = (disp & MIX_SZM);
    rsiz /= 2 ;				/* f[^ */

    if ((disp >> MIX_CHS) == MIX_EOF) {	/* f[^IR[hȂ */
	mix_play_status = MIX_PLAY_STATUS_WAIT ;
	mix_play_adpcm_stop(0);
	mix_play_adpcm_stop(1);
	mix_play_adpcm_check();		/* ׂĂ̍Đ~ďI */
	return;
    }
    if ( read_mixp == disp_mixp ) {
	return;				/* \ׂf[^܂ǂݍ܂ */
    }					/* ĂȂ */

    disp_mixp++;			/* \f[^ʒuXV */

    switch( (disp >> MIX_CHS) ) {	/* f[^ɂ菈I */
    case MIX_NUL:
	break;				/* Ȃ */
    case MIX_NOP:
	mix_play_vsync += vsync_next;	/* ̃^C~O܂ő҂ */
	if ( mix_play_vsync < vsync_count ) {
	    mix_play_errt = 1 ;		/* \ԂɍȂG[ */
	}
	break;
    case MIX_AdL:
	mix_play_adpcm_exec(0);		/* ADPCM `lĐ */
	exec_adp[0] += rsiz ;
	break;
    case MIX_AnL:
	mix_play_adpcm_stop(0);		/* ADPCM `l~ */
	break;
    case MIX_AdR:
	mix_play_adpcm_exec(1);		/* ADPCM E`lĐ */
	exec_adp[1] += rsiz ;
	break;
    case MIX_AnR:
	mix_play_adpcm_stop(1);		/* ADPCM E`l~ */
	break;
    case MIX_DCT:
	back_dct = disp_dct;		/* ̍Đ */
	rpos = exec_dct ;
	disp_dct = rpos;
	exec_dct = rpos+rsiz;
	if ( rpos == 0 ) {
	    __OUTPORTH( IO_KING_AR,_KR_TSR);
	    __OUTPORTH( IO_KING_DR,mix_dct_tsr+mix_tsr_ofs);
	    __OUTPORTH( IO_KING_AR,_KR_LEN);
	    __OUTPORTH( IO_KING_DR,mix_dct_len);
	    set_kr_trans(KR_TRANS_ON);
	}
	rpos %= KRAM_SIZE;
	mix_play_vsync += vsync_next;
	if ( mix_play_vsync < vsync_count ) {
	    mix_play_errt = 1 ;		/* \ԂɍȂG[ */
	}
	__OUTPORTH( IO_KING_AR,_KR_TSA );
	__OUTPORTW( IO_KING_DR,(KG_kram_A|rpos) );
	break;
    }
    mix_play_adpcm_check();		/* ADPCM ̍Đ^~̐ */
}

/* SCSI  DMA ]N܂B
 *
 *  mix_read() Ă΂ DMA ]Nꂽ́ADMA ]I荞
 * ݂̏[`Å֐Ăяo DMA ]p܂B
 *
 * K-RAM Đf[^Ŗ܂ DMA ]IĂ܂ꍇ mix_read() 
 * 炱̊֐Ăяo DMA ]ĊJ܂B
 *
 * ́F
 * Ȃ
 *
 * óF
 * Ȃ
 */
void	mix_read_int()
{
    unsigned int	read;
    unsigned int	rsiz;
    unsigned int	rpos;
    unsigned int	tmp ;

    if ( read28_stat.stat == READ28_IDLE ) {
					/* ̓]Jn҂̏Ԃ̎̂ */
	if ( read_exec != 0 ) {
	    read_exec = 0 ;		/* O̓ǂݍݎs̒Ȃ */
	    read_mixp++;		/* ǂݍ݈ʒuO̕i߂ */
	}

	for(;;){			/* f[^ǂݍނ܂ŌJԂ */
	    __OUTPORTH(IO_KING_AR, _KRAM_ARR);
	    __OUTPORTW(IO_KING_DR, 0);
	    __OUTPORTH(IO_KING_AR, _KRAM_DATA);
	    tmp=__INPORTH(IO_KING_DR);	/* 荞ݏ̏ꍇ̂ */
	    tmp=__INPORTH(IO_KING_DR);	/* K-RAM ̃_~[ANZXsȂ */
	    tmp=__INPORTH(IO_KING_DR);	/*  K-RAM ANZXۏ؂ */
	    tmp=__INPORTH(IO_KING_DR);

	    read=*read_mixp;		/* ݂̓Ǎʒu̐f[^ƒ */
	    rsiz = (read & MIX_SZM);
	    rsiz /= 2 ;			/* ǂݍޒ */

	    switch( (read >> MIX_CHS) ) {
	    case MIX_EOF:
		return;			/* f[^IR[h */
	    case MIX_NOP:
		read_mixp++;		/* ǂރf[^̂Ŏɐi߂ */
		break;
	    case MIX_AdL:
		rpos = read_adp[0] ;	/* ADPCM ̍`lǂ */
		if ( (rpos+rsiz) < (exec_adp[0]+(KRAM_SIZE-1024)) ){
		    read_adp[0] = rpos + rsiz ;
		    rpos %= KRAM_SIZE ;
		    __OUTPORTH(IO_KING_AR,_KRAM_PAGE);
		    __OUTPORTH(IO_KING_DR,0x0101);
		    read28((KG_kram_A|rpos),rsiz*2);
		    read_exec=1;
		}
		return;			/* ǂݏI֐烊^[ */
	    case MIX_AdR:
		rpos = read_adp[1] ;	/* ADPCM ̉E`lǂ */
		if ( (rpos+rsiz) < (exec_adp[1]+(KRAM_SIZE-1024)) ){
		    read_adp[1] = rpos + rsiz ;
		    rpos %= KRAM_SIZE ;
		    __OUTPORTH(IO_KING_AR,_KRAM_PAGE);
		    __OUTPORTH(IO_KING_DR,0x0101);
		    read28((KG_kram_B|rpos),rsiz*2);
		    read_exec=1;
		}
		return;			/* ǂݏI֐烊^[ */
	    case MIX_AnL:
		read_mixp++;		/* ǂރf[^̂Ŏɐi߂ */
		break;
	    case MIX_AnR:
		read_mixp++;		/* ǂރf[^̂Ŏɐi߂ */
		break;
	    case MIX_NUL:
	    case MIX_DCT:
		rpos = read_dct ;	/* f[^ǂݍ */
		if ( (rpos+rsiz) < (back_dct+KRAM_SIZE) ) {
		    read_dct = rpos+rsiz;
		    rpos %= KRAM_SIZE;
		    __OUTPORTH(IO_KING_AR,_KRAM_PAGE);
		    __OUTPORTH(IO_KING_DR,0x0100);
		    read28( (KG_kram_A|rpos),rsiz*2);
		    read_exec=1;
		}
		return;			/* ǂݏI֐烊^[ */
	    }
	}
    }
}

/* CD-ROM ̓批f[^ǂݍ݂ DMA ]𐧌䂵܂B
 *
 * ĐԂɂȂꍇ͉܂B
 *
 * ]҂̏Ԃ̏ꍇ DMA ]N܂B
 *
 * ǂݍݒ̏ꍇ͉܂B
 *
 * Ō܂œ]IꍇArŒfꂽꍇ͓ĐI܂B
 *
 * ́F
 * Ȃ
 *
 * óF
 * Ȃ
 */
static void	mix_read()
{
    if ( mix_play_scsi == 0 ) {		/* ĐԂł͂ȂȂ */
	return;				/* Ȃ */
    }
    switch( read28_stat.stat ) {
    case READ28_IDLE:			/* ̓]҂Ȃ */
	mix_read_int();			/* DMA ]N */
	break;
    case READ28_READ:			/* ǂݍݒȂ */
	break;				/* Ȃ */
    case READ28_END:			/* ǂݍݏIȂ */
	if ( read_exec != 0 ) {
	    read_exec = 0 ;
	    read_mixp++;
	}
	close_read28() ;		/* ǂݍݏI葱sȂ */
	mix_play_scsi=0;		/* ĐI */
	break;
    case READ28_BREAK:			/* ǂݍ݂fꂽ */
	close_read28() ;		/* ǂݍݏI葱sȂ */
    default:
	mix_stop();			/* Đ𒆎~ */
	break;
    }
}

/* 批f[^̍ĐsȂAĐJn܂B
 *
 * ́F
 * int		    id;    CD-ROMi^[Qbgj SCSI ID
 * unsigned int	    sect;  Đf[^ǂݍ݊JnubNʒu
 * unsigned int	    fram;  gp
 *
 * óF
 * int		    0      ĐJnꂽ
 *		    -1     ĐȂ
 */
int	mix_start(id,sect,fram)
int		id;
unsigned int	sect;
unsigned int	fram;
{
    static unsigned char	read_buff[MAX_MIX_HEAD][2048];
    MIX_HEAD			*mix;
    unsigned int		v;

    if ( mix_play_status == MIX_PLAY_STATUS_EXEC ) {
	return(-1);			/* ɍĐ */
    }
    cdrom_read(id,sect,read_buff[0],1);	/* Đf[^ǂݍ */
    mix = (MIX_HEAD *)read_buff[0];
    mix_play_mixp = mix ;		/* ĐJnʒuZbg */
    if ( strcmp(mix->mixs,MIX_MAGIC) != 0 && strcmp(mix->mixs,MIX_MAGIC) != 0 ) {
	return(-1);			/* Đf[^̃}[N */
    }
    if ( mix->hrec > MAX_MIX_HEAD ) {	/* Đf[^̍őubN */
	return(-1);			/* Ă̂ōĐłȂ */
    }
    if ( mix->hrec > 1 ) {		/* f[^QubNȏȂ */
	cdrom_read(id,sect+1,read_buff[1],mix->hrec-1);	/* ǂ */
    }
    if ( mix_read_start(id,sect+mix->hrec,mix->drec) != 0 ) {
	return(-1);			/* f[^̓ǂݍ݊JnɎs */
    }

    mix_play_scsi=1;			/* ϐ[N */
    mix_dct_tsr = mix_dct[mix->blck][0];
    mix_dct_len = mix_dct[mix->blck][1];
    mix_play_status = MIX_PLAY_STATUS_EXEC ;
    mix_play_vsync = 0 ;		/* ĐJnt[ԍ */

    read_adp[0] = 0 ;
    read_adp[1] = 0 ;
    exec_adp[0] = 0 ;
    exec_adp[1] = 0 ;
    read_dct = 0;
    exec_dct = 0;
    disp_dct = 0;
    back_dct = 0;
    read_exec = 0 ;
    disp_mixp = read_mixp = &(mix->data[0]) ;

    reset_adp(ADP_RESET_ALL);		/* ADPCM  */
    switch( ((mix->adpt) & 0x07) ) {	/* f[^̍Đ[gɂ */
    case 1:				/* ADPCM ̍ĐgZbg */
	adpcm.ksmode=0x0c;
	set_adp_rate(ADPCM_RATE4);
	break;
    case 2:
	adpcm.ksmode=0x08;
	set_adp_rate(ADPCM_RATE8);
	break;
    case 3:
	adpcm.ksmode=0x04;
	set_adp_rate(ADPCM_RATE16);
	break;
    default:
	adpcm.ksmode=0x00;
	set_adp_rate(ADPCM_RATE32);
	break;
    }

    if( ((mix->adpt) & 0x40) == 0 ) {	/* Pʂ̃X^̑I */
	set_nt_mode(mode_5M|inter_sync|line263);
    } else {
	set_nt_mode(mode_5M|inter_sync|line262);
    }

    set_ks_pram(&adpcm);		/* ADPCM ̃p[^̃Zbg */

    set_kr_trans(KR_TRANS_OFF);		/* HuC6271 ւ K-RAM DMA ]~ */
    v=vsync_count;			/* 荞݂Q҂ */
    while( v== vsync_count )		/* HuC6271 ̕\It҂ */
	;
    v=vsync_count;
    while( v== vsync_count )
	;
    return(0);
}

/* 批̍Đ~܂B
 *
 * ĐłȂȂ牽܂B
 *
 * ́F
 * Ȃ
 *
 * óF
 * Ȃ
 */
void	mix_stop()
{
    if ( mix_play_status != MIX_PLAY_STATUS_WAIT ) {	/* ĐĂȂ */
	if ( mix_play_scsi != 0 ) {	/* CD-ROM ǂݍݒȂ */
	    close_read28() ;		/* CD-ROM ̓ǂݍ݂~ */
	    mix_play_scsi=0;
	}
	mix_play_status = MIX_PLAY_STATUS_WAIT ;	/* ~w */
	mix_play_adpcm_stop(0);		/* ADPCM ̍`l~w */
	mix_play_adpcm_stop(1);		/* ADPCM ̉E`l~w */
	mix_play_adpcm_check();		/* ADPCM ̍Đ~ */
    }
}

/* Đǂ𒲂ׁAĐȂ\Ɠǂݍ݂sȂAĐǂ
 * Ԃ܂B
 *
 * ́F
 * Ȃ
 *
 * óF
 * int		    0      Đ
 *		    -1     ĐI
 */
int	mix_check()
{
    if ( mix_play_status == MIX_PLAY_STATUS_WAIT ) {
	return(-1);			/* ĐIĂ */
    }
    mix_disp();				/* f[^̕\ */
    mix_read();				/* f[^̓ǂݍ */
    return(0);
}
