/*
 * MIXMAIN.C Version 1.00 (C)1996 HUDSON SOFT
 * MIX ĐTvvOC(MIXMAIN.C)
 */

#include    <system.h>
#include    <sysboard.h>
#include    <sup.h>
#include    <nt.h>
#include    <king_kr.h>
#include    <soundbox.h>
#include    <scsi.h>
#include    <v93.h>

#include    "cdrscsi.h"

/* 荞݊֘ÃV{` */
#define IO_ILR0 0x0e80
#define IO_ILR1 0x0ec0

#define IO_ISR	0x0e00
#define IO_IMR	0x0e40

#define _ISR_AERR   0x80
#define _ISR_TIMR   0x40
#define _ISR_INTEX  0x20
#define _ISR_INTKP  0x10
#define _ISR_INT7A  0x08
#define _ISR_INT72  0x04
#define _ISR_INT7B  0x02
#define _ISR_INTSIO 0x01

#define _IMR_TIMR   0x40
#define _IMR_INTEX  0x20
#define _IMR_INTKP  0x10
#define _IMR_INT7A  0x08
#define _IMR_INT72  0x04
#define _IMR_INT7B  0x02
#define _IMR_INTSIO 0x01

/* HuC6270 ֘ÃV{` */
#define _7UP_STAT_CR	0x001	/* Փˌo		*/
#define _7UP_STAT_OR	0x002	/* XvCgI[o[	*/
#define _7UP_STAT_RR	0x004	/* X^o		*/
#define _7UP_STAT_DS	0x008	/* VRAM-SATB ]I	*/
#define _7UP_STAT_DV	0x010	/* VRAM-VRAM ]I	*/
#define _7UP_STAT_VD	0x020	/* AԌo	*/
#define _7UP_STAT_BSY	0x040
#define	_AR_SDMA_READ	0x003
#define	_AR_SDMA_WRITE	0x013

/* 荞݃xN^Ɗ荞݃xݒ肷ׂ̍\ */
typedef struct {
    void    (*func)();
    int	    vect;
} VECT_INIT ;

/* V-SYNC 荞݂̃JE^ */
unsigned int	vsync_count=0;

/* LEVEL F 荞ݗp֐i_~[j
 *
 * LEVEL F 荞݂ HuC6270-B p荞݊֐ irq_7upB_entry() ŏ̂
 * ̊荞݊֐͎gp܂B
 */
void interrupt	irq_err0_entry()
{
}

/* LEVEL E 荞ݗp֐i_~[j
 *
 * LEVEL E 荞݂ HuC6272 p荞݊֐ irq_king_entry() ŏ̂ł
 * ̊荞݊֐͎gp܂B
 */
void interrupt	irq_err1_entry()
{
}

/* LEVEL D 荞ݗp֐i_~[j
 *
 * LEVEL D 荞݂ HuC6270-A p荞݊֐ irq_7upA_entry() ŏ̂
 * ̊荞݊֐͎gp܂B
 */
void interrupt	irq_err2_entry()
{
}

/* LEVEL C 荞ݗp֐i_~[j
 *
 * LEVEL C 荞݂̓}XNꏈ܂񂪁AÖׁApӂ荞
 * ɓo^Ă܂B
 */
void interrupt	irq_err3_entry()
{
}

/* LEVEL B 荞ݗp֐i_~[j
 *
 * LEVEL B 荞݂̓L[pbhp荞݊֐ int_pad() ŏ̂ł̊
 * ݊֐͎gp܂B
 */
void interrupt	irq_err4_entry()
{
}

/* LEVEL A 荞ݗp֐i_~[j
 *
 * LEVEL A 荞݂̓}XNꏈ܂񂪁AÖׁApӂ荞
 * ɓo^Ă܂B
 */
void interrupt	irq_err5_entry()
{
}

/* LEVEL 9 荞ݗp֐i_~[j
 *
 * LEVEL 9 荞݂̓}XNꏈ܂񂪁AÖׁApӂ荞
 * ɓo^Ă܂B
 */
void interrupt	irq_err6_entry()
{
}

/* LEVEL 8 荞ݗp֐i_~[j
 *
 * LEVEL 8 荞݂̓}XNꏈ܂񂪁AÖׁApӂ荞
 * ɓo^Ă܂B
 */
void interrupt	irq_err7_entry()
{
}

/* LEVEL F 荞ݗp֐
 *
 * LEVEL F 荞݂ HuC6270-B ̊荞݂܂B
 *
 * ̊荞ݏł́A荞݂̃JEgARUN + SELECT ł̃Zbg
 * L[pbh̓NGXg̏sȂ܂B
 *
 * HuC6270-A,HuC6270-B,HuC6272 ̊efoCX̃AhXWX^̑ҔƕÁA
 * Ɂi̊֐ŁjΉfoCXgpȂꍇ͕Kv܂B
 *
 * eipc, eipsw ̑ҔƕA͑dȂꍇ͕Kp܂B
 * i̊֐ł͑dĂȂ̂ō폜Ă肠܂j
 */
void interrupt	irq_7upB_entry()
{
    regsave at,ra0-ra3,rg0-rg9,ut;	/* CPU WX^̑ޔBA͎ */
    unsigned int	ar_king;	/* HuC6272  AR WX^ޔp */
    unsigned int	ar_7upA;	/* HuC6270-A  AR WX^ޔp */
    unsigned int	ar_7upB;	/* HuC6270-B  AR WX^ޔp */
    unsigned int	eipc;		/* eipc WX^̑ޔp */
    unsigned int	eipsw;		/* eipsw WX^̑ޔp */
    unsigned int	st;
    static unsigned int	reset_count=0;	/* RUN + SELECT ̃Zbgp */

    ar_king = __INPORTH(IO_KING_AR);	/* HuC6272  AR WX^̑Ҕ */
    ar_7upA = __INPORTH(IO_IO_7AR_A);	/* HuC6270-A  AR WX^̑Ҕ */
    ar_7upB = __INPORTH(IO_IO_7AR_B);	/* HuC6270-B  AR WX^̑Ҕ */
    eipc    = _EIPC ;			/* eipc WX^̑Ҕ */
    eipsw   = _EIPSW ;			/* eipsw WX^̑Ҕ */

    st = __INPORTH(IO_70B_SR);		/* 荞ݗv擾 */
    if ( (st & _7UP_STAT_VD) != 0 ) {	/* 荞݂̏ꍇ */
	vsync_count++;			/* 荞݃JE^Z */
	if ( (pad00.KD_DAT & (KP_run|KP_select) ) == (KP_run|KP_select) ) {
	    reset_count++;		/* RUN + SELECT ĂȂ */
	    if ( reset_count==60 ) {	/* 60 (Pb)ꑱĂȂ */
		((void (*)())(IRQVEC_SFTRST))();	/* Zbg */
	    }
	} else {
	    reset_count=0;		/* ĂȂȂJE^NA */
	}
	get_pad();			/* L[pbh͏ */
    }
    __OUTPORTH(IO_KING_AR,ar_king);	/* HuC6272  AR WX^̕A */
    if (ar_7upA == _AR_SDMA_READ) {	/* HuC6270-A  AR WX^̕A */
	__OUTPORTH(IO_70A_AR, _AR_SDMA_WRITE);
    } else {
	__OUTPORTH(IO_70A_AR, ar_7upA);
    }
    if (ar_7upB == _AR_SDMA_READ) {	/* HuC6270-B  AR WX^̕A */
	__OUTPORTH(IO_70B_AR, _AR_SDMA_WRITE);
    } else {
	__OUTPORTH(IO_70B_AR, ar_7upB);
    }
    _EIPC  = eipc ;			/* eipc WX^̕A */
    _EIPSW = eipsw ;			/* eipsw WX^̕A */
}

/* LEVEL C 荞ݗp֐
 *
 * LEVEL C 荞݂ HuC6270-A ̊荞݂܂B
 *
 * ̊荞ݏł́Aۂɂ͉܂B
 *
 * HuC6270-A,HuC6270-B,HuC6272 ̊efoCX̃AhXWX^̑ҔƕÁA
 * Ɂi̊֐ŁjΉfoCXgpȂꍇ͕Kv܂B
 *
 * eipc, eipsw ̑ҔƕA͑dȂꍇ͕Kp܂B
 * i̊֐ł͑dĂȂ̂ō폜Ă肠܂j
 */
void interrupt	irq_7upA_entry()
{
    regsave at,ra0-ra3,rg0-rg9,ut;	/* CPU WX^̑ޔBA͎ */
    unsigned int	ar_king;	/* HuC6272  AR WX^ޔp */
    unsigned int	ar_7upA;	/* HuC6270-A  AR WX^ޔp */
    unsigned int	ar_7upB;	/* HuC6270-B  AR WX^ޔp */
    unsigned int	eipc;		/* eipc WX^̑ޔp */
    unsigned int	eipsw;		/* eipsw WX^̑ޔp */
    unsigned int	st;

    ar_king = __INPORTH(IO_KING_AR);	/* HuC6272  AR WX^̑Ҕ */
    ar_7upA = __INPORTH(IO_IO_7AR_A);	/* HuC6270-A  AR WX^̑Ҕ */
    ar_7upB = __INPORTH(IO_IO_7AR_B);	/* HuC6270-B  AR WX^̑Ҕ */
    eipc    = _EIPC ;			/* eipc WX^̑Ҕ */
    eipsw   = _EIPSW ;			/* eipsw WX^̑Ҕ */

    st = __INPORTH(IO_70A_SR);		/* 荞ݗv擾 */
    if ( (st & _7UP_STAT_VD) != 0 ) {	/* 荞݂̏ꍇ */
					/* {Ȃ炱ŏ邪 */
					/* 荞݂ HuC6270-B ̊ */
					/* ̂ŁAł͏Ȃ */
    }
    __OUTPORTH(IO_KING_AR,ar_king);	/* HuC6272  AR WX^̕A */
    if (ar_7upA == _AR_SDMA_READ) {	/* HuC6270-A  AR WX^̕A */
	__OUTPORTH(IO_70A_AR, _AR_SDMA_WRITE);
    } else {
	__OUTPORTH(IO_70A_AR, ar_7upA);
    }
    if (ar_7upB == _AR_SDMA_READ) {	/* HuC6270-B  AR WX^̕A */
	__OUTPORTH(IO_70B_AR, _AR_SDMA_WRITE);
    } else {
	__OUTPORTH(IO_70B_AR, ar_7upB);
    }
    _EIPC  = eipc ;			/* eipc WX^̕A */
    _EIPSW = eipsw ;			/* eipsw WX^̕A */
}

/* LEVEL E 荞ݗp֐
 *
 * LEVEL E 荞݂ HuC6272 ̊荞݂܂B
 *
 * ̊荞ݏł SOUND obt@荞݁AX^Ď荞݁ACD SUB-CODE
 * 荞݁ASCSI DMA I荞݁ASCSI oXZbg^oXtF[YG[荞
 * ݂܂B
 *
 * HuC6270-A,HuC6270-B,HuC6272 ̊efoCX̃AhXWX^̑ҔƕÁA
 * Ɂi̊֐ŁjΉfoCXgpȂꍇ͕Kv܂B
 *
 * ȂÅ荞݊֐ł HuC6272 ̃AhXWX^𑀍삷̂ŁAޔ
 * AKvłB
 *
 * eipc, eipsw ̑ҔƕA͑dȂꍇ͕Kp܂B
 * i̊֐ł͑dĂȂ̂ō폜Ă肠܂j
 */
void interrupt	irq_king_entry()
{
    regsave at,ra0-ra3,rg0-rg9,ut;	/* CPU WX^̑ޔBA͎ */
    unsigned int	ar_king;	/* HuC6272  AR WX^ޔp */
    unsigned int	ar_7upA;	/* HuC6270-A  AR WX^ޔp */
    unsigned int	ar_7upB;	/* HuC6270-B  AR WX^ޔp */
    unsigned int	eipc;		/* eipc WX^̑ޔp */
    unsigned int	eipsw;		/* eipsw WX^̑ޔp */
    unsigned int	st;

    ar_king = __INPORTH(IO_KING_AR);	/* HuC6272  AR WX^̑Ҕ */
    ar_7upA = __INPORTH(IO_IO_7AR_A);	/* HuC6270-A  AR WX^̑Ҕ */
    ar_7upB = __INPORTH(IO_IO_7AR_B);	/* HuC6270-B  AR WX^̑Ҕ */
    eipc    = _EIPC ;			/* eipc WX^̑Ҕ */
    eipsw   = _EIPSW ;			/* eipsw WX^̑Ҕ */

    st = __INPORTH(IO_KING_SRL) ;	/* 荞ݗv̎擾 */
    if ( st & 0x00400 ) {		/* SOUND obt@荞݂̏ꍇ */
	__OUTPORTH( IO_KING_AR, _KS_STAT ) ;
	__INPORTH( IO_KING_DR ) ;	/* 荞ݗv */
    }
    if ( st & 0x00800 ) {		/* X^Ď荞݂̏ꍇ */
					/* {Ȃ΂ŏ邪X^ */
					/* Ď荞݂gpĂȂ̂ */
					/* ł͏Ȃ */
    }
    if ( st & 0x01000 ) {		/* CD SUB-CODE 荞݂̏ꍇ */
					/* {Ȃ΂ŏ邪 CD SUB */
					/* CODE 𗘗pĂȂ̂łł */
					/* Ȃ */
    }
    if ( st & 0x02000 ) {		/* SCSI DMA I荞݂̏ꍇ */
	scsi_dma_int();			/* DMA ]̌nsȂ */
	mix_read_int();			/*  DMA N */
    }
    if ( st & 0x04000 ) {		/* SCSI oXZbg^oXtF[Y */
					/* G[荞݂̏ꍇ */
	scsi_block_int();		/* SCSI oX]̌nsȂ */
    }
    __OUTPORTH(IO_KING_AR,ar_king);	/* HuC6272  AR WX^̕A */
    if (ar_7upA == _AR_SDMA_READ) {	/* HuC6270-A  AR WX^̕A */
	__OUTPORTH(IO_70A_AR, _AR_SDMA_WRITE);
    } else {
	__OUTPORTH(IO_70A_AR, ar_7upA);
    }
    if (ar_7upB == _AR_SDMA_READ) {	/* HuC6270-B  AR WX^̕A */
	__OUTPORTH(IO_70B_AR, _AR_SDMA_WRITE);
    } else {
	__OUTPORTH(IO_70B_AR, ar_7upB);
    }
    _EIPC  = eipc ;			/* eipc WX^̕A */
    _EIPSW = eipsw ;			/* eipsw WX^̕A */
}

/* 荞݃xN^A荞݃xA荞ݗD揇ʂ̐ݒ
 *
 * 荞݃xN^A荞݃xA荞ݗD揇ʂ̐ݒsȂ܂B
 *
 * ́F
 * Ȃ
 *
 * óF
 * Ȃ
 */
void	init_vect()
{
    VECT_INIT	vect_init[]={		/* 荞ݏƃx̕\ */
	irq_7upB_entry, IRQ_LEVELF,
	irq_king_entry, IRQ_LEVELE,
	irq_7upA_entry, IRQ_LEVELC,
	irq_err3_entry, IRQ_LEVELD,
	int_pad,	IRQ_LEVELB,
	irq_err5_entry, IRQ_LEVELA,
	irq_err6_entry, IRQ_LEVEL9,
	irq_err7_entry, IRQ_LEVEL8,
    };
    int	n ;

    for ( n=0 ; n < (sizeof(vect_init)/sizeof(VECT_INIT)) ; n++ ) {
	set_irq_vector( vect_init[n].func, vect_init[n].vect );
					/* 荞݃xN^̐ݒ */
    }

    __OUTPORTH(IO_IMR,0xffff);		/* ׂĂ̊荞݂֎~ */
		    /* 6270-A  6272  6270-B  SIO */
    __OUTPORTH(IO_ILR0,(5<<9)|(6<<6)|(7<<3)|(4<<0));	/* D揇ʐݒ */
		    /*        timer  INTEX  INTKP */
    __OUTPORTH(IO_ILR1,	      (1<<6)|(2<<3)|(3<<0));	/* D揇ʐݒ */

    __OUTPORTH(IO_IMR,~(_IMR_INTKP|_IMR_INT7A|_IMR_INT72|_IMR_INT7B));
					/* gp銄荞݂̂݉ */
					/* ȍ~A荞݂܂ */
}

/* ҂
 *
 * w肵񐔂̐҂킵܂B60 w肷ƖPb҂킹ɂ
 * ܂B
 *
 * 0 w肵ꍇ́A҂킹ɕA܂̂ŒӂĉB
 *
 * ́F
 * int		    nums;    ҂킹
 *
 * óF
 * Ȃ
 */
void	vsync_wait(nums)
int	nums;
{
    unsigned int	v;

    v = vsync_count ;
    while( nums > 0 ) {
	while ( v==vsync_count )
	    ;
	v = vsync_count ;
	nums--;
    }
}

/* CvO
 *
 * e I/O foCXAĐ mix_play() Ăяo܂B
 *
 * ́F
 * Ȃ
 *
 * óF
 * Ȃ
 */
void	main()
{
    static struct ADPVOL	adpvol={
	0x3f,				/* ADPCM #1 `l */
	0,				/* ADPCM #1 E`l */
	0,				/* ADPCM #2 `l */
	0x3f,				/* ADPCM #2 E`l */
    };
    int	    n;

    init_vect();			/* 荞݃xN^̏ */
    init_nt();				/* HuC6261 ̏ */
    set_nt_mode(mode_5M|inter_sync|line263);	/* HuC6261 ̃[hݒ */
    init_rainbow();			/* HuC6271 ̏ */
    init_king();			/* HuC6272 ̏ */
    init_soundbox();			/* HuC6230 ̏ */
    init_70();				/* HuC6270 ̏ */

    init_scsi();			/* SCSI ̏ */
    init_get_pad();			/* L[pbh̏ */

    set_70_irqbit(IE_VC,DEV70B);	/* HuC6270 ̐ */
    irq_enable();			/* CPU 荞ݎ󂯕tԂ */

    set_kr_trans(KR_TRANS_OFF);		/* HuC6271 <-> HuC6272 ԓ]~ */
    dispon(rain);			/* HuC6271 \[h */

    __OUTPORTH(IO_NT_AR,_NT_CRMY);	/* N}L[ō𓧉߂ */
    __OUTPORTH(IO_NT_DR,0x0000);	/* N}L[ x */
    __OUTPORTH(IO_NT_AR,_NT_CRMU);
    __OUTPORTH(IO_NT_DR,0x8080);	/* N}L[ t */
    __OUTPORTH(IO_NT_AR,_NT_CRMV);
    __OUTPORTH(IO_NT_DR,0x8080);	/* N}L[ u */

    __OUTPORTH( IO_NT_AR, _NT_CPA);	/* SẴpbgɂ */
    __OUTPORTH( IO_NT_DR, 0 ) ;
    __OUTPORTH( IO_NT_AR, _NT_CPW);
    for(n=0;n<512;n++){
	__OUTPORTH( IO_NT_DR,0x0088);
    }
					/* k̎w() */
    __OUTPORTH(IO_RA_NRLY,0x080);	/* k x */
    __OUTPORTH(IO_RA_NRLU,0x000);	/* k t */
    __OUTPORTH(IO_RA_NRLV,0x000);	/* k u */

    reset_adp(ADP_RESET_ALL);		/* ADPCM ̃Zbg */
    set_adp_liner(SB_ADPCM_ALL,ADP_LINER_ON);	/* ADPCM ̒ԂI */
    set_adp_rate(ADPCM_RATE32);		/* ADPCM ̃Tv[g̐ݒ */
    set_adp_vol(&adpvol);		/* ADPCM ̉ʂ̐ݒ */

    mix_play();				/* ĐĂяo */
}
